local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local __TS__New = ____lualib.__TS__New
local ____exports = {}
local ____lib = require("lib.index")
local assertNever = ____lib.assertNever
local getKeySet = ____lib.getKeySet
local RegisterClass = ____lib.RegisterClass
local ____geometry = require("lib.geometry.index")
local Pos = ____geometry.Pos
local ____task = require("lib.task")
local EnumeratedItemsTask = ____task.EnumeratedItemsTask
local runEntireTask = ____task.runEntireTask
local submitTask = ____task.submitTask
local ____set_2Dtiles = require("project.set-tiles")
local setTilesAndCheckerboardForStage = ____set_2Dtiles.setTilesAndCheckerboardForStage
local ____properties_2Dobj = require("utils.properties-obj")
local getCurrentValues = ____properties_2Dobj.getCurrentValues
local ____blueprint_2Dsettings = require("blueprints.blueprint-settings")
local getDefaultBlueprintSettings = ____blueprint_2Dsettings.getDefaultBlueprintSettings
local ____take_2Dsingle_2Dblueprint = require("blueprints.take-single-blueprint")
local takeSingleBlueprint = ____take_2Dsingle_2Dblueprint.takeSingleBlueprint
local max = math.max
local PseudoPromise = __TS__Class()
PseudoPromise.name = "PseudoPromise"
function PseudoPromise.prototype.____constructor(self)
end
function PseudoPromise.prototype.set(self, value)
    assert(not self.value, "value already set")
    self.value = value
end
function PseudoPromise.prototype.get(self)
    return (assert(self.value, "value not set"))
end
local function getCurrentBpSettings(stage)
    return getCurrentValues(stage:getBlueprintSettingsView())
end
local BlueprintMethods = {}
do
    function BlueprintMethods.computeChangedEntities(projectPlan)
        local project = projectPlan.project
        local result = {}
        for i = 1, project:numStages() do
            result[i] = {}
        end
        local content = project.content
        for entity in pairs(content:iterateAllEntities()) do
            local firstStageMap = result[entity.firstStage]
            firstStageMap[entity] = true
            local diffs = entity.stageDiffs
            if diffs then
                for stage in pairs(diffs) do
                    result[stage][entity] = true
                end
            end
            local circuitConnections = entity.circuitConnections
            if circuitConnections then
                for otherEntity in pairs(circuitConnections) do
                    firstStageMap[otherEntity] = true
                end
            end
        end
        projectPlan.changedEntities:set(result)
    end
    function BlueprintMethods.computeUnitNumberFilter(projectPlan, stagePlan, stageLimit)
        local stageNumber = stagePlan.stage.stageNumber
        local minStage = max(1, stageNumber - stageLimit + 1)
        local maxStage = stageNumber
        local changedEntities = projectPlan.changedEntities:get()
        local result = {}
        for stage = minStage, maxStage do
            for entity in pairs(changedEntities[stage]) do
                do
                    local luaEntity = entity:getWorldOrPreviewEntity(stageNumber)
                    if not luaEntity then
                        goto __continue17
                    end
                    local unitNumber = luaEntity.unit_number
                    if unitNumber then
                        result[unitNumber] = true
                    end
                end
                ::__continue17::
            end
        end
        stagePlan.unitNumberFilter = result
    end
    function BlueprintMethods.computeModuleOverrides(projectPlan)
        local project = projectPlan.project
        local assemblingMachineNames = getKeySet(game.get_filtered_entity_prototypes({{filter = "type", type = "assembling-machine"}}))
        local result = {}
        for entity in pairs(project.content:iterateAllEntities()) do
            do
                local firstValue = entity.firstValue
                if firstValue.items or not (assemblingMachineNames[firstValue.name] ~= nil) then
                    goto __continue22
                end
                local firstDiffStage, newItems = entity:getFirstStageDiffForProp("items")
                if not firstDiffStage then
                    goto __continue22
                end
                for stage = entity.firstStage, firstDiffStage - 1 do
                    do
                        local worldEntity = entity:getWorldEntity(stage)
                        if not worldEntity then
                            goto __continue25
                        end
                        local un = worldEntity.unit_number
                        if not un then
                            goto __continue25
                        end
                        result[un] = newItems
                    end
                    ::__continue25::
                end
            end
            ::__continue22::
        end
        projectPlan.moduleOverrides:set(result)
    end
    BlueprintMethods.setLandfill = setTilesAndCheckerboardForStage
    function BlueprintMethods.takeStageBlueprint(stagePlan, actualStack, settings)
        local ____stagePlan_0 = stagePlan
        local stage = ____stagePlan_0.stage
        local bbox = ____stagePlan_0.bbox
        local result = takeSingleBlueprint(
            actualStack,
            settings,
            stage.surface,
            bbox,
            stagePlan.unitNumberFilter,
            false
        )
        stagePlan.result = result
        actualStack.label = stage.name:get()
        if result and settings.useModulePreloading then
            local moduleOverrides = stagePlan.projectPlan.moduleOverrides:get()
            local entities = result.entities
            local bpMapping = result.bpMapping
            for entityNumber, luaEntity in pairs(bpMapping) do
                do
                    local un = luaEntity.unit_number
                    if not un then
                        goto __continue31
                    end
                    local overrides = moduleOverrides[un]
                    if not overrides then
                        goto __continue31
                    end
                    local entity = entities[entityNumber]
                    if not entity then
                        goto __continue31
                    end
                    entity.items = overrides
                end
                ::__continue31::
            end
            actualStack.set_blueprint_entities(entities)
        end
    end
    function BlueprintMethods.setNextStageTiles(curStage, nextStage)
        if not curStage.result or not nextStage.result then
            return
        end
        local nextStageTiles = nextStage.stack.get_blueprint_tiles()
        if not nextStageTiles then
            curStage.stack.set_blueprint_tiles({})
            return
        end
        local shift = Pos.minus(curStage.result.effectivePositionOffset, nextStage.result.effectivePositionOffset)
        if not Pos.isZero(shift) then
            local x = shift.x
            local y = shift.y
            for i = 1, #nextStageTiles do
                local pos = nextStageTiles[i].position
                pos.x = pos.x + x
                pos.y = pos.y + y
            end
        end
        curStage.stack.set_blueprint_tiles(nextStageTiles)
    end
    function BlueprintMethods.finalizeBlueprintBook(bookInventory)
        for i = 1, #bookInventory do
            local bpStack = bookInventory[i]
            if not bpStack.is_blueprint_setup() then
                bpStack.clear()
            end
        end
    end
    function BlueprintMethods.exportBlueprintBookToFile(stack, fileName, player)
        local projectFileName = string.gsub(fileName, "[^%w%-%_%.]", "_")
        local filename = ("staged-builds/" .. projectFileName) .. ".txt"
        local data = stack.export_stack()
        game.write_file(filename, data, false, player.index)
    end
end
local BlueprintCreationTask = __TS__Class()
BlueprintCreationTask.name = "BlueprintCreationTask"
__TS__ClassExtends(BlueprintCreationTask, EnumeratedItemsTask)
function BlueprintCreationTask.prototype.____constructor(self, steps, inventory, title)
    EnumeratedItemsTask.prototype.____constructor(self, steps)
    self.inventory = inventory
    self.title = title
end
function BlueprintCreationTask.prototype.getTitle(self)
    return self.title
end
function BlueprintCreationTask.prototype.doTask(self, task)
    local method = BlueprintMethods[task.name]
    method(table.unpack(task.args))
end
function BlueprintCreationTask.prototype.getTitleForTask(self, task)
    repeat
        local ____switch48 = task.name
        local ____cond48 = ____switch48 == "takeStageBlueprint"
        if ____cond48 then
            do
                local stagePlan = task.args[1]
                return {
                    "bp100.gui.blueprint-book-task.take-stage-blueprint",
                    stagePlan.stage.name:get()
                }
            end
        end
        ____cond48 = ____cond48 or (____switch48 == "computeChangedEntities" or ____switch48 == "computeModuleOverrides")
        if ____cond48 then
            do
                local projectPlan = task.args[1]
                return {
                    "bp100.gui.blueprint-book-task.preparing-project",
                    projectPlan.project:displayName():get()
                }
            end
        end
        ____cond48 = ____cond48 or ____switch48 == "computeUnitNumberFilter"
        if ____cond48 then
            do
                local stagePlan = task.args[2]
                return {
                    "bp100.gui.blueprint-book-task.preparing-stage",
                    stagePlan.stage.name:get()
                }
            end
        end
        ____cond48 = ____cond48 or ____switch48 == "setLandfill"
        if ____cond48 then
            do
                local stage = task.args[1]
                return {
                    "bp100.gui.blueprint-book-task.set-landfill-tiles",
                    stage.name:get()
                }
            end
        end
        ____cond48 = ____cond48 or ____switch48 == "finalizeBlueprintBook"
        if ____cond48 then
            do
                return {"bp100.gui.blueprint-book-task.finalize-blueprint-book"}
            end
        end
        ____cond48 = ____cond48 or ____switch48 == "setNextStageTiles"
        if ____cond48 then
            do
                local curStage = task.args[1]
                return {
                    "bp100.gui.blueprint-book-task.set-next-stage-tiles",
                    curStage.stage.name:get()
                }
            end
        end
        ____cond48 = ____cond48 or ____switch48 == "exportBlueprintBookToFile"
        if ____cond48 then
            do
                return {"bp100.gui.blueprint-book-task.export-blueprint-book-to-file"}
            end
        end
        do
            assertNever(task)
        end
    until true
end
function BlueprintCreationTask.prototype.done(self)
    local ____opt_1 = self.inventory
    if ____opt_1 and ____opt_1.valid then
        self.inventory.destroy()
    end
end
function BlueprintCreationTask.prototype.cancel(self)
    self:done()
end
BlueprintCreationTask = __TS__DecorateLegacy(
    {RegisterClass("BlueprintCreationTask")},
    BlueprintCreationTask
)
local BlueprintCreationTaskBuilder = __TS__Class()
BlueprintCreationTaskBuilder.name = "BlueprintCreationTaskBuilder"
function BlueprintCreationTaskBuilder.prototype.____constructor(self)
    self.projectPlans = {}
    self.tasks = {}
end
function BlueprintCreationTaskBuilder.prototype.getPlanForProject(self, project)
    if not (self.projectPlans[project] ~= nil) then
        self.projectPlans[project] = {project = project, stagePlans = {}}
    end
    return self.projectPlans[project]
end
function BlueprintCreationTaskBuilder.prototype.addNewStagePlan(self, projectPlan, stack, stage, settings)
    local plan = {
        stack = stack,
        stage = stage,
        bbox = stage:getBlueprintBBox(),
        projectPlan = projectPlan,
        settings = settings,
        result = nil
    }
    projectPlan.stagePlans[stage.stageNumber] = plan
    return plan
end
function BlueprintCreationTaskBuilder.prototype.ensureTilesTaken(self, projectInfo, stage)
    local stagePlan = projectInfo.stagePlans[stage.stageNumber]
    if not stagePlan then
        self:addNewStagePlan(
            projectInfo,
            nil,
            stage,
            getCurrentBpSettings(stage)
        )
    end
end
function BlueprintCreationTaskBuilder.prototype.queueBlueprintTask(self, stage, stack)
    local projectPlan = self:getPlanForProject(stage.project)
    local existingStagePlan = projectPlan.stagePlans[stage.stageNumber]
    if existingStagePlan then
        if existingStagePlan.stack then
            return nil
        end
        existingStagePlan.stack = stack
    end
    local settings = existingStagePlan and existingStagePlan.settings or getCurrentBpSettings(stage)
    if settings.useNextStageTiles then
        local nextStage = stage.project:getStage(stage.stageNumber + 1)
        if nextStage then
            self:ensureTilesTaken(projectPlan, nextStage)
        end
    end
    return existingStagePlan or self:addNewStagePlan(projectPlan, stack, stage, settings)
end
function BlueprintCreationTaskBuilder.prototype.addAllBpTasks(self)
    for ____, projectPlan in pairs(self.projectPlans) do
        for ____, stagePlan in pairs(projectPlan.stagePlans) do
            self:addTakeBlueprintTasks(projectPlan, stagePlan)
        end
        self:setNextStageTiles(projectPlan.stagePlans)
    end
    return self
end
function BlueprintCreationTaskBuilder.prototype.addTask(self, task)
    local ____self_tasks_5 = self.tasks
    ____self_tasks_5[#____self_tasks_5 + 1] = task
    return self
end
function BlueprintCreationTaskBuilder.prototype.build(self, taskTitle)
    return __TS__New(BlueprintCreationTask, self.tasks, self.inventory, taskTitle)
end
function BlueprintCreationTaskBuilder.prototype.setNextStageTiles(self, stagePlans)
    for stageNumber, curStage in pairs(stagePlans) do
        do
            if curStage.settings.useNextStageTiles then
                local nextStagePlan = stagePlans[stageNumber + 1]
                if not nextStagePlan then
                    goto __continue76
                end
                local ____self_tasks_6 = self.tasks
                ____self_tasks_6[#____self_tasks_6 + 1] = {name = "setNextStageTiles", args = {curStage, nextStagePlan}}
            end
        end
        ::__continue76::
    end
end
function BlueprintCreationTaskBuilder.prototype.addTakeBlueprintTasks(self, projectPlan, stagePlan)
    local ____stagePlan_7 = stagePlan
    local stack = ____stagePlan_7.stack
    local stage = ____stagePlan_7.stage
    local settings = stagePlan.settings
    local actualStack
    if not stack then
        local ____stagePlan_8 = stagePlan
        actualStack = self:getNewTempStack()
        ____stagePlan_8.stack = actualStack
        settings = getDefaultBlueprintSettings()
    else
        actualStack = stack
    end
    if settings.autoLandfill then
        local ____self_tasks_9 = self.tasks
        ____self_tasks_9[#____self_tasks_9 + 1] = {name = "setLandfill", args = {stage}}
    end
    if settings.stageLimit ~= nil then
        self:ensureHasComputeChangedEntities(projectPlan)
        local ____self_tasks_10 = self.tasks
        ____self_tasks_10[#____self_tasks_10 + 1] = {name = "computeUnitNumberFilter", args = {projectPlan, stagePlan, settings.stageLimit}}
    end
    if settings.useModulePreloading then
        self:ensureHasComputeModuleOverrides(projectPlan)
    end
    local ____self_tasks_11 = self.tasks
    ____self_tasks_11[#____self_tasks_11 + 1] = {name = "takeStageBlueprint", args = {stagePlan, actualStack, settings}}
end
function BlueprintCreationTaskBuilder.prototype.ensureHasComputeChangedEntities(self, projectInfo)
    if not projectInfo.changedEntities then
        projectInfo.changedEntities = __TS__New(PseudoPromise)
        local ____self_tasks_12 = self.tasks
        ____self_tasks_12[#____self_tasks_12 + 1] = {name = "computeChangedEntities", args = {projectInfo}}
    end
end
function BlueprintCreationTaskBuilder.prototype.ensureHasComputeModuleOverrides(self, projectInfo)
    if not projectInfo.moduleOverrides then
        projectInfo.moduleOverrides = __TS__New(PseudoPromise)
        local ____self_tasks_13 = self.tasks
        ____self_tasks_13[#____self_tasks_13 + 1] = {name = "computeModuleOverrides", args = {projectInfo}}
    end
end
function BlueprintCreationTaskBuilder.prototype.getNewTempStack(self)
    local ____self_14, ____inventory_15 = self, "inventory"
    if ____self_14[____inventory_15] == nil then
        ____self_14[____inventory_15] = game.create_inventory(4)
    end
    local inventory = self.inventory
    local stack = inventory.find_empty_stack()
    if stack then
        stack.set_stack("blueprint")
        return stack
    end
    inventory.resize(#inventory * 2)
    stack = inventory.find_empty_stack()
    if not stack then
        error("Could not find empty stack after resizing inventory")
    end
    stack.set_stack("blueprint")
    return stack
end
function BlueprintCreationTaskBuilder.prototype.cleanup(self)
    if self.inventory and self.inventory.valid then
        self.inventory.destroy()
    end
end
function ____exports.takeStageBlueprint(stage, stack)
    local builder = __TS__New(BlueprintCreationTaskBuilder)
    local plan = builder:queueBlueprintTask(stage, stack)
    local task = builder:addAllBpTasks():build(nil)
    runEntireTask(task)
    return (plan and plan.result) ~= nil
end
local function addBlueprintBookTasks(builder, project, stack)
    stack.set_stack("blueprint-book")
    stack.label = project.name:get()
    local bookInventory = stack.get_inventory(defines.inventory.item_main)
    for ____, stage in ipairs(project:getAllStages()) do
        bookInventory.insert("blueprint")
        local bpStack = bookInventory[#bookInventory]
        builder:queueBlueprintTask(stage, bpStack)
    end
    builder:addAllBpTasks():addTask({name = "finalizeBlueprintBook", args = {bookInventory}})
end
function ____exports.submitProjectBlueprintBookTask(project, stack)
    local builder = __TS__New(BlueprintCreationTaskBuilder)
    addBlueprintBookTasks(builder, project, stack)
    submitTask(builder:build({"bp100.gui.blueprint-book-task.assembling-blueprint-book"}))
end
function ____exports.exportBlueprintBookToFile(project, player)
    local builder = __TS__New(BlueprintCreationTaskBuilder)
    local stack = builder:getNewTempStack()
    stack.set_stack("blueprint-book")
    addBlueprintBookTasks(builder, project, stack)
    local name = project.name:get()
    if name == "" then
        name = "Unnamed-build-" .. tostring(project.id)
    end
    name = (string.gsub(name, "[^%w%-%_%.]", "_"))
    name = "staged-blueprints/" .. name
    builder:addTask({name = "exportBlueprintBookToFile", args = {stack, name, player}})
    local task = builder:build({"bp100.gui.blueprint-book-task.assembling-blueprint-book"})
    submitTask(task)
    return name
end
return ____exports
