local ____lualib = require("lualib_bundle")
local __TS__ObjectKeys = ____lualib.__TS__ObjectKeys
local ____exports = {}
local ____lib = require("lib.index")
local Events = ____lib.Events
local isEmpty = ____lib.isEmpty
local ____geometry = require("lib.geometry.index")
local Pos = ____geometry.Pos
local ____take_2Dsingle_2Dblueprint = require("blueprints.take-single-blueprint")
local FirstEntityOriginalPositionTag = ____take_2Dsingle_2Dblueprint.FirstEntityOriginalPositionTag
local takeSingleBlueprint = ____take_2Dsingle_2Dblueprint.takeSingleBlueprint
local function clearOpenedItem(playerIndex)
    local data = global.players[playerIndex]
    if data and data.blueprintEditInfo then
        local inventory = data.blueprintEditInfo.blueprintInventory
        if inventory and inventory.valid then
            inventory.destroy()
        end
        data.blueprintEditInfo = nil
    end
end
local function getBasicBlueprintTakeParams(settings)
    local ____temp_2 = settings.positionOffset:get()
    local ____temp_3 = settings.snapToGrid:get()
    local ____temp_4 = settings.positionRelativeToGrid:get()
    local ____temp_5 = settings.absoluteSnapping:get()
    local ____temp_6 = settings.blacklist:get()
    local ____temp_7 = settings.replaceInfinityEntitiesWithCombinators:get()
    local ____opt_0 = settings.icons
    return {
        positionOffset = ____temp_2,
        snapToGrid = ____temp_3,
        positionRelativeToGrid = ____temp_4,
        absoluteSnapping = ____temp_5,
        stageLimit = nil,
        additionalWhitelist = nil,
        blacklist = ____temp_6,
        replaceInfinityEntitiesWithCombinators = ____temp_7,
        useModulePreloading = false,
        icons = ____opt_0 and ____opt_0:get()
    }
end
function ____exports.editInItemBlueprintSettings(player, settings, surface, bbox, bpName)
    clearOpenedItem(player.index)
    local inventory = game.create_inventory(1)
    local blueprint = inventory[1]
    local took = takeSingleBlueprint(
        blueprint,
        getBasicBlueprintTakeParams(settings),
        surface,
        bbox,
        nil,
        true
    )
    if not took then
        inventory.destroy()
        return
    end
    blueprint.label = bpName
    global.players[player.index].blueprintEditInfo = {blueprintInventory = inventory, settings = settings, editType = "blueprint-item"}
    player.opened = blueprint
    return blueprint
end
function ____exports.editBlueprintFilters(player, settings, ____type)
    clearOpenedItem(player.index)
    local inventory = game.create_inventory(1)
    local stack = inventory[1]
    stack.set_stack("bp100:blueprint-filters")
    local property = settings[____type]
    local currentFilters = property:get()
    if currentFilters then
        stack.entity_filters = __TS__ObjectKeys(currentFilters)
    end
    global.players[player.index].blueprintEditInfo = {blueprintInventory = inventory, settings = settings, editType = ____type}
    player.opened = stack
    return stack
end
local function notifyFirstEntityRemoved(playerIndex)
    local player = game.get_player(playerIndex)
    if player then
        player.create_local_flying_text({create_at_cursor = true, text = {"bp100.interaction.blueprint-first-entity-removed"}})
    end
end
local function updateBlueprintItemSettings(blueprint, settings, playerIndex)
    if settings.icons then
        local icons = blueprint.blueprint_icons
        settings.icons:set(icons and icons[1] and icons or nil)
    end
    local snapToGrid = blueprint.blueprint_snap_to_grid
    if snapToGrid == nil then
        settings.snapToGrid:set(nil)
        return
    end
    local originalPosition = blueprint.get_blueprint_entity_tag(1, FirstEntityOriginalPositionTag)
    if not originalPosition then
        return notifyFirstEntityRemoved(playerIndex)
    end
    local bpPosition = blueprint.get_blueprint_entities()[1].position
    settings.snapToGrid:set(snapToGrid)
    settings.absoluteSnapping:set(blueprint.blueprint_absolute_snapping)
    settings.positionRelativeToGrid:set(blueprint.blueprint_position_relative_to_grid)
    settings.positionOffset:set(Pos.minus(bpPosition, originalPosition))
end
local function updateBlueprintFilters(stack, property)
    local filters = stack.entity_filters
    if isEmpty(filters) then
        property:set(nil)
        return
    end
    local result = {}
    for ____, filter in pairs(filters) do
        result[filter] = true
    end
    property:set(result)
end
local function tryUpdateSettings(playerIndex, info)
    local inventory = info.blueprintInventory
    if not inventory.valid then
        return
    end
    local stack = inventory[1]
    if not stack.valid_for_read then
        return
    end
    if info.editType == "blueprint-item" then
        if not stack.is_blueprint then
            return
        end
        updateBlueprintItemSettings(stack, info.settings, playerIndex)
    elseif info.editType == "additionalWhitelist" or info.editType == "blacklist" then
        updateBlueprintFilters(stack, info.settings[info.editType])
    end
end
Events.on_gui_closed(function(e)
    local playerIndex = e.player_index
    local data = global.players[playerIndex]
    local info = data.blueprintEditInfo
    if not info then
        return
    end
    data.blueprintEditInfo = nil
    tryUpdateSettings(playerIndex, info)
    local bpInventory = info.blueprintInventory
    if bpInventory.valid then
        bpInventory.destroy()
    end
end)
return ____exports
