local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local __TS__New = ____lualib.__TS__New
local ____exports = {}
local ____util = require("util")
local oppositedirection = ____util.oppositedirection
local ____lib = require("lib.index")
local deepCompare = ____lib.deepCompare
local isEmpty = ____lib.isEmpty
local mutableShallowCopy = ____lib.mutableShallowCopy
local RegisterClass = ____lib.RegisterClass
local shallowCopy = ____lib.shallowCopy
local shiftNumberKeysDown = ____lib.shiftNumberKeysDown
local shiftNumberKeysUp = ____lib.shiftNumberKeysUp
local ____diff_2Dvalue = require("utils.diff-value")
local fromDiffValue = ____diff_2Dvalue.fromDiffValue
local getDiff = ____diff_2Dvalue.getDiff
local toDiffValue = ____diff_2Dvalue.toDiffValue
local ____circuit_2Dconnection = require("entity.circuit-connection")
local circuitConnectionEquals = ____circuit_2Dconnection.circuitConnectionEquals
local getDirectionalInfo = ____circuit_2Dconnection.getDirectionalInfo
local ____entity_2Dprototype_2Dinfo = require("entity.entity-prototype-info")
local isPreviewEntity = ____entity_2Dprototype_2Dinfo.isPreviewEntity
local isRollingStockType = ____entity_2Dprototype_2Dinfo.isRollingStockType
local OnEntityPrototypesLoaded = ____entity_2Dprototype_2Dinfo.OnEntityPrototypesLoaded
local rollingStockTypes = ____entity_2Dprototype_2Dinfo.rollingStockTypes
local ____registration = require("entity.registration")
local registerEntity = ____registration.registerEntity
local ____stage_2Ddiff = require("entity.stage-diff")
local applyDiffToEntity = ____stage_2Ddiff.applyDiffToEntity
local getDiffDiff = ____stage_2Ddiff.getDiffDiff
local getEntityDiff = ____stage_2Ddiff.getEntityDiff
local floor = math.floor
local nameToType
OnEntityPrototypesLoaded:addListener(function(info)
    nameToType = info.nameToType
end)
local MaxCableConnections = 5
function ____exports.orientationToDirection(orientation)
    if orientation == nil then
        return 0
    end
    return floor(orientation * 8 + 0.5) % 8
end
local raise_script_destroy = script.raise_script_destroy
local ProjectEntityImpl = __TS__Class()
ProjectEntityImpl.name = "ProjectEntityImpl"
function ProjectEntityImpl.prototype.____constructor(self, firstStage, firstValue, position, direction)
    self.position = position
    self.direction = direction or 0
    self.firstValue = firstValue
    self.firstStage = firstStage
    if self:isRollingStock() then
        self.lastStage = firstStage
    end
end
function ProjectEntityImpl.prototype.getPreviewDirection(self)
    if self:isRollingStock() then
        return ____exports.orientationToDirection(self.firstValue.orientation)
    end
    return self.direction
end
function ProjectEntityImpl.prototype.setPositionUnchecked(self, position)
    self.position = position
end
function ProjectEntityImpl.prototype.isRollingStock(self)
    return isRollingStockType(self.firstValue.name)
end
function ProjectEntityImpl.prototype.isUndergroundBelt(self)
    return nameToType[self.firstValue.name] == "underground-belt"
end
function ProjectEntityImpl.prototype.isInserter(self)
    return nameToType[self.firstValue.name] == "inserter"
end
function ProjectEntityImpl.prototype.isInStage(self, stage)
    return stage >= self.firstStage and not self:isPastLastStage(stage)
end
function ProjectEntityImpl.prototype.isPastLastStage(self, stage)
    return self.lastStage ~= nil and stage > self.lastStage
end
function ProjectEntityImpl.prototype.hasErrorAt(self, stage)
    if not self:isInStage(stage) then
        return false
    end
    local worldEntity = self:getWorldEntity(stage)
    return worldEntity == nil or worldEntity.type == "underground-belt" and worldEntity.belt_to_ground_type ~= self.firstValue.type
end
function ProjectEntityImpl.prototype.canAddCableConnection(self)
    local cableConnections = self.cableConnections
    return cableConnections == nil or table_size(cableConnections) < MaxCableConnections
end
function ProjectEntityImpl.prototype.tryAddOneWayCableConnection(self, entity)
    if self == entity or not self:canAddCableConnection() then
        return false
    end
    local ____self_0, ____cableConnections_1 = self, "cableConnections"
    if ____self_0[____cableConnections_1] == nil then
        ____self_0[____cableConnections_1] = {}
    end
    self.cableConnections[entity] = true
    return true
end
function ProjectEntityImpl.prototype.tryAddDualCableConnection(self, entity)
    if self == entity then
        return "Error"
    end
    if not (self:canAddCableConnection() and entity:canAddCableConnection()) then
        return "MaxConnectionsReached"
    end
    local ____self_3, ____cableConnections_4 = self, "cableConnections"
    if ____self_3[____cableConnections_4] == nil then
        ____self_3[____cableConnections_4] = {}
    end
    self.cableConnections[entity] = true
    local ____entity_6, ____cableConnections_7 = entity, "cableConnections"
    if ____entity_6[____cableConnections_7] == nil then
        ____entity_6[____cableConnections_7] = {}
    end
    entity.cableConnections[self] = true
    return "Added"
end
function ProjectEntityImpl.prototype.removeOneWayCableConnection(self, entity)
    local connections = self.cableConnections
    if not connections then
        return
    end
    connections[entity] = nil
    if next(connections) == nil then
        self.cableConnections = nil
    end
end
function ProjectEntityImpl.prototype.removeDualCableConnection(self, entity)
    self:removeOneWayCableConnection(entity)
    entity:removeOneWayCableConnection(self)
end
function ProjectEntityImpl.prototype.addOneWayCircuitConnection(self, connection)
    local toEntity = getDirectionalInfo(connection, self)
    local connections = self.circuitConnections
    if connections then
        local existingConnections = connections[toEntity]
        if existingConnections then
            for existingConnection in pairs(existingConnections) do
                if circuitConnectionEquals(existingConnection, connection) then
                    return false
                end
            end
        end
    end
    if connections == nil then
        local ____temp_9 = {}
        self.circuitConnections = ____temp_9
        connections = ____temp_9
    end
    local existingConnections = connections[toEntity]
    if existingConnections then
        existingConnections[connection] = true
    else
        connections[toEntity] = {[connection] = true}
    end
    return true
end
function ProjectEntityImpl.prototype.removeOneWayCircuitConnection(self, connection)
    local toEntity = getDirectionalInfo(connection, self)
    local connections = self.circuitConnections
    if not connections then
        return
    end
    local existingConnections = connections[toEntity]
    if not existingConnections then
        return
    end
    existingConnections[connection] = nil
    if next(existingConnections) == nil then
        connections[toEntity] = nil
        if next(connections) == nil then
            self.circuitConnections = nil
        end
    end
end
function ProjectEntityImpl.prototype.addOrPruneIngoingConnections(self, existing)
    local cableConnections = self.cableConnections
    if cableConnections then
        for otherEntity in pairs(cableConnections) do
            if not (existing[otherEntity] ~= nil) then
                cableConnections[otherEntity] = nil
            else
                otherEntity:tryAddOneWayCableConnection(self)
            end
        end
        if next(cableConnections) == nil then
            self.cableConnections = nil
        end
    end
    local circuitConnections = self.circuitConnections
    if circuitConnections then
        for otherEntity, connections in pairs(circuitConnections) do
            if not (existing[otherEntity] ~= nil) then
                circuitConnections[otherEntity] = nil
            else
                for connection in pairs(connections) do
                    otherEntity:addOneWayCircuitConnection(connection)
                end
            end
        end
        if next(circuitConnections) == nil then
            self.circuitConnections = nil
        end
    end
end
function ProjectEntityImpl.prototype.removeIngoingConnections(self)
    local cableConnections = self.cableConnections
    if cableConnections then
        for otherEntity in pairs(cableConnections) do
            otherEntity:removeOneWayCableConnection(self)
        end
    end
    local circuitConnections = self.circuitConnections
    if circuitConnections then
        for otherEntity, connections in pairs(circuitConnections) do
            for connection in pairs(connections) do
                otherEntity:removeOneWayCircuitConnection(connection)
            end
        end
    end
end
function ProjectEntityImpl.prototype.setTypeProperty(self, direction)
    self.firstValue.type = direction
end
function ProjectEntityImpl.prototype.setDropPosition(self, position)
    self.firstValue.drop_position = position
end
function ProjectEntityImpl.prototype.setPickupPosition(self, position)
    self.firstValue.pickup_position = position
end
function ProjectEntityImpl.prototype.hasStageDiff(self, stage)
    local stageDiffs = self.stageDiffs
    if not stageDiffs then
        return false
    end
    if stage then
        return stageDiffs[stage] ~= nil
    end
    return (next(stageDiffs)) ~= nil
end
function ProjectEntityImpl.prototype.getStageDiff(self, stage)
    local stageDiffs = self.stageDiffs
    return stageDiffs and stageDiffs[stage]
end
function ProjectEntityImpl.prototype.setStageDiffs(self, stageDiffs)
    self.stageDiffs = stageDiffs
end
function ProjectEntityImpl.prototype.setFirstValue(self, value)
    self.firstValue = value
end
function ProjectEntityImpl.prototype.getStageDiffProp(self, stage, prop)
    local stageDiffs = self.stageDiffs
    if not stageDiffs then
        return false
    end
    local stageDiff = stageDiffs[stage]
    if not stageDiff then
        return false
    end
    local val = stageDiff[prop]
    if val == nil then
        return false
    end
    return true, fromDiffValue(val)
end
function ProjectEntityImpl.prototype.getFirstStageDiffForProp(self, prop)
    local stageDiffs = self.stageDiffs
    if stageDiffs then
        for stage, diff in pairs(stageDiffs) do
            local value = diff[prop]
            if value ~= nil then
                return stage, fromDiffValue(value)
            end
        end
    end
    return
end
function ProjectEntityImpl.prototype._applyDiffAtStage(self, stage, _diff)
    assert(self:isInStage(stage))
    local diff = _diff
    local stageDiffs = self.stageDiffs
    local firstStage = self.firstStage
    assert(stage >= firstStage, "stage must be >= first stage")
    if stage == firstStage then
        applyDiffToEntity(self.firstValue, diff)
        return
    end
    local existingDiff = stageDiffs and stageDiffs[stage]
    if existingDiff then
        for key, value in pairs(diff) do
            existingDiff[key] = value
        end
    else
        if stageDiffs == nil then
            local ____temp_10 = {}
            self.stageDiffs = ____temp_10
            stageDiffs = ____temp_10
        end
        stageDiffs[stage] = shallowCopy(diff)
    end
end
function ProjectEntityImpl.prototype.nextStageWithDiff(self, stage)
    if stage < self.firstStage then
        return nil
    end
    local stageDiffs = self.stageDiffs
    if not stageDiffs then
        return nil
    end
    for curStage in pairs(stageDiffs) do
        if curStage > stage then
            return curStage
        end
    end
    return nil
end
function ProjectEntityImpl.prototype.prevStageWithDiff(self, stage)
    if stage <= self.firstStage then
        return nil
    end
    local stageDiffs = self.stageDiffs
    if not stageDiffs then
        return nil
    end
    local result
    for curStage in pairs(stageDiffs) do
        if curStage >= stage then
            break
        end
        result = curStage
    end
    return result
end
function ProjectEntityImpl.prototype.getValueAtStage(self, stage)
    if not self:isInStage(stage) then
        return nil
    end
    local firstStage = self.firstStage
    if stage < firstStage then
        return nil
    end
    local stageDiffs = self.stageDiffs
    if not stageDiffs then
        return self.firstValue
    end
    local value = mutableShallowCopy(self.firstValue)
    for changedStage, diff in pairs(stageDiffs) do
        if changedStage > stage then
            break
        end
        applyDiffToEntity(value, diff)
    end
    return value
end
function ProjectEntityImpl.prototype.getPropAtStage(self, stage, prop)
    local value = self.firstValue[prop]
    local resultStage = self.firstStage
    local stageDiffs = self.stageDiffs
    if stage <= resultStage or not stageDiffs then
        return value, resultStage
    end
    for changedStage, diff in pairs(stageDiffs) do
        if changedStage > stage then
            break
        end
        local propDiff = diff[prop]
        if propDiff ~= nil then
            resultStage = changedStage
            value = fromDiffValue(propDiff)
        end
    end
    return value, resultStage
end
function ProjectEntityImpl.prototype.getNameAtStage(self, stage)
    return (self:getPropAtStage(stage, "name"))
end
function ProjectEntityImpl.prototype.iterateValues(self, start, ____end)
    local stageDiffs = self.stageDiffs
    if not stageDiffs then
        return self:iterateValuesNoDiffs(start, ____end)
    end
    local firstStage = self.firstStage
    local firstValue = self.firstValue
    local lastStage = self.lastStage or ____end
    local value = self:getValueAtStage(start - 1)
    local function iterNext(stageDiffs, prevStage)
        local nextStage = prevStage + 1
        if nextStage > ____end then
            return
        end
        if nextStage < firstStage or nextStage > lastStage then
            return nextStage, nil, false
        end
        if nextStage == firstStage then
            value = shallowCopy(firstValue)
            return nextStage, value, true
        end
        local diff = stageDiffs and stageDiffs[nextStage]
        if diff then
            applyDiffToEntity(value, diff)
        end
        return nextStage, value, diff ~= nil or nextStage == start
    end
    return iterNext, stageDiffs, start - 1
end
function ProjectEntityImpl.prototype.iterateValuesNoDiffs(self, start, ____end)
    local firstStage = self.firstStage
    local firstValue = self.firstValue
    local lastStage = self.lastStage or ____end
    local function next(_, prevStage)
        local stage = prevStage + 1
        if stage > ____end then
            return
        end
        if stage < firstStage or stage > lastStage then
            return stage, nil, false
        end
        return stage, firstValue, stage == firstStage or stage == start
    end
    return next, nil, start - 1
end
function ProjectEntityImpl.prototype.adjustValueAtStage(self, stage, value)
    local firstStage = self.firstStage
    assert(stage >= firstStage, "stage must be >= first stage")
    if self:isRollingStock() then
        return self:adjustValueRollingStock(stage, value)
    end
    if stage == self.firstStage then
        return self:setValueAtFirstStage(value)
    end
    local valueAtPreviousStage = assert(self:getValueAtStage(stage - 1))
    local newStageDiff = getEntityDiff(valueAtPreviousStage, value)
    return self:setDiffInternal(stage, newStageDiff, valueAtPreviousStage)
end
function ProjectEntityImpl.prototype.adjustValueRollingStock(self, stage, value)
    local canAdjust = stage == self.firstStage
    if not canAdjust then
        return false
    end
    local diff = getEntityDiff(self.firstValue, value)
    if not diff then
        return false
    end
    diff.orientation = nil
    if isEmpty(diff) then
        return false
    end
    applyDiffToEntity(self.firstValue, diff)
    return true
end
function ProjectEntityImpl.prototype.setValueAtFirstStage(self, value)
    local firstValue = self.firstValue
    local diff = getEntityDiff(firstValue, value)
    if not diff then
        return false
    end
    applyDiffToEntity(firstValue, diff)
    self:trimDiffs(self.firstStage, diff)
    return true
end
function ProjectEntityImpl.prototype.setDiffInternal(self, stage, newStageDiff, valueAtPreviousStage)
    local stageDiffs = self.stageDiffs
    local oldStageDiff = self:getStageDiff(stage)
    if newStageDiff then
        if stageDiffs == nil then
            local ____temp_11 = {}
            self.stageDiffs = ____temp_11
            stageDiffs = ____temp_11
        end
        stageDiffs[stage] = newStageDiff
    elseif stageDiffs then
        stageDiffs[stage] = nil
    end
    local diff = getDiffDiff(valueAtPreviousStage, oldStageDiff, newStageDiff)
    if not diff then
        return false
    end
    self:trimDiffs(stage, diff)
    return true
end
function ProjectEntityImpl.prototype.setPropAtStage(self, stage, prop, value)
    local firstStage = self.firstStage
    assert(stage >= firstStage, "stage must be >= first stage")
    if self:isRollingStock() then
        return false
    end
    local propAtPreviousStage = self:getPropAtStage(stage - 1, prop)
    return self:setPropAtStageInternal(stage, prop, value, propAtPreviousStage)
end
function ProjectEntityImpl.prototype.setPropAtStageInternal(self, stage, prop, newValue, propAtPreviousStage)
    local oldValue = propAtPreviousStage
    local hasDiff, curStageValue = self:getStageDiffProp(stage, prop)
    if hasDiff then
        oldValue = curStageValue
    end
    if deepCompare(oldValue, newValue) then
        return false
    end
    local newDiffValue = getDiff(propAtPreviousStage, newValue)
    if stage == self.firstStage then
        self.firstValue[prop] = newValue
    else
        local stageDiffs = self.stageDiffs
        if newDiffValue ~= nil then
            if stageDiffs == nil then
                local ____temp_12 = {}
                self.stageDiffs = ____temp_12
                stageDiffs = ____temp_12
            end
            local ____stageDiffs_stage_14 = stageDiffs[stage]
            if ____stageDiffs_stage_14 == nil then
                local ____temp_13 = {}
                stageDiffs[stage] = ____temp_13
                ____stageDiffs_stage_14 = ____temp_13
            end
            local stageDiff = ____stageDiffs_stage_14
            stageDiff[prop] = newDiffValue
        elseif stageDiffs then
            local ____opt_15 = stageDiffs[stage]
            if ____opt_15 ~= nil then
                ____opt_15[prop] = nil
            end
            local ____ = true
        end
    end
    self:trimDiffs(
        stage,
        {[prop] = toDiffValue(newValue)}
    )
    return true
end
function ProjectEntityImpl.prototype.applyUpgradeAtStage(self, stage, newName)
    return self:setPropAtStage(stage, "name", newName)
end
function ProjectEntityImpl.prototype.trimDiffs(self, stage, diff)
    local stageDiffs = self.stageDiffs
    if not stageDiffs then
        return
    end
    local oldDiff = stageDiffs[stage]
    if oldDiff and isEmpty(oldDiff) then
        stageDiffs[stage] = nil
    end
    for stageNumber, changes in pairs(stageDiffs) do
        do
            if stageNumber <= stage then
                goto __continue143
            end
            for k, v in pairs(diff) do
                if deepCompare(changes[k], v) then
                    changes[k] = nil
                else
                    diff[k] = nil
                end
            end
            if isEmpty(changes) then
                stageDiffs[stageNumber] = nil
            end
            if isEmpty(diff) then
                break
            end
        end
        ::__continue143::
    end
    if isEmpty(stageDiffs) then
        self.stageDiffs = nil
    end
end
function ProjectEntityImpl.prototype.resetValue(self, stage)
    if stage <= self.firstStage then
        return false
    end
    return self:setDiffInternal(
        stage,
        nil,
        self:getValueAtStage(stage - 1)
    )
end
function ProjectEntityImpl.prototype.resetProp(self, stage, prop)
    if stage <= self.firstStage then
        return false
    end
    local value = self:getPropAtStage(stage - 1, prop)
    return self:setPropAtStageInternal(stage, prop, value, value)
end
function ProjectEntityImpl.prototype.movePropDown(self, stage, prop)
    local hasDiff, curStageValue = self:getStageDiffProp(stage, prop)
    if not hasDiff then
        return nil
    end
    local stageToApply = self:prevStageWithDiff(stage) or self.firstStage
    if self:setPropAtStage(stageToApply, prop, curStageValue) then
        return stageToApply
    end
    return nil
end
function ProjectEntityImpl.prototype.moveValueDown(self, stage)
    if not self:hasStageDiff(stage) then
        return nil
    end
    local stageToApply = self:prevStageWithDiff(stage) or self.firstStage
    if self:adjustValueAtStage(
        stageToApply,
        self:getValueAtStage(stage)
    ) then
        return stageToApply
    end
    return nil
end
function ProjectEntityImpl.prototype.setFirstStageUnchecked(self, stage)
    local firstStage = self.firstStage
    local lastStage = self.lastStage
    if lastStage then
        assert(stage <= lastStage, "stage must be <= last stage")
    end
    if stage > firstStage then
        self:moveFirstStageUp(stage)
    end
    self.firstStage = stage
end
function ProjectEntityImpl.prototype.moveFirstStageUp(self, newFirstStage)
    local stageDiffs = self.stageDiffs
    if stageDiffs then
        local firstValue = self.firstValue
        for stage, diff in pairs(stageDiffs) do
            if stage > newFirstStage then
                break
            end
            applyDiffToEntity(firstValue, diff)
            stageDiffs[stage] = nil
        end
        if isEmpty(stageDiffs) then
            self.stageDiffs = nil
        end
    end
end
function ProjectEntityImpl.prototype.setLastStageUnchecked(self, stage)
    assert(not stage or stage >= self.firstStage, "stage must be >= first stage")
    local lastStage = self.lastStage
    if stage and (lastStage == nil or stage < lastStage) then
        self:moveLastStageDown(stage)
    end
    self.lastStage = stage
end
function ProjectEntityImpl.prototype.moveLastStageDown(self, stage)
    local stageDiffs = self.stageDiffs
    if stageDiffs and (self.lastStage == nil or stage < self.lastStage) then
        for stageNumber in pairs(stageDiffs) do
            if stageNumber > stage then
                stageDiffs[stageNumber] = nil
            end
        end
        if isEmpty(stageDiffs) then
            self.stageDiffs = nil
        end
    end
end
function ProjectEntityImpl.prototype.getWorldOrPreviewEntity(self, stage)
    local entity = self[stage]
    if entity then
        if entity.valid then
            return entity
        end
        self[stage] = nil
    end
end
function ProjectEntityImpl.prototype.getWorldEntity(self, stage)
    local entity = self:getWorldOrPreviewEntity(stage)
    if entity and not isPreviewEntity(entity) then
        return entity
    end
end
function ProjectEntityImpl.prototype.replaceWorldEntity(self, stage, entity)
    self:replaceWorldOrPreviewEntity(stage, entity)
end
function ProjectEntityImpl.prototype.replaceWorldOrPreviewEntity(self, stage, entity)
    local existing = self[stage]
    if existing and existing.valid and existing ~= entity then
        raise_script_destroy({entity = existing})
        existing.destroy()
    end
    self[stage] = entity
    if entity and rollingStockTypes[entity.type] ~= nil then
        registerEntity(entity, self)
    end
end
function ProjectEntityImpl.prototype.destroyWorldOrPreviewEntity(self, stage)
    local existing = self[stage]
    if existing and existing.valid then
        raise_script_destroy({entity = existing})
        existing.destroy()
        self[stage] = nil
    end
end
function ProjectEntityImpl.prototype.destroyAllWorldOrPreviewEntities(self)
    for k, v in pairs(self) do
        if type(k) ~= "number" then
            break
        end
        if v.valid then
            raise_script_destroy({entity = v})
            v.destroy()
        end
        self[k] = nil
    end
end
function ProjectEntityImpl.prototype.hasWorldEntityInRange(self, start, ____end)
    for i = start, ____end do
        local entity = self[i]
        if entity and entity.valid then
            if not isPreviewEntity(entity) then
                return true
            end
        else
            self[i] = nil
        end
    end
    return false
end
function ProjectEntityImpl.prototype.getExtraEntity(self, ____type, stage)
    local stageProperties = self.stageProperties
    if not stageProperties then
        return nil
    end
    local byType = stageProperties[____type]
    if not byType then
        return nil
    end
    local worldEntity = byType[stage]
    if worldEntity and worldEntity.valid then
        return worldEntity
    end
    byType[stage] = nil
    if isEmpty(byType) then
        stageProperties[____type] = nil
    end
end
function ProjectEntityImpl.prototype.replaceExtraEntity(self, ____type, stage, entity)
    if entity == nil then
        return self:destroyExtraEntity(____type, stage)
    end
    local ____self_stageProperties_18 = self.stageProperties
    if ____self_stageProperties_18 == nil then
        local ____temp_17 = {}
        self.stageProperties = ____temp_17
        ____self_stageProperties_18 = ____temp_17
    end
    local stageProperties = ____self_stageProperties_18
    local ____stageProperties_____type_20 = stageProperties[____type]
    if ____stageProperties_____type_20 == nil then
        local ____temp_19 = {}
        stageProperties[____type] = ____temp_19
        ____stageProperties_____type_20 = ____temp_19
    end
    local byType = ____stageProperties_____type_20
    local existing = byType[stage]
    if existing and existing.valid and existing ~= entity then
        existing.destroy()
    end
    byType[stage] = entity
end
function ProjectEntityImpl.prototype.destroyExtraEntity(self, ____type, stage)
    local stageProperties = self.stageProperties
    if not stageProperties then
        return
    end
    local byType = stageProperties[____type]
    if not byType then
        return
    end
    local entity = byType[stage]
    if entity and entity.valid then
        entity.destroy()
    end
    if not entity or not entity.valid then
        byType[stage] = nil
        if isEmpty(byType) then
            stageProperties[____type] = nil
            if isEmpty(stageProperties) then
                self.stageProperties = nil
            end
        end
    end
end
function ProjectEntityImpl.prototype.destroyAllExtraEntities(self, ____type)
    local stageProperties = self.stageProperties
    if not stageProperties then
        return
    end
    local byType = stageProperties[____type]
    if not byType then
        return
    end
    for ____, entity in pairs(byType) do
        if entity and entity.valid then
            entity.destroy()
        end
    end
    stageProperties[____type] = nil
    if isEmpty(stageProperties) then
        self.stageProperties = nil
    end
end
function ProjectEntityImpl.prototype.hasAnyExtraEntities(self, ____type)
    local stageProperties = self.stageProperties
    return stageProperties ~= nil and stageProperties[____type] ~= nil
end
function ProjectEntityImpl.prototype.iterateWorldOrPreviewEntities(self)
    local lastKey = nil
    return function()
        while true do
            local nextKey = (next(self, lastKey))
            if type(nextKey) ~= "number" then
                return nil
            end
            lastKey = nextKey
            local entity = self[nextKey]
            if entity and entity.valid then
                return nextKey, entity
            end
            self[nextKey] = nil
        end
    end
end
function ProjectEntityImpl.prototype.setProperty(self, key, stage, value)
    local ____self_stageProperties_22 = self.stageProperties
    if ____self_stageProperties_22 == nil then
        local ____temp_21 = {}
        self.stageProperties = ____temp_21
        ____self_stageProperties_22 = ____temp_21
    end
    local stageProperties = ____self_stageProperties_22
    local ____stageProperties_key_24 = stageProperties[key]
    if not ____stageProperties_key_24 then
        local ____temp_23 = {}
        stageProperties[key] = ____temp_23
        ____stageProperties_key_24 = ____temp_23
    end
    local byType = ____stageProperties_key_24
    byType[stage] = value
    if isEmpty(byType) then
        stageProperties[key] = nil
    end
end
function ProjectEntityImpl.prototype.getProperty(self, key, stage)
    local stageProperties = self.stageProperties
    if not stageProperties then
        return nil
    end
    local byType = stageProperties[key]
    return byType and byType[stage]
end
function ProjectEntityImpl.prototype.propertySetInAnyStage(self, key)
    local stageProperties = self.stageProperties
    return stageProperties ~= nil and stageProperties[key] ~= nil
end
function ProjectEntityImpl.prototype.clearPropertyInAllStages(self, key)
    local stageProperties = self.stageProperties
    if not stageProperties then
        return
    end
    stageProperties[key] = nil
end
function ProjectEntityImpl.prototype.insertStage(self, stageNumber)
    if self.firstStage >= stageNumber then
        self.firstStage = self.firstStage + 1
    end
    if self.lastStage and self.lastStage >= stageNumber then
        self.lastStage = self.lastStage + 1
    end
    shiftNumberKeysUp(self, stageNumber)
    if self.stageDiffs then
        shiftNumberKeysUp(self.stageDiffs, stageNumber)
    end
    local stageProperties = self.stageProperties
    if stageProperties then
        for ____, byType in pairs(stageProperties) do
            shiftNumberKeysUp(byType, stageNumber)
        end
    end
end
function ProjectEntityImpl.prototype.deleteStage(self, stageNumber)
    local stageToMerge = stageNumber == 1 and 2 or stageNumber
    self:mergeStageDiffWithBelow(stageToMerge)
    if self.firstStage >= stageToMerge then
        self.firstStage = self.firstStage - 1
    end
    if self.lastStage and self.lastStage >= stageNumber then
        self.lastStage = self.lastStage - 1
    end
    shiftNumberKeysDown(self, stageNumber)
    if self.stageDiffs then
        shiftNumberKeysDown(self.stageDiffs, stageNumber)
    end
    local stageProperties = self.stageProperties
    if stageProperties then
        for ____, byType in pairs(stageProperties) do
            shiftNumberKeysDown(byType, stageNumber)
        end
    end
end
function ProjectEntityImpl.prototype.mergeStageDiffWithBelow(self, stage)
    if stage <= self.firstStage then
        return
    end
    if not self:hasStageDiff(stage) then
        return
    end
    self:adjustValueAtStage(
        stage - 1,
        self:getValueAtStage(stage)
    )
end
ProjectEntityImpl = __TS__DecorateLegacy(
    {RegisterClass("AssemblyEntity")},
    ProjectEntityImpl
)
function ____exports.addCircuitConnection(connection)
    local ____connection_25 = connection
    local fromEntity = ____connection_25.fromEntity
    local toEntity = ____connection_25.toEntity
    fromEntity:addOneWayCircuitConnection(connection)
    toEntity:addOneWayCircuitConnection(connection)
end
function ____exports.removeCircuitConnection(connection)
    local ____connection_26 = connection
    local fromEntity = ____connection_26.fromEntity
    local toEntity = ____connection_26.toEntity
    fromEntity:removeOneWayCircuitConnection(connection)
    toEntity:removeOneWayCircuitConnection(connection)
end
--- nil direction means the default direction of north
function ____exports.createProjectEntityNoCopy(entity, position, direction, stageNumber)
    return __TS__New(
        ProjectEntityImpl,
        stageNumber,
        entity,
        position,
        direction
    )
end
local excludedTypes = {unit = true, car = true, ["spider-vehicle"] = true, ["entity-ghost"] = true}
function ____exports.isWorldEntityProjectEntity(luaEntity)
    return luaEntity.valid and luaEntity.is_entity_with_owner and luaEntity.has_flag("player-creation") and not excludedTypes[luaEntity.type]
end
--- Gets the stage number this would merge with if this stage were to be deleted.
function ____exports.getStageToMerge(stageNumber)
    if stageNumber == 1 then
        return 2
    end
    return stageNumber - 1
end
function ____exports._migrateEntity_0_17_0(entity)
    if entity:isUndergroundBelt() and entity.firstValue.type == "output" then
        entity.direction = oppositedirection(entity.direction)
    end
end
return ____exports
