--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local entityHasSettings, createItems
local ____lib = require("lib.index")
local Events = ____lib.Events
local mutableShallowCopy = ____lib.mutableShallowCopy
local ____geometry = require("lib.geometry.index")
local BBox = ____geometry.BBox
local Pos = ____geometry.Pos
local ____migration = require("lib.migration")
local Migrations = ____migration.Migrations
local ____stage_2Dsurface = require("project.stage-surface")
local getStageAtSurface = ____stage_2Dsurface.getStageAtSurface
local ____entity_2Dprototype_2Dinfo = require("entity.entity-prototype-info")
local getPrototypeRotationType = ____entity_2Dprototype_2Dinfo.getPrototypeRotationType
local OnEntityPrototypesLoaded = ____entity_2Dprototype_2Dinfo.OnEntityPrototypesLoaded
local rollingStockTypes = ____entity_2Dprototype_2Dinfo.rollingStockTypes
local ____underground_2Dbelt = require("entity.underground-belt")
local getUndergroundDirection = ____underground_2Dbelt.getUndergroundDirection
function entityHasSettings(entity)
    for key in pairs(entity) do
        if key ~= "name" and key ~= "items" and key ~= "type" then
            return true
        end
    end
    return false
end
function createItems(luaEntity, items)
    local insertTarget = luaEntity.get_module_inventory() or luaEntity
    for name, count in pairs(items) do
        insertTarget.insert({name = name, count = count})
    end
end
function ____exports.forceFlipUnderground(luaEntity)
    local wasRotatable = luaEntity.rotatable
    luaEntity.rotatable = true
    local rotated = luaEntity.rotate()
    luaEntity.rotatable = wasRotatable
    return rotated
end
local build_check_ghost_revive = defines.build_check_type.ghost_revive
local build_check_manual = defines.build_check_type.manual
local floor = math.floor
Events.on_init(function()
    global.tempBPInventory = game.create_inventory(1)
end)
local bpStack
Migrations.since(
    "0.17.0",
    function()
        bpStack = global.tempBPInventory[1]
        bpStack.set_stack("blueprint")
    end
)
Events.on_load(function()
    bpStack = global.tempBPInventory[1]
end)
function ____exports.getTempBpItemStack()
    return bpStack
end
local function findEntityIndex(mapping, entity)
    for index, mEntity in pairs(mapping) do
        if entity == mEntity then
            return index
        end
    end
end
local function blueprintEntity(entity)
    local ____entity_0 = entity
    local surface = ____entity_0.surface
    local position = ____entity_0.position
    for ____, radius in ipairs({0.01, 1}) do
        local indexMapping = bpStack.create_blueprint({
            surface = surface,
            force = entity.force_index,
            area = BBox.around(position, radius),
            include_station_names = true,
            include_trains = true,
            include_fuel = true
        })
        local matchingIndex = findEntityIndex(indexMapping, entity)
        if matchingIndex then
            return bpStack.get_blueprint_entities()[matchingIndex]
        end
    end
end
local function setBlueprintEntity(stack, entity, position, direction)
    entity.position = position
    entity.direction = direction
    entity.entity_number = 1
    stack.set_blueprint_entities({entity})
    entity.position = nil
    entity.direction = nil
    entity.entity_number = nil
end
local entityVersion = 1
local pasteEntityVersion = 0
local function pasteEntity(surface, position, direction, entity)
    local tilePosition = {
        x = floor(position.x),
        y = floor(position.y)
    }
    if pasteEntityVersion ~= entityVersion then
        pasteEntityVersion = entityVersion
        local offsetPosition = Pos.minus(position, tilePosition)
        setBlueprintEntity(bpStack, entity, offsetPosition, direction)
        bpStack.blueprint_snap_to_grid = {1, 1}
        bpStack.blueprint_absolute_snapping = true
    end
    local ghosts = bpStack.build_blueprint({surface = surface, force = "player", position = tilePosition})
    return ghosts[1]
end
local function removeIntersectingItemsOnGround(surface, area)
    local items = surface.find_entities_filtered({type = "item-entity", area = area})
    for ____, item in ipairs(items) do
        item.destroy()
    end
end
local tryCreateEntityParams = {
    name = "",
    position = nil,
    direction = nil,
    orientation = nil,
    type = nil,
    force = "player",
    create_build_effect_smoke = false,
    build_check_type = build_check_ghost_revive
}
local tryCreateVersion = 0
local function tryCreateUnconfiguredEntity(surface, position, direction, entity)
    if tryCreateVersion ~= entityVersion then
        tryCreateVersion = entityVersion
        local orientation = entity.orientation
        if orientation then
            direction = nil
        end
        tryCreateEntityParams.name = entity.name
        tryCreateEntityParams.position = position
        tryCreateEntityParams.direction = direction
        tryCreateEntityParams.orientation = orientation
        tryCreateEntityParams.type = entity.type
    end
    tryCreateEntityParams.build_check_type = build_check_ghost_revive
    local canPlaceEntity = surface.can_place_entity
    if canPlaceEntity(tryCreateEntityParams) then
        return surface.create_entity(tryCreateEntityParams)
    end
    tryCreateEntityParams.build_check_type = build_check_manual
    if not canPlaceEntity(tryCreateEntityParams) then
        return
    end
    local createdEntity = surface.create_entity(tryCreateEntityParams)
    if not createdEntity then
        return
    end
    removeIntersectingItemsOnGround(surface, createdEntity.bounding_box)
    if createdEntity.secondary_bounding_box then
        removeIntersectingItemsOnGround(surface, createdEntity.secondary_bounding_box)
    end
    return createdEntity
end
local nameToType
OnEntityPrototypesLoaded:addListener(function(info)
    nameToType = info.nameToType
end)
local rawset = _G.rawset
local raise_script_built = script.raise_script_built
--- If changed is false, the code assumes that the last time this was called [entity] is the same.
-- This is a performance optimization to use with care.
function ____exports.createEntity(surface, position, direction, entity, changed)
    if changed == nil then
        changed = true
    end
    if changed then
        entityVersion = entityVersion + 1
    end
    local luaEntity = tryCreateUnconfiguredEntity(surface, position, direction, entity)
    if not luaEntity then
        return nil
    end
    local ____type = nameToType[entity.name]
    rawset(luaEntity, "name", entity.name)
    rawset(luaEntity, "type", ____type)
    if ____type == "loader" or ____type == "loader-1x1" then
        luaEntity.loader_type = entity.type or "output"
        luaEntity.direction = direction
    end
    if entityHasSettings(entity) then
        local ghost = pasteEntity(surface, position, direction, entity)
        if ghost ~= nil then
            ghost.destroy()
        end
    end
    if entity.items then
        createItems(luaEntity, entity.items)
    end
    raise_script_built({entity = luaEntity})
    if luaEntity.valid then
        return luaEntity
    end
end
local upgradeEntityParams = {
    name = "",
    position = nil,
    direction = nil,
    force = "player",
    fast_replace = true,
    spill = false,
    create_build_effect_smoke = false,
    type = nil
}
local upgradeEntityVersion = 0
local function upgradeEntity(oldEntity, name)
    if upgradeEntityVersion ~= entityVersion then
        upgradeEntityVersion = entityVersion
        upgradeEntityParams.name = name
        upgradeEntityParams.position = oldEntity.position
        upgradeEntityParams.direction = oldEntity.direction
        upgradeEntityParams.type = oldEntity.type == "underground-belt" and oldEntity.belt_to_ground_type or nil
    end
    oldEntity.minable = true
    local newEntity = oldEntity.surface.create_entity(upgradeEntityParams)
    if not newEntity then
        return oldEntity
    end
    if oldEntity.valid then
        oldEntity.destroy()
    end
    return newEntity
end
local function matchItems(luaEntity, value)
    local items = value.items
    local moduleInventory = luaEntity.get_module_inventory()
    if not moduleInventory then
        return
    end
    if not items then
        moduleInventory.clear()
        return
    end
    for item, amount in pairs(moduleInventory.get_contents()) do
        local expected = items[item] or 0
        if amount > expected then
            moduleInventory.remove({name = item, count = amount - expected})
        end
    end
    for item, amount in pairs(items) do
        local existing = moduleInventory.get_item_count(item)
        if amount > existing then
            moduleInventory.insert({name = item, count = amount - existing})
        end
    end
    moduleInventory.sort_and_merge()
end
function ____exports.checkUndergroundPairFlippable(luaEntity)
    if not luaEntity then
        return nil, true
    end
    local stage = getStageAtSurface(luaEntity.surface_index)
    if not stage then
        return nil, true
    end
    local content = stage.project.content
    local existing = content:findCompatibleWithLuaEntity(luaEntity, nil, stage.stageNumber)
    if not existing then
        return nil, true
    end
    return existing, existing.firstValue.type ~= luaEntity.belt_to_ground_type
end
local function updateUndergroundRotation(luaEntity, value, direction)
    if getUndergroundDirection(direction, value.type) ~= getUndergroundDirection(luaEntity.direction, luaEntity.belt_to_ground_type) then
        local surface = luaEntity.surface
        local position = luaEntity.position
        luaEntity.destroy()
        return ____exports.createEntity(
            surface,
            position,
            direction,
            value,
            false
        )
    end
    local mode = value.type or "input"
    if luaEntity.belt_to_ground_type ~= mode then
        local neighbor = luaEntity.neighbours
        local neighborProjEntity, flippable = ____exports.checkUndergroundPairFlippable(neighbor)
        if not flippable then
            return luaEntity
        end
        local rotated = ____exports.forceFlipUnderground(luaEntity)
        local ____luaEntity_4 = luaEntity
        local ____rotated_3
        if rotated then
            ____rotated_3 = neighborProjEntity
        else
            ____rotated_3 = nil
        end
        return ____luaEntity_4, ____rotated_3
    end
    return luaEntity
end
local function updateRollingStock(luaEntity, value)
    if luaEntity.type ~= "locomotive" then
        return
    end
    local train = luaEntity.train
    if not train then
        return
    end
    local schedule = value.schedule
    if not schedule then
        train.schedule = nil
    else
        local ____opt_5 = train.schedule
        local oldScheduleCurrent = ____opt_5 and ____opt_5.current
        train.schedule = {current = oldScheduleCurrent or 1, records = value.schedule}
    end
end
local function removeExtraProperties(bpEntity)
    bpEntity.entity_number = nil
    bpEntity.position = nil
    bpEntity.direction = nil
    bpEntity.neighbours = nil
    bpEntity.connections = nil
    bpEntity.tags = nil
    return bpEntity
end
function ____exports.copyKnownValue(value)
    return removeExtraProperties(mutableShallowCopy(value))
end
--- Position and direction are ignored.
function ____exports.saveEntity(entity, knownValue)
    if knownValue then
        return ____exports.copyKnownValue(knownValue)
    end
    local bpEntity = blueprintEntity(entity)
    if bpEntity then
        return removeExtraProperties(bpEntity)
    end
end
function ____exports.updateEntity(luaEntity, value, direction, changed)
    if changed == nil then
        changed = true
    end
    if changed then
        entityVersion = entityVersion + 1
    end
    if luaEntity.name ~= value.name then
        luaEntity = upgradeEntity(luaEntity, value.name)
    end
    local ____type = luaEntity.type
    if ____type == "underground-belt" then
        return updateUndergroundRotation(luaEntity, value, direction)
    end
    if ____type == "loader" or ____type == "loader-1x1" then
        luaEntity.loader_type = value.type or "output"
    elseif rollingStockTypes[____type] ~= nil then
        updateRollingStock(luaEntity, value)
        return luaEntity
    end
    luaEntity.direction = direction
    local ghost = pasteEntity(luaEntity.surface, luaEntity.position, direction, value)
    if ghost then
        ghost.destroy()
    end
    matchItems(luaEntity, value)
    return luaEntity
end
local function makePreviewIndestructible(entity)
    if not entity then
        return
    end
    entity.destructible = false
    entity.minable = false
    entity.rotatable = false
    if entity.type == "rail-remnants" then
        entity.corpse_expires = false
        entity.corpse_immune_to_entity_placement = true
    end
end
function ____exports.createPreviewEntity(surface, position, apparentDirection, previewName)
    local entity = surface.create_entity({name = previewName, position = position, direction = apparentDirection, force = "player"})
    makePreviewIndestructible(entity)
    return entity
end
____exports._mockable = true
--- Currently only true if is a square assembling machine with no fluid inputs.
function ____exports.canBeAnyDirection(luaEntity)
    return luaEntity.type == "assembling-machine" and getPrototypeRotationType(luaEntity.name) == 1 and #luaEntity.fluidbox == 0
end
return ____exports
