--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____util = require("util")
local direction_vectors = ____util.direction_vectors
local oppositedirection = ____util.oppositedirection
local min = math.min
--- Gets the underground direction (direction of where a paired underground belt would be).
function ____exports.getUndergroundDirection(direction, undergroundBeltType)
    if undergroundBeltType == "output" then
        return oppositedirection(direction)
    end
    return direction
end
--- Finds an underground pair. If there are multiple possible pairs, returns the first one, and true as the second return value.
function ____exports.findUndergroundPair(content, member, stage, name)
    if name == nil then
        name = member:getNameAtStage(stage)
    end
    local reach = game.entity_prototypes[name].max_underground_distance
    if not reach then
        return
    end
    local direction = ____exports.getUndergroundDirection(member.direction, member.firstValue.type)
    local otherDirection = oppositedirection(direction)
    local ____member_position_0 = member.position
    local x = ____member_position_0.x
    local y = ____member_position_0.y
    local dx, dy = table.unpack(direction_vectors[direction])
    local currentPair = nil
    local shadowStage = math.huge
    local curPos = {}
    for i = 1, reach do
        do
            curPos.x = x + i * dx
            curPos.y = y + i * dy
            local candidate = content:findCompatibleByProps(name, curPos, nil, stage)
            if not candidate or candidate:getNameAtStage(stage) ~= name or candidate.firstStage >= shadowStage then
                goto __continue6
            end
            local candidateDirection = ____exports.getUndergroundDirection(candidate.direction, candidate.firstValue.type)
            if candidateDirection == direction then
                shadowStage = min(shadowStage, candidate.firstStage)
                if shadowStage <= stage then
                    break
                end
            end
            if candidateDirection == otherDirection then
                if candidate.firstStage <= stage then
                    return candidate
                end
                if currentPair == nil or candidate.firstStage < currentPair.firstStage then
                    currentPair = candidate
                end
            end
        end
        ::__continue6::
    end
    return currentPair
end
return ____exports
