--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local removeExistingConnectionsToPowerSwitchSide, partitionExistingCircuitConnections, findMatchingCircuitConnection
local ____lib = require("lib.index")
local isEmpty = ____lib.isEmpty
local ____circuit_2Dconnection = require("entity.circuit-connection")
local circuitConnectionMatches = ____circuit_2Dconnection.circuitConnectionMatches
local getDirectionalInfo = ____circuit_2Dconnection.getDirectionalInfo
local ____ProjectEntity = require("entity.ProjectEntity")
local addCircuitConnection = ____ProjectEntity.addCircuitConnection
local removeCircuitConnection = ____ProjectEntity.removeCircuitConnection
function removeExistingConnectionsToPowerSwitchSide(powerSwitchEntity, side)
    local connections = powerSwitchEntity.circuitConnections
    if not connections then
        return
    end
    for ____, otherConnections in pairs(connections) do
        for connection in pairs(otherConnections) do
            local ____, fromId = getDirectionalInfo(connection, powerSwitchEntity)
            if fromId == side then
                removeCircuitConnection(connection)
                return true
            end
        end
    end
end
function partitionExistingCircuitConnections(projectConnections, luaEntity, existingConnections, content, stage)
    local matching = {}
    local extra = {}
    for ____, existingConnection in ipairs(existingConnections) do
        do
            local otherLuaEntity = existingConnection.target_entity
            if luaEntity == otherLuaEntity and existingConnection.source_circuit_id > existingConnection.target_circuit_id then
                goto __continue86
            end
            local otherEntity = content:findCompatibleWithLuaEntity(otherLuaEntity, nil, stage)
            if not otherEntity then
                goto __continue86
            end
            local matchingConnection
            if projectConnections then
                local otherConnections = projectConnections[otherEntity]
                matchingConnection = otherConnections and findMatchingCircuitConnection(otherConnections, otherEntity, existingConnection)
            end
            if matchingConnection then
                matching[matchingConnection] = existingConnection
            else
                extra[existingConnection] = otherEntity
            end
        end
        ::__continue86::
    end
    return matching, extra
end
function findMatchingCircuitConnection(connections, toEntity, ____bindingPattern0)
    local wire
    local target_circuit_id
    local source_circuit_id
    source_circuit_id = ____bindingPattern0.source_circuit_id
    target_circuit_id = ____bindingPattern0.target_circuit_id
    wire = ____bindingPattern0.wire
    for connection in pairs(connections) do
        if circuitConnectionMatches(
            connection,
            wire,
            toEntity,
            source_circuit_id,
            target_circuit_id
        ) then
            return connection
        end
    end
end
local wire_type = defines.wire_type
function ____exports.addPowerSwitchConnections(thisEntity, existingConnections)
    local thisType = thisEntity.type
    if thisType == "electric-pole" then
        for ____, copperConnectionDefinition in ipairs(thisEntity.copper_connection_definitions) do
            if copperConnectionDefinition.target_entity.type == "power-switch" then
                existingConnections[#existingConnections + 1] = {wire = defines.wire_type.copper, target_entity = copperConnectionDefinition.target_entity, source_circuit_id = copperConnectionDefinition.source_wire_connector, target_circuit_id = copperConnectionDefinition.target_wire_connector}
            end
        end
    elseif thisType == "power-switch" then
        for ____, copperConnectionDefinition in ipairs(thisEntity.copper_connection_definitions) do
            if copperConnectionDefinition.target_entity.type == "electric-pole" then
                existingConnections[#existingConnections + 1] = {wire = defines.wire_type.copper, target_entity = copperConnectionDefinition.target_entity, source_circuit_id = copperConnectionDefinition.source_wire_connector, target_circuit_id = copperConnectionDefinition.target_wire_connector}
            end
        end
    end
end
local function updateCircuitConnections(content, entity, stage, luaEntity)
    local existingConnections = luaEntity.circuit_connection_definitions
    if not existingConnections then
        return
    end
    ____exports.addPowerSwitchConnections(luaEntity, existingConnections)
    local projectConnections = entity.circuitConnections
    local matchingConnections, extraConnections = partitionExistingCircuitConnections(
        projectConnections,
        luaEntity,
        existingConnections,
        content,
        stage
    )
    for extraConnection in pairs(extraConnections) do
        if extraConnection.wire == wire_type.copper then
            if luaEntity.type == "power-switch" then
                luaEntity.disconnect_neighbour({wire = extraConnection.wire, target_entity = extraConnection.target_entity, source_wire_id = extraConnection.source_circuit_id, target_wire_id = extraConnection.target_circuit_id})
            else
                extraConnection.target_entity.disconnect_neighbour({wire = extraConnection.wire, target_entity = luaEntity, source_wire_id = extraConnection.target_circuit_id, target_wire_id = extraConnection.source_circuit_id})
            end
        else
            luaEntity.disconnect_neighbour(extraConnection)
        end
    end
    if projectConnections then
        for otherEntity, connections in pairs(projectConnections) do
            do
                local otherLuaEntity = otherEntity:getWorldEntity(stage)
                if not otherLuaEntity then
                    goto __continue19
                end
                for connection in pairs(connections) do
                    do
                        if matchingConnections[connection] ~= nil then
                            goto __continue21
                        end
                        local ____, otherId, thisId = getDirectionalInfo(connection, otherEntity)
                        if connection.wire == wire_type.copper then
                            luaEntity.connect_neighbour({wire = connection.wire, target_entity = otherLuaEntity, source_wire_id = thisId, target_wire_id = otherId})
                        else
                            luaEntity.connect_neighbour({wire = connection.wire, target_entity = otherLuaEntity, source_circuit_id = thisId, target_circuit_id = otherId})
                        end
                    end
                    ::__continue21::
                end
            end
            ::__continue19::
        end
    end
end
local function updateCableConnections(content, entity, stage, luaEntity)
    if luaEntity.type ~= "electric-pole" then
        return
    end
    local projectConnections = entity.cableConnections
    local matching = {}
    local existingConnections = luaEntity.neighbours.copper
    if existingConnections then
        for ____, otherLuaEntity in ipairs(existingConnections) do
            do
                if otherLuaEntity.type == "power-switch" then
                    goto __continue29
                end
                local otherEntity = content:findCompatibleWithLuaEntity(otherLuaEntity, nil, stage)
                if not otherEntity then
                    goto __continue29
                end
                if projectConnections and projectConnections[otherEntity] ~= nil then
                    matching[otherEntity] = true
                else
                    luaEntity.disconnect_neighbour(otherLuaEntity)
                end
            end
            ::__continue29::
        end
    end
    if projectConnections then
        for otherEntity in pairs(projectConnections) do
            local otherLuaEntity = otherEntity:getWorldEntity(stage)
            if otherLuaEntity and not (matching[otherEntity] ~= nil) then
                luaEntity.connect_neighbour(otherLuaEntity)
            end
        end
    end
end
--- Handles both cable and circuit connections.
local function updateWireConnectionsAtStage(content, entity, stage)
    local luaEntity = entity:getWorldEntity(stage)
    if not luaEntity then
        return
    end
    updateCircuitConnections(content, entity, stage, luaEntity)
    updateCableConnections(content, entity, stage, luaEntity)
end
local function saveCircuitConnections(content, entity, stage)
    local luaEntity = entity:getWorldEntity(stage)
    if not luaEntity then
        return false
    end
    local existingConnections = luaEntity.circuit_connection_definitions
    if not existingConnections then
        return false
    end
    ____exports.addPowerSwitchConnections(luaEntity, existingConnections)
    local projectConnections = entity.circuitConnections
    local matchingConnections, extraConnections = partitionExistingCircuitConnections(
        projectConnections,
        luaEntity,
        existingConnections,
        content,
        stage
    )
    local hasDiff = not isEmpty(extraConnections)
    if projectConnections then
        for otherEntity, connections in pairs(projectConnections) do
            do
                local otherLuaEntity = otherEntity:getWorldEntity(stage)
                if not otherLuaEntity then
                    goto __continue45
                end
                for connection in pairs(connections) do
                    if not (matchingConnections[connection] ~= nil) then
                        removeCircuitConnection(connection)
                        hasDiff = true
                    end
                end
            end
            ::__continue45::
        end
    end
    local additionalEntitiesToUpdate = nil
    for definition, otherEntity in pairs(extraConnections) do
        if definition.wire == defines.wire_type.copper then
            if luaEntity.type == "power-switch" then
                removeExistingConnectionsToPowerSwitchSide(entity, definition.source_circuit_id)
            else
                assert(luaEntity.type == "electric-pole")
                if removeExistingConnectionsToPowerSwitchSide(otherEntity, definition.target_circuit_id) then
                    additionalEntitiesToUpdate = additionalEntitiesToUpdate or ({})
                    additionalEntitiesToUpdate[#additionalEntitiesToUpdate + 1] = otherEntity
                end
            end
        end
        addCircuitConnection({
            fromEntity = entity,
            toEntity = otherEntity,
            wire = definition.wire,
            fromId = definition.source_circuit_id,
            toId = definition.target_circuit_id
        })
    end
    return hasDiff, additionalEntitiesToUpdate
end
--- additionalStageForConnections: If provided, the connections will be saved for this stage as well (with lower priority).
-- Used when poles are first placed.
local function saveCableConnections(content, entity, stage, additionalStageForConnections)
    local luaEntity = entity:getWorldEntity(stage)
    if not luaEntity or luaEntity.type ~= "electric-pole" then
        return false
    end
    local worldConnections = luaEntity.neighbours.copper
    local savedConnections = entity.cableConnections
    local matchingConnections = {}
    local newConnections = {}
    if worldConnections then
        for ____, otherLuaEntity in ipairs(worldConnections) do
            do
                local otherEntity = content:findCompatibleWithLuaEntity(otherLuaEntity, nil, stage)
                if not otherEntity then
                    goto __continue64
                end
                if otherLuaEntity.type == "power-switch" then
                    goto __continue64
                end
                if not savedConnections or not (savedConnections[otherEntity] ~= nil) then
                    newConnections[otherEntity] = true
                else
                    matchingConnections[otherEntity] = true
                end
            end
            ::__continue64::
        end
    end
    if additionalStageForConnections then
        local higherEntity = entity:getWorldEntity(additionalStageForConnections)
        if higherEntity then
            local higherConnections = higherEntity.neighbours.copper
            if higherConnections then
                for ____, otherLuaEntity in ipairs(higherConnections) do
                    do
                        if otherLuaEntity.type == "power-switch" then
                            goto __continue73
                        end
                        local otherEntity = content:findCompatibleWithLuaEntity(otherLuaEntity, nil, stage)
                        if otherEntity and otherEntity.firstStage > stage and not (savedConnections and savedConnections[otherEntity] ~= nil) then
                            newConnections[otherEntity] = true
                        end
                    end
                    ::__continue73::
                end
            end
        end
    end
    local hasDiff = not isEmpty(newConnections)
    if savedConnections then
        for otherEntity in pairs(savedConnections) do
            if not (matchingConnections[otherEntity] ~= nil) and otherEntity:getWorldEntity(stage) then
                entity:removeDualCableConnection(otherEntity)
                hasDiff = true
            end
        end
    end
    local maxConnectionsExceeded
    for add in pairs(newConnections) do
        local result = entity:tryAddDualCableConnection(add)
        if result == "MaxConnectionsReached" then
            maxConnectionsExceeded = true
        end
    end
    return hasDiff, maxConnectionsExceeded
end
local function saveWireConnections(content, entity, stage, higherStageForMerging)
    local diff2, maxConnectionsExceeded = saveCableConnections(content, entity, stage, higherStageForMerging)
    local diff1, additionalEntitiesToUpdate = saveCircuitConnections(content, entity, stage)
    return diff1 or diff2, maxConnectionsExceeded, additionalEntitiesToUpdate
end
____exports.updateWireConnectionsAtStage = updateWireConnectionsAtStage
____exports.saveWireConnections = saveWireConnections
____exports._mockable = true
return ____exports
