local ____lualib = require("lualib_bundle")
local __TS__Symbol = ____lualib.__TS__Symbol
local Symbol = ____lualib.Symbol
local __TS__ArrayUnshift = ____lualib.__TS__ArrayUnshift
local __TS__ObjectAssign = ____lualib.__TS__ObjectAssign
local __TS__ArrayIsArray = ____lualib.__TS__ArrayIsArray
local ____exports = {}
____exports.scriptEventIds = {
    on_init = __TS__Symbol("on_init"),
    on_load = __TS__Symbol("on_load"),
    on_configuration_changed = __TS__Symbol("on_configuration_changed")
}
local registeredHandlers = {}
local canRegister = true
local ignoreRegister = false
function ____exports._setCanRegister(value)
    canRegister = value
end
local function registerInternal(id, handler, early)
    if ignoreRegister then
        log("Ignoring register call for " .. tostring(id))
        return
    end
    if not canRegister then
        error("Cannot register event handlers after on_init/on_load")
    end
    local handlers = registeredHandlers[id]
    if not handlers then
        local ____temp_0 = {}
        registeredHandlers[id] = ____temp_0
        handlers = ____temp_0
    end
    if early then
        __TS__ArrayUnshift(handlers, handler)
    else
        handlers[#handlers + 1] = handler
    end
    if #handlers > 2 then
        return
    end
    local func
    if #handlers == 1 then
        func = handler
    else
        local theHandlers = handlers
        func = function(data)
            for i = 1, #theHandlers do
                theHandlers[i](data)
            end
        end
    end
    if type(id) == "table" then
        local function funcWrapper(data)
            func(data)
            canRegister = false
        end
        script[id.description](funcWrapper)
    else
        script.on_event(id, func)
    end
end
local function raiseFakeEvent(id, data)
    ignoreRegister = true
    local handlers = registeredHandlers[id]
    if not handlers then
        return
    end
    if data then
        __TS__ObjectAssign(
            data,
            {
                tick = game.tick,
                name = type(id) ~= "table" and id or nil
            }
        )
        if type(id) == "string" then
            data.input_name = id
            if data.cursor_position == nil then
                data.cursor_position = {x = 0, y = 0}
            end
        end
    end
    for ____, handler in ipairs(handlers) do
        handler(data)
    end
    ignoreRegister = false
end
local function clear(id)
    registeredHandlers[id] = nil
    if type(id) == "table" then
        script[id.description](nil)
    else
        script.on_event(id, nil)
    end
end
local Events = {
    on = function(event, func)
        if not __TS__ArrayIsArray(event) then
            registerInternal(event, func)
        else
            for ____, e in ipairs(event) do
                registerInternal(e, func)
            end
        end
    end,
    onAll = function(handlers)
        for event, handler in pairs(handlers) do
            local id = ____exports.scriptEventIds[event] or defines.events[event] or error(("\"" .. event) .. "\" is not an event name. Use \"register\" to register a handler for a custom input event.")
            registerInternal(id, handler)
        end
    end,
    registerEarly = function(e, f)
        registerInternal(e, f, true)
    end,
    onInitOrLoad = function(f)
        registerInternal(____exports.scriptEventIds.on_init, f)
        registerInternal(____exports.scriptEventIds.on_load, f)
    end,
    clearHandlers = clear,
    raiseFakeEvent = function(event, data)
        raiseFakeEvent(event, data)
    end,
    raiseFakeEventNamed = function(event, data)
        local id = ____exports.scriptEventIds[event] or defines.events[event] or error(("\"" .. tostring(event)) .. "\" is not an event name.")
        raiseFakeEvent(id, data)
    end
}
setmetatable(
    Events,
    {__index = function(self, key)
        local id = ____exports.scriptEventIds[key] or defines.events[key]
        if id ~= nil then
            return function(handler)
                registerInternal(id, handler)
            end
        end
    end}
)
____exports.Events = Events
return ____exports
