--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local util = require("util")
function ____exports.shallowCopy(obj)
    local result = {}
    for k, v in pairs(obj) do
        result[k] = v
    end
    return result
end
____exports.mutableShallowCopy = ____exports.shallowCopy
____exports.deepCopy = util.table.deepcopy
function ____exports.deepCompare(a, b)
    if a == b then
        return true
    end
    if type(a) ~= "table" or type(b) ~= "table" then
        return false
    end
    for k, v in pairs(a) do
        if not ____exports.deepCompare(v, b[k]) then
            return false
        end
    end
    for k in pairs(b) do
        if a[k] == nil then
            return false
        end
    end
    return true
end
function ____exports.shallowCompare(a, b)
    if a == b then
        return true
    end
    if type(a) ~= "table" or type(b) ~= "table" then
        return false
    end
    for k, v in pairs(a) do
        if b[k] ~= v then
            return false
        end
    end
    for k in pairs(b) do
        if a[k] == nil then
            return false
        end
    end
    return true
end
local next = _G.next
function ____exports.isEmpty(obj)
    return next(obj) == nil
end
function ____exports.assertNever(value)
    error("should not be reachable: " .. serpent.block(value))
end
____exports.assert = _G.assert
function ____exports.shiftNumberKeysUp(obj, number)
    local keysToChange = {}
    for changeStage in pairs(obj) do
        if type(changeStage) ~= "number" then
            break
        end
        if changeStage >= number then
            keysToChange[#keysToChange + 1] = changeStage
        end
    end
    do
        local i = #keysToChange - 1
        while i >= 0 do
            local key = keysToChange[i + 1]
            obj[key + 1] = obj[key]
            obj[key] = nil
            i = i - 1
        end
    end
end
function ____exports.shiftNumberKeysDown(obj, number)
    local keysToChange = {}
    for changeStage in pairs(obj) do
        if type(changeStage) ~= "number" then
            break
        end
        if changeStage > number then
            keysToChange[#keysToChange + 1] = changeStage
        end
    end
    obj[number] = nil
    for ____, stage in ipairs(keysToChange) do
        obj[stage - 1] = obj[stage]
        obj[stage] = nil
    end
end
function ____exports.visitAll(obj, fn)
    local seen = {}
    seen[obj] = true
    local queue = {obj}
    while #queue > 0 do
        local obj = table.remove(queue)
        fn(obj)
        for k, v in pairs(obj) do
            if type(k) == "table" and not (seen[k] ~= nil) then
                seen[k] = true
                queue[#queue + 1] = k
            end
            if type(v) == "table" and not (seen[v] ~= nil) then
                seen[v] = true
                queue[#queue + 1] = v
            end
        end
    end
end
function ____exports.getKeySet(keys)
    local result = {}
    for key in pairs(keys) do
        result[key] = true
    end
    return result
end
return ____exports
