local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__New = ____lualib.__TS__New
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__ArrayMap = ____lualib.__TS__ArrayMap
local __TS__InstanceOf = ____lualib.__TS__InstanceOf
local ____exports = {}
local MappedProperty
local _____util = require("lib._util")
local isEmpty = _____util.isEmpty
local visitAll = _____util.visitAll
local ____migration = require("lib.migration")
local Migrations = ____migration.Migrations
local ____references = require("lib.references")
local bind = ____references.bind
local funcRef = ____references.funcRef
local ibind = ____references.ibind
local RegisterClass = ____references.RegisterClass
local registerFunctions = ____references.registerFunctions
local ____Event = require("lib.event.Event")
local Event = ____Event.Event
____exports.Property = __TS__Class()
local Property = ____exports.Property
Property.name = "Property"
function Property.prototype.____constructor(self)
end
function Property.prototype.subscribe(self, context, observer)
    local subscription = self:_subscribeIndependently(observer)
    context:add(subscription)
    return subscription
end
function Property.prototype._subscribeIndependentlyAndRaise(self, observer)
    local subscription = self:_subscribeIndependently(observer)
    observer:invoke(
        self:get(),
        nil
    )
    return subscription
end
function Property.prototype.subscribeAndRaise(self, context, observer)
    local subscription = self:subscribe(context, observer)
    observer:invoke(
        self:get(),
        nil
    )
    return subscription
end
function Property.prototype.map(self, mapper)
    return __TS__New(MappedProperty, self, mapper)
end
function Property.prototype.flatMap(self, mapper)
    return __TS__New(____exports.FlatMappedProperty, self, mapper)
end
function Property.truthyFn(value)
    return not not value
end
function Property.prototype.truthy(self)
    return self:map(funcRef(____exports.Property.truthyFn))
end
function Property.andFn(outValue, thisValue)
    local ____thisValue_0
    if thisValue then
        ____thisValue_0 = outValue
    else
        ____thisValue_0 = nil
    end
    return ____thisValue_0
end
Property.prototype["and"] = function(self, other)
    return self:flatMap(bind(____exports.Property.andFn, other))
end
function Property.selectFn(ifTrue, ifFalse, value)
    local ____value_1
    if value then
        ____value_1 = ifTrue
    else
        ____value_1 = ifFalse
    end
    return ____value_1
end
function Property.prototype.select(self, ifTrue, ifFalse)
    return self:flatMap(bind(____exports.Property.selectFn, ifTrue, ifFalse))
end
Property = __TS__DecorateLegacy(
    {RegisterClass("State")},
    Property
)
____exports.Property = Property
____exports.BasicProperty = __TS__Class()
local BasicProperty = ____exports.BasicProperty
BasicProperty.name = "BasicProperty"
__TS__ClassExtends(BasicProperty, ____exports.Property)
function BasicProperty.prototype.____constructor(self, ...)
    BasicProperty.____super.prototype.____constructor(self, ...)
    self.event = __TS__New(Event)
end
function BasicProperty.prototype._subscribeIndependently(self, observer)
    return self.event:_subscribeIndependently(observer)
end
function BasicProperty.prototype.forceNotify(self)
    local value = self:get()
    self.event:raise(value, value)
end
function BasicProperty.prototype.closeAll(self)
    self.event:closeAll()
end
function ____exports._numObservers(state)
    return table_size(state.event)
end
local MutablePropertyImpl = __TS__Class()
MutablePropertyImpl.name = "MutablePropertyImpl"
__TS__ClassExtends(MutablePropertyImpl, ____exports.BasicProperty)
function MutablePropertyImpl.prototype.____constructor(self, value)
    MutablePropertyImpl.____super.prototype.____constructor(self)
    self.value = value
end
function MutablePropertyImpl.prototype.get(self)
    return self.value
end
function MutablePropertyImpl.prototype.set(self, value)
    local oldValue = self.value
    self.value = value
    if oldValue ~= value then
        self.event:raise(value, oldValue)
    end
end
function MutablePropertyImpl.prototype.__tostring(self)
    return ("MutablePropertyImpl(" .. tostring(self:get())) .. ")"
end
MutablePropertyImpl = __TS__DecorateLegacy(
    {RegisterClass("MutableState")},
    MutablePropertyImpl
)
function ____exports.property(value)
    return __TS__New(MutablePropertyImpl, value)
end
function ____exports.isMutableProperty(property)
    return type(property.set) == "function"
end
MappedProperty = __TS__Class()
MappedProperty.name = "MappedProperty"
__TS__ClassExtends(MappedProperty, ____exports.BasicProperty)
function MappedProperty.prototype.____constructor(self, source, mapper)
    MappedProperty.____super.prototype.____constructor(self)
    self.source = source
    self.mapper = mapper
    self._checkEmpty = ibind(self, "checkEmpty")
end
function MappedProperty.prototype.get(self)
    if self.sourceSubscription then
        return self.curValue
    end
    return self.mapper:invoke(self.source:get())
end
function MappedProperty.prototype.subscribeToSource(self)
    local source = self.source
    local mapper = self.mapper
    local ____opt_2 = self.sourceSubscription
    if ____opt_2 ~= nil then
        ____opt_2:close()
    end
    self.sourceSubscription = source:_subscribeIndependently(ibind(self, "sourceListener"))
    self.curValue = mapper:invoke(source:get())
end
function MappedProperty.prototype.unsubscribeFromSource(self)
    local ____opt_4 = self.sourceSubscription
    if ____opt_4 ~= nil then
        ____opt_4:close()
    end
    self.sourceSubscription = nil
    self.curValue = nil
end
function MappedProperty.prototype.sourceListener(self, sourceNewValue)
    if isEmpty(self.event) then
        return self:unsubscribeFromSource()
    end
    local oldValue = self.curValue
    local mapper = self.mapper
    local mappedNewValue = mapper:invoke(sourceNewValue)
    if oldValue == mappedNewValue then
        return
    end
    self.curValue = mappedNewValue
    self.event:raise(mappedNewValue, oldValue)
end
function MappedProperty.prototype.checkEmpty(self)
    if isEmpty(self.event) then
        self:unsubscribeFromSource()
    end
end
function MappedProperty.prototype._subscribeIndependently(self, observer)
    if not self.sourceSubscription then
        self:subscribeToSource()
    end
    local childSubscription = MappedProperty.____super.prototype._subscribeIndependently(self, observer)
    childSubscription:add(self._checkEmpty)
    return childSubscription
end
function MappedProperty.prototype.__tostring(self)
    return ("MappedState(" .. tostring(self.source)) .. ")"
end
MappedProperty = __TS__DecorateLegacy(
    {RegisterClass("MappedState")},
    MappedProperty
)
local CustomProperty = __TS__Class()
CustomProperty.name = "CustomProperty"
__TS__ClassExtends(CustomProperty, ____exports.BasicProperty)
function CustomProperty.prototype.____constructor(self, sources, func)
    CustomProperty.____super.prototype.____constructor(self)
    self.sources = sources
    self.func = func
    self._checkEmpty = ibind(self, "checkEmpty")
end
function CustomProperty.prototype.get(self)
    if self.subscriptions then
        return self.curValue
    end
    return self.func:invoke()
end
function CustomProperty.prototype.subscribeToSources(self)
    self.subscriptions = __TS__ArrayMap(
        self.sources,
        function(____, source) return source:_subscribeIndependently(ibind(self, "sourceListener")) end
    )
    self.curValue = self.func:invoke()
end
function CustomProperty.prototype.unsubscribeFromSources(self)
    for ____, sub in ipairs(self.subscriptions) do
        sub:close()
    end
    self.subscriptions = nil
    self.curValue = nil
end
function CustomProperty.prototype.sourceListener(self)
    if isEmpty(self.event) then
        return self:unsubscribeFromSources()
    end
    local oldValue = self.curValue
    local mappedNewValue = self.func:invoke()
    if oldValue == mappedNewValue then
        return
    end
    self.curValue = mappedNewValue
    self.event:raise(mappedNewValue, oldValue)
end
function CustomProperty.prototype.checkEmpty(self)
    if isEmpty(self.event) then
        self:unsubscribeFromSources()
    end
end
function CustomProperty.prototype._subscribeIndependently(self, observer)
    if not self.subscriptions then
        self:subscribeToSources()
    end
    local subscription = CustomProperty.____super.prototype._subscribeIndependently(self, observer)
    subscription:add(self._checkEmpty)
    return subscription
end
function CustomProperty.prototype.__tostring(self)
    return ("CustomProperty(" .. tostring(self.sources)) .. ")"
end
CustomProperty = __TS__DecorateLegacy(
    {RegisterClass("CustomProperty")},
    CustomProperty
)
function ____exports.customMap(func, ...)
    local sources = {...}
    return __TS__New(CustomProperty, sources, func)
end
local function unwrapValuesAndCall(sources, func)
    local values = {}
    for i = 1, #sources do
        values[i] = sources[i]:get()
    end
    return func:invoke(table.unpack(values))
end
registerFunctions("multiMap", {unwrapValuesAndCall = unwrapValuesAndCall})
function ____exports.multiMap(func, ...)
    local sources = {...}
    local fn = bind(func)
    return __TS__New(
        CustomProperty,
        sources,
        bind(unwrapValuesAndCall, sources, fn)
    )
end
____exports.FlatMappedProperty = __TS__Class()
local FlatMappedProperty = ____exports.FlatMappedProperty
FlatMappedProperty.name = "FlatMappedProperty"
__TS__ClassExtends(FlatMappedProperty, ____exports.BasicProperty)
function FlatMappedProperty.prototype.____constructor(self, source, mapper)
    FlatMappedProperty.____super.prototype.____constructor(self)
    self.source = source
    self.mapper = mapper
    self._checkEmpty = ibind(self, "checkEmpty")
end
function FlatMappedProperty.prototype.get(self)
    if self.sourceSubscription then
        return self.curValue
    end
    local mappedValue = self.mapper:invoke(self.source:get())
    local ____temp_6
    if __TS__InstanceOf(mappedValue, ____exports.Property) then
        ____temp_6 = mappedValue:get()
    else
        ____temp_6 = mappedValue
    end
    return ____temp_6
end
function FlatMappedProperty.prototype.subscribeToSource(self)
    local source = self.source
    local mapper = self.mapper
    local ____opt_7 = self.sourceSubscription
    if ____opt_7 ~= nil then
        ____opt_7:close()
    end
    self.sourceSubscription = source:_subscribeIndependently(ibind(self, "sourceListener"))
    self:receiveNewMappedValue(mapper:invoke(source:get()))
end
function FlatMappedProperty.prototype.receiveNewMappedValue(self, newValue)
    local ____opt_9 = self.nestedSubscription
    if ____opt_9 ~= nil then
        ____opt_9:close()
    end
    if __TS__InstanceOf(newValue, ____exports.Property) then
        self.nestedSubscription = newValue:_subscribeIndependently(ibind(self, "nestedListener"))
        self.curValue = newValue:get()
    else
        self.nestedSubscription = nil
        self.curValue = newValue
    end
end
function FlatMappedProperty.prototype.sourceListener(self, sourceNewValue)
    if isEmpty(self.event) then
        return self:unsubscribeFromSource()
    end
    local oldValue = self.curValue
    local mapper = self.mapper
    local newMappedValue = mapper:invoke(sourceNewValue)
    self:receiveNewMappedValue(newMappedValue)
    local newValue = self.curValue
    if oldValue ~= newValue then
        self.event:raise(newValue, oldValue)
    end
end
function FlatMappedProperty.prototype.nestedListener(self, nestedNewValue)
    if isEmpty(self.event) then
        return self:unsubscribeFromSource()
    end
    local oldValue = self.curValue
    self.curValue = nestedNewValue
    if oldValue ~= nestedNewValue then
        self.event:raise(nestedNewValue, oldValue)
    end
end
function FlatMappedProperty.prototype.unsubscribeFromSource(self)
    local sourceSubscription = self.sourceSubscription
    local nestedSubscription = self.nestedSubscription
    if nestedSubscription then
        nestedSubscription:close()
        self.nestedSubscription = nil
    end
    if sourceSubscription then
        sourceSubscription:close()
        self.sourceSubscription = nil
    end
    self.curValue = nil
end
function FlatMappedProperty.prototype.checkEmpty(self)
    if isEmpty(self.event) then
        self:unsubscribeFromSource()
    end
end
function FlatMappedProperty.prototype._subscribeIndependently(self, observer)
    if not self.sourceSubscription then
        self:subscribeToSource()
    end
    local subscription = FlatMappedProperty.____super.prototype._subscribeIndependently(self, observer)
    subscription:add(self._checkEmpty)
    return subscription
end
function FlatMappedProperty.prototype.__tostring(self)
    return ("FlatMappedState(" .. tostring(self.source)) .. ")"
end
FlatMappedProperty = __TS__DecorateLegacy(
    {RegisterClass("FlatMappedState")},
    FlatMappedProperty
)
____exports.FlatMappedProperty = FlatMappedProperty
____exports.Props = {}
local Props = ____exports.Props
do
    local function setValue(state, value)
        state:set(value)
    end
    local function toggle(state)
        state:set(not state:get())
    end
    registerFunctions("States", {setValue = setValue, toggle = toggle})
    function Props.setValueFn(state, value)
        return bind(setValue, state, value)
    end
    function Props.toggleFn(state)
        return bind(toggle, state)
    end
end
local function _migrateCheckEmpty(property)
    property._checkEmpty = ibind(property, "checkEmpty")
    for subscription in pairs(property.event) do
        subscription:add(property._checkEmpty)
    end
    property:checkEmpty()
end
local function migrateCheckEmpty()
    local metatables = {[MappedProperty.prototype] = true, [____exports.FlatMappedProperty.prototype] = true, [CustomProperty.prototype] = true}
    visitAll(
        global,
        function(obj)
            local metatable = getmetatable(obj)
            if metatable and metatables[metatable] ~= nil then
                _migrateCheckEmpty(obj)
            end
        end
    )
end
Migrations.to("0.23.2", migrateCheckEmpty)
return ____exports
