local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ArrayMap = ____lualib.__TS__ArrayMap
local __TS__InstanceOf = ____lualib.__TS__InstanceOf
local __TS__ArrayPushArray = ____lualib.__TS__ArrayPushArray
local __TS__New = ____lualib.__TS__New
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local ____exports = {}
local getMeta
local ____references = require("lib.references")
local RegisterClass = ____references.RegisterClass
function ____exports.isSubscription(subscription)
    return getMeta(subscription) == ____exports.Subscription.prototype
end
____exports.UnsubscriptionError = __TS__Class()
local UnsubscriptionError = ____exports.UnsubscriptionError
UnsubscriptionError.name = "UnsubscriptionError"
function UnsubscriptionError.prototype.____constructor(self, errors)
    self.errors = errors
    self.message = table.concat(
        __TS__ArrayMap(
            errors,
            function(____, err, i) return (tostring(i + 1) .. ") ") .. tostring(tostring(err)) end
        ),
        "\n  "
    )
end
function UnsubscriptionError.prototype.__tostring(self)
    return self.message
end
____exports.Subscription = __TS__Class()
local Subscription = ____exports.Subscription
Subscription.name = "Subscription"
function Subscription.prototype.____constructor(self)
    self._children = {}
    self._parents = {}
end
function Subscription.prototype.isClosed(self)
    return self._children == nil
end
function Subscription.prototype.add(self, subscription)
    if subscription == self then
        return
    end
    local _children = self._children
    if not _children then
        self:callUnsubscription(subscription)
        return
    end
    if ____exports.isSubscription(subscription) then
        if subscription:isClosed() then
            return
        end
        subscription._parents[self] = true
    end
    _children[subscription] = true
end
function Subscription.prototype.hasActions(self)
    return self._children ~= nil and (next(self._children)) ~= nil
end
function Subscription.prototype.removeChild(self, subscription)
    local ____opt_0 = self._children
    if ____opt_0 ~= nil then
        ____opt_0[subscription] = nil
    end
end
function Subscription.prototype.callUnsubscription(self, subscription)
    if subscription.close ~= nil then
        subscription:close()
    else
        subscription:invoke()
    end
end
function Subscription.prototype.tryClose(self)
    local _children = self._children
    if not _children then
        return
    end
    for parent in pairs(self._parents) do
        parent:removeChild(self)
    end
    self._children = nil
    self._parents = nil
    local errors = nil
    for subscription in pairs(_children) do
        local success, result = pcall(self.callUnsubscription, self, subscription)
        if not success then
            if errors == nil then
                errors = {}
            end
            if __TS__InstanceOf(result, ____exports.UnsubscriptionError) then
                __TS__ArrayPushArray(errors, result.errors)
            else
                errors[#errors + 1] = result
            end
        end
    end
    if errors then
        return __TS__New(____exports.UnsubscriptionError, errors)
    end
end
function Subscription.prototype.close(self)
    local ____error = self:tryClose()
    if ____error then
        error(____error, 0)
    end
end
Subscription = __TS__DecorateLegacy(
    {RegisterClass("Subscription")},
    Subscription
)
____exports.Subscription = Subscription
getMeta = getmetatable
return ____exports
