local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__ArrayMap = ____lualib.__TS__ArrayMap
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local __TS__InstanceOf = ____lualib.__TS__InstanceOf
local ____exports = {}
local ____Events = require("lib.Events")
local Events = ____Events.Events
local ____references = require("lib.references")
local ibind = ____references.ibind
local RegisterClass = ____references.RegisterClass
local ____element = require("lib.factoriojsx.element")
local Component = ____element.Component
local ____index = require("lib.factoriojsx.index")
local destroy = ____index.destroy
local FactorioJsx = ____index.FactorioJsx
local getComponentInstance = ____index.getComponentInstance
local renderOpened = ____index.renderOpened
____exports.Dialog = __TS__Class()
local Dialog = ____exports.Dialog
Dialog.name = "Dialog"
__TS__ClassExtends(Dialog, Component)
function Dialog.prototype.render(self, props)
    assert(props.backCaption or props.confirmCaption, "Dialog requires at least one button")
    self.onBackFn = props.onBack
    self.onConfirmFn = props.onConfirm
    self.redConfirm = props.redConfirm
    return FactorioJsx.createElement(
        "frame",
        {
            auto_center = true,
            caption = props.title,
            direction = "vertical",
            onCreate = function(____, e)
                local ____e_0 = e
                self.element = ____e_0
                return ____e_0
            end,
            on_gui_closed = ibind(self, "onBack")
        },
        __TS__ArrayMap(
            props.message,
            function(____, line) return FactorioJsx.createElement("label", {caption = line}) end
        ),
        FactorioJsx.createElement(
            "flow",
            {style = "dialog_buttons_horizontal_flow"},
            props.backCaption ~= nil and FactorioJsx.createElement(
                "button",
                {
                    style = "back_button",
                    caption = props.backCaption,
                    on_gui_click = ibind(self, "onBack")
                }
            ),
            FactorioJsx.createElement(
                "empty-widget",
                {
                    style = "draggable_space",
                    styleMod = {horizontally_stretchable = true},
                    onCreate = function(____, e)
                        local ____e_parent_parent_1 = e.parent.parent
                        e.drag_target = ____e_parent_parent_1
                        return ____e_parent_parent_1
                    end
                }
            ),
            props.confirmCaption ~= nil and FactorioJsx.createElement(
                "button",
                {
                    style = props.redConfirm and "red_confirm_button" or "confirm_button",
                    caption = props.confirmCaption,
                    on_gui_click = ibind(self, "onConfirm")
                }
            )
        )
    )
end
function Dialog.prototype.onBack(self, e)
    local ____opt_2 = self.onBackFn
    if ____opt_2 ~= nil then
        ____opt_2:invoke(game.players[e.player_index])
    end
    destroy(self.element)
end
function Dialog.prototype.onConfirm(self, e)
    local ____opt_4 = self.onConfirmFn
    if ____opt_4 ~= nil then
        ____opt_4:invoke(game.players[e.player_index])
    end
    destroy(self.element)
end
Dialog = __TS__DecorateLegacy(
    {RegisterClass("gui:Dialog")},
    Dialog
)
____exports.Dialog = Dialog
Events.on(
    "bp100:confirm-gui",
    function(e)
        local player = game.players[e.player_index]
        local opened = player.opened
        if (opened and opened.object_name) ~= "LuaGuiElement" or opened.type ~= "frame" then
            return
        end
        local instance = getComponentInstance(opened)
        if instance and __TS__InstanceOf(instance, ____exports.Dialog) then
            instance:onConfirm(e)
            player.play_sound({path = "utility/confirm"})
        end
    end
)
function ____exports.showDialog(player, props)
    renderOpened(player, {type = ____exports.Dialog, props = props})
end
return ____exports
