local ____lualib = require("lualib_bundle")
local __TS__ArrayIsArray = ____lualib.__TS__ArrayIsArray
local __TS__ArrayPushArray = ____lualib.__TS__ArrayPushArray
local ____exports = {}
local _select = select
local function flattenChildren(...)
    local children = {...}
    local childrenLen = _select("#", ...)
    if childrenLen == 0 then
        return nil
    end
    local childArray
    if childrenLen == 1 then
        local child = table.unpack(children)
        if not child then
            return nil
        end
        if not __TS__ArrayIsArray(child) then
            if child.type == "fragment" then
                return child.children
            end
            return {child}
        end
        childArray = child
        local n = childArray.n
        childrenLen = type(n) == "number" and n or #childArray
    else
        childArray = {table.unpack(children)}
    end
    local result = {}
    local function pushSingleChild(child)
        if child then
            if child.type == "fragment" then
                local children = child.children
                if children then
                    __TS__ArrayPushArray(result, children)
                end
            else
                result[#result + 1] = child
            end
        end
    end
    for i = 1, childrenLen do
        local child = childArray[i]
        if __TS__ArrayIsArray(child) then
            for ____, child2 in ipairs(child) do
                pushSingleChild(child2)
            end
        else
            pushSingleChild(child)
        end
    end
    return result
end
local function flattenChildrenToProp(...)
    local children = {...}
    local childrenLen = _select("#", ...)
    if childrenLen == 0 then
        return nil
    end
    if childrenLen == 1 then
        local child = table.unpack(children)
        if child and child.type == "fragment" then
            return child.children or ({})
        end
        return child
    end
    local result = {}
    for i = 1, childrenLen do
        local child = children[i]
        if child and child.type == "fragment" then
            if child.children then
                __TS__ArrayPushArray(result, child.children)
            end
        else
            result[#result + 1] = child
        end
    end
    return result
end
local _type = type
function ____exports.default(____type, props, ...)
    local typeofType = _type(____type)
    if typeofType == "string" then
        local result = props or ({})
        result.type = ____type
        result.children = flattenChildren(...)
        return result
    end
    if not props then
        props = {}
    end
    if props.children == nil then
        props.children = flattenChildrenToProp(...)
    end
    return {type = ____type, props = props}
end
return ____exports
