local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__ArrayPushArray = ____lualib.__TS__ArrayPushArray
local __TS__InstanceOf = ____lualib.__TS__InstanceOf
local __TS__ArrayMap = ____lualib.__TS__ArrayMap
local ____exports = {}
local setStateFunc, setValueObserver, callSetterObserver, _newTracker, newRootContext, newChildContext, callOnMount, isLuaGuiElement, renderInternal, renderFragment, renderElement, renderFunctionComponent, renderClassComponent, ____type
local _____util = require("lib._util")
local isEmpty = _____util.isEmpty
local ____event = require("lib.event.index")
local isMutableProperty = ____event.isMutableProperty
local Property = ____event.Property
local Subscription = ____event.Subscription
local ____Events = require("lib.Events")
local Events = ____Events.Events
local ____migration = require("lib.migration")
local Migrations = ____migration.Migrations
local ____player_2Dinit = require("lib.player-init")
local onPlayerInit = ____player_2Dinit.onPlayerInit
local ____protected_2Daction = require("lib.protected-action")
local protectedAction = ____protected_2Daction.protectedAction
local ____references = require("lib.references")
local assertIsRegisteredClass = ____references.assertIsRegisteredClass
local bind = ____references.bind
local funcRef = ____references.funcRef
local registerFunctions = ____references.registerFunctions
local propInfo = require("lib.factoriojsx.propInfo")
function setStateFunc(state, key, event)
    state:set(event[key] or event.element[key])
end
function setValueObserver(elem, key, value)
    if not elem.valid then
        return
    end
    if elem.object_name == "LuaGuiElement" then
        local info = propInfo[key]
        if info and info[3] and elem[key] == value then
            return
        end
    end
    elem[key] = value
end
function callSetterObserver(elem, key, value)
    if not elem.valid then
        return
    end
    if key == "slider_minimum" then
        elem.set_slider_minimum_maximum(
            value,
            elem.get_slider_maximum()
        )
    elseif key == "slider_maximum" then
        elem.set_slider_minimum_maximum(
            elem.get_slider_minimum(),
            value
        )
    else
        elem[key](value)
    end
end
function _newTracker(parent, playerIndex, firstIndex)
    return {
        playerIndex = playerIndex,
        firstIndex = firstIndex,
        parent = parent,
        onMountCallbacks = {},
        subscriptionContext = parent and parent.subscriptionContext,
        componentInstance = parent and parent.componentInstance,
        onMount = function(self, callback)
            local ____self_onMountCallbacks_0 = self.onMountCallbacks
            ____self_onMountCallbacks_0[#____self_onMountCallbacks_0 + 1] = callback
        end,
        getSubscription = function(self)
            local subscriptionContext = self.subscriptionContext
            if subscriptionContext then
                return subscriptionContext
            end
            local ____temp_3 = parent and parent:getSubscription() or __TS__New(Subscription)
            self.subscriptionContext = ____temp_3
            return ____temp_3
        end
    }
end
function newRootContext(playerIndex, firstIndex)
    return _newTracker(nil, playerIndex, firstIndex)
end
function newChildContext(parent, firstIndex)
    return _newTracker(parent, parent.playerIndex, firstIndex)
end
function callOnMount(context, element)
    for ____, callback in ipairs(context.onMountCallbacks) do
        callback(nil, element)
    end
    if context.parent then
        return callOnMount(context.parent, element)
    end
end
function isLuaGuiElement(element)
    return type(element) == "table" and element.object_name == "LuaGuiElement"
end
function renderInternal(parent, element, context)
    local elemType = element.type
    local elemTypeType = ____type(elemType)
    if elemTypeType == "string" then
        return renderElement(parent, element, context)
    end
    if elemTypeType == "table" then
        return renderClassComponent(parent, element, context)
    end
    if elemTypeType == "function" then
        return renderFunctionComponent(parent, element, context)
    end
    error("Unknown spec type: " .. serpent.block(element))
end
function renderFragment(parent, element, context)
    local children = element.children or ({})
    local usedTracker = context
    local elements = {}
    for ____, child in ipairs(children) do
        do
            local childResult = renderInternal(parent, child, usedTracker)
            if not childResult or isEmpty(childResult) then
                goto __continue29
            end
            usedTracker = newRootContext(usedTracker.playerIndex, nil)
            if isLuaGuiElement(childResult) then
                elements[#elements + 1] = childResult
            else
                __TS__ArrayPushArray(elements, childResult)
            end
        end
        ::__continue29::
    end
    if #elements == 0 then
        local ____opt_4 = context.subscriptionContext
        if ____opt_4 ~= nil then
            ____opt_4:close()
        end
        return
    end
    return elements
end
function renderElement(parent, element, context)
    if element.type == "fragment" then
        return renderFragment(parent, element, context)
    end
    local guiSpec = {}
    local elemProps = {}
    local events = {}
    for key, value in pairs(element) do
        do
            local propInfoElement = propInfo[key]
            if not propInfoElement then
                goto __continue37
            end
            if type(value) == "function" then
                value = funcRef(value)
            end
            if propInfoElement == "event" then
                assert(value.invoke, "Gui event handler must be a function")
                events[key] = value
                goto __continue37
            end
            local isSpecProp = propInfoElement[1]
            local isElemProp = propInfoElement[2]
            local stateEvent = propInfoElement[3]
            local isState = __TS__InstanceOf(value, Property)
            local shouldSetElemProp = not isSpecProp or isState
            if shouldSetElemProp then
                if not isElemProp then
                    error(key .. " cannot be a state value")
                end
                if type(isElemProp) ~= "string" then
                    elemProps[key] = value
                else
                    elemProps[{isElemProp}] = value
                end
                if stateEvent and __TS__InstanceOf(value, Property) then
                    if isMutableProperty(value) then
                        if events[stateEvent] then
                            error("Cannot specify both state and gui event for " .. stateEvent)
                        end
                        events[stateEvent] = bind(setStateFunc, value, key)
                    end
                    if isSpecProp then
                        guiSpec[key] = value:get()
                    end
                end
            elseif isSpecProp then
                guiSpec[key] = value
            end
        end
        ::__continue37::
    end
    if context.firstIndex then
        guiSpec.index = context.firstIndex
    end
    local factorioElement = parent.add(guiSpec)
    for key, value in pairs(elemProps) do
        do
            if key == "selected_tab_index" then
                goto __continue51
            end
            if __TS__InstanceOf(value, Property) then
                local observer
                local name
                if type(key) ~= "table" then
                    observer = bind(setValueObserver, factorioElement, key)
                    name = key
                else
                    name = key[1]
                    observer = bind(callSetterObserver, factorioElement, name)
                end
                value:subscribeAndRaise(
                    context:getSubscription(),
                    observer
                )
            elseif type(key) ~= "table" then
                factorioElement[key] = value
            else
                factorioElement[key[1]](value)
            end
        end
        ::__continue51::
    end
    local styleMod = element.styleMod
    if styleMod then
        local style = factorioElement.style
        for key, value in pairs(styleMod) do
            if __TS__InstanceOf(value, Property) then
                value:subscribeAndRaise(
                    context:getSubscription(),
                    bind(setValueObserver, style, key)
                )
            else
                style[key] = value
            end
        end
    end
    local children = element.children
    if children then
        for ____, child in ipairs(children) do
            renderInternal(
                factorioElement,
                child,
                newRootContext(context.playerIndex, nil)
            )
        end
    end
    if factorioElement.type == "tabbed-pane" then
        local children = factorioElement.children
        for i = 1, #children, 2 do
            local tab = children[i]
            local content = children[i + 1]
            if tab.type ~= "tab" then
                error("Tabbed pane must have alternating tab-content children, got types: " .. table.concat(
                    __TS__ArrayMap(
                        children,
                        function(____, c) return c.type end
                    ),
                    ", "
                ))
            end
            factorioElement.add_tab(tab, content)
        end
        local selectedTabIndex = elemProps.selected_tab_index
        if selectedTabIndex then
            local ____temp_6
            if __TS__InstanceOf(selectedTabIndex, Property) then
                ____temp_6 = selectedTabIndex:get()
            else
                ____temp_6 = selectedTabIndex
            end
            factorioElement.selected_tab_index = ____temp_6
        end
    end
    local ____this_8
    ____this_8 = element
    local ____opt_7 = ____this_8.onCreate
    if ____opt_7 ~= nil then
        ____opt_7(____this_8, factorioElement)
    end
    callOnMount(context, factorioElement)
    local ____context_9 = context
    local subscription = ____context_9.subscriptionContext
    local componentInstance = ____context_9.componentInstance
    if componentInstance or subscription and subscription:hasActions() or not isEmpty(events) then
        global.players[factorioElement.player_index].guiElements[factorioElement.index] = {element = factorioElement, events = events, subscription = subscription, componentInstance = componentInstance}
    end
    return factorioElement
end
function renderFunctionComponent(parent, spec, context)
    return renderInternal(
        parent,
        spec.type(spec.props, context),
        context
    )
end
function renderClassComponent(parent, spec, context)
    local childTracker = newChildContext(context, context.firstIndex)
    local Component = spec.type
    assertIsRegisteredClass(Component)
    local instance = __TS__New(Component)
    if childTracker.componentInstance == nil then
        childTracker.componentInstance = instance
    end
    local resultSpec = instance:render(spec.props, childTracker)
    return renderInternal(parent, resultSpec, childTracker)
end
function ____exports.destroy(element, destroyElement)
    if destroyElement == nil then
        destroyElement = true
    end
    if not element or not element.valid then
        return
    end
    local ____element_10 = element
    local player_index = ____element_10.player_index
    local index = ____element_10.index
    local guiElements = global.players[player_index].guiElements
    local instance = guiElements[index]
    if not instance then
        for ____, child in ipairs(element.children) do
            ____exports.destroy(child, false)
        end
        if destroyElement then
            element.destroy()
        end
        return
    end
    local subscription = instance.subscription
    if element.valid then
        for ____, child in ipairs(element.children) do
            ____exports.destroy(child, false)
        end
    end
    if subscription ~= nil then
        subscription:tryClose()
    end
    if destroyElement and element.valid then
        element.destroy()
    end
    guiElements[index] = nil
end
registerFunctions("factoriojsx render", {setValueObserver = setValueObserver, callSetterObserver = callSetterObserver, setStateFunc = setStateFunc})
onPlayerInit(function(index)
    global.players[index].guiElements = {}
end)
____type = _G.type
function ____exports.render(element, parent, index)
    local result = renderInternal(
        parent,
        element,
        newRootContext(parent.player_index, index)
    )
    if not result or isLuaGuiElement(result) then
        return result
    end
    if #result > 1 then
        error("cannot render multiple elements at root. Try wrapping them in another element.")
    end
    return result[1]
end
function ____exports.renderMultiple(elements, parent)
    local result = renderInternal(
        parent,
        elements,
        newRootContext(parent.player_index, nil)
    )
    return (not result or isLuaGuiElement(result)) and ({result}) or result
end
--- Replaces if another element with the same name already exists.
function ____exports.renderNamed(element, parent, name)
    ____exports.destroy(parent[name])
    local result = ____exports.render(element, parent)
    if result then
        result.name = name
    end
    return result
end
function ____exports.renderOpened(player, spec)
    local element = ____exports.render(spec, player.gui.screen)
    if element then
        player.opened = element
    end
    return element
end
--- Only gets the outermost component, if it exists (if a component renders with another component, the inner component is not returned)
-- 
-- @param element
function ____exports.getComponentInstance(element)
    local guiElement = global.players[element.player_index].guiElements[element.index]
    if guiElement then
        return guiElement.componentInstance
    end
    return nil
end
local function getInstance(element)
    if not element.valid then
        return nil
    end
    return global.players[element.player_index].guiElements[element.index]
end
function ____exports.destroyChildren(element)
    if not element.valid then
        return
    end
    for ____, child in ipairs(element.children) do
        ____exports.destroy(child, false)
    end
    element.clear()
end
local guiEventNames = {
    on_gui_click = true,
    on_gui_confirmed = true,
    on_gui_text_changed = true,
    on_gui_checked_state_changed = true,
    on_gui_selection_state_changed = true,
    on_gui_elem_changed = true,
    on_gui_opened = true,
    on_gui_closed = true,
    on_gui_value_changed = true,
    on_gui_location_changed = true,
    on_gui_selected_tab_changed = true,
    on_gui_switch_state_changed = true,
    on_gui_hover = true,
    on_gui_leave = true
}
for name in pairs(guiEventNames) do
    local id = defines.events[name]
    Events.on(
        id,
        function(e)
            local element = e.element
            if not element then
                return
            end
            local instance = getInstance(element)
            if not instance then
                return
            end
            local event = instance.events[name]
            if event then
                protectedAction(event.invoke, event, e)
            end
        end
    )
end
function ____exports.cleanGuiInstances()
    local count = 0
    for ____, data in pairs(global.players) do
        for ____, instance in pairs(data.guiElements) do
            local element = instance.element
            if not element.valid then
                ____exports.destroy(element)
                count = count + 1
            end
        end
    end
    return count
end
if script.active_mods.debugadapter ~= nil then
    commands.add_command(
        "clean-gui-instances",
        "",
        function()
            local count = ____exports.cleanGuiInstances()
            if count > 0 then
                game.print(("found " .. tostring(count)) .. " invalid gui elements")
            else
                game.print("No improperly destroyed GUI elements found")
            end
        end
    )
end
Migrations.fromAny(____exports.cleanGuiInstances)
return ____exports
