--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local meta
local ____position = require("lib.geometry.position")
local Pos = ____position.Pos
local floor = math.floor
local ceil = math.ceil
local setmetatable = _G.setmetatable
local BBox = setmetatable(
    {},
    {__call = function(____, left_top, right_bottom)
        return setmetatable({left_top = left_top, right_bottom = right_bottom}, meta)
    end}
)
do
    local max = math.max
    local min = math.min
    function BBox.from(data)
        return setmetatable({left_top = data.left_top, right_bottom = data.right_bottom}, meta)
    end
    function BBox.load(data)
        return setmetatable(data, meta)
    end
    function BBox.coords(lx, ly, rx, ry)
        return BBox({x = lx, y = ly}, {x = rx, y = ry})
    end
    function BBox.around(point, radius)
        return BBox({x = point.x - radius, y = point.y - radius}, {x = point.x + radius, y = point.y + radius})
    end
    function BBox.normalize(box)
        return BBox(
            Pos.normalize(box.left_top or box[1]),
            Pos.normalize(box.right_bottom or box[2])
        )
    end
    function BBox.empty()
        local pos = {x = 0, y = 0}
        return BBox(pos, pos)
    end
    function BBox.translate(box, amount)
        local ____box_0 = box
        local left_top = ____box_0.left_top
        local right_bottom = ____box_0.right_bottom
        local ____amount_1 = amount
        local bx = ____amount_1.x
        local by = ____amount_1.y
        return BBox({x = left_top.x + bx, y = left_top.y + by}, {x = right_bottom.x + bx, y = right_bottom.y + by})
    end
    function BBox.translateNegative(box, amount)
        local ____box_2 = box
        local left_top = ____box_2.left_top
        local right_bottom = ____box_2.right_bottom
        local ____amount_3 = amount
        local bx = ____amount_3.x
        local by = ____amount_3.y
        return BBox({x = left_top.x - bx, y = left_top.y - by}, {x = right_bottom.x - bx, y = right_bottom.y - by})
    end
    function BBox.size(box)
        local ____box_4 = box
        local left_top = ____box_4.left_top
        local right_bottom = ____box_4.right_bottom
        return Pos(right_bottom.x - left_top.x, right_bottom.y - left_top.y)
    end
    function BBox.roundTile(box)
        local ____box_5 = box
        local left_top = ____box_5.left_top
        local right_bottom = ____box_5.right_bottom
        return BBox(
            {
                x = floor(left_top.x),
                y = floor(left_top.y)
            },
            {
                x = ceil(right_bottom.x),
                y = ceil(right_bottom.y)
            }
        )
    end
    function BBox.roundChunk(box)
        local ____box_6 = box
        local left_top = ____box_6.left_top
        local right_bottom = ____box_6.right_bottom
        return BBox(
            {
                x = floor(left_top.x / 32) * 32,
                y = floor(left_top.y / 32) * 32
            },
            {
                x = ceil(right_bottom.x / 32) * 32,
                y = ceil(right_bottom.y / 32) * 32
            }
        )
    end
    function BBox.scale(box, factor)
        local ____box_7 = box
        local left_top = ____box_7.left_top
        local right_bottom = ____box_7.right_bottom
        return BBox({x = left_top.x * factor, y = left_top.y * factor}, {x = right_bottom.x * factor, y = right_bottom.y * factor})
    end
    function BBox.scaleXY(box, factorX, factorY)
        local ____box_8 = box
        local left_top = ____box_8.left_top
        local right_bottom = ____box_8.right_bottom
        return BBox({x = left_top.x * factorX, y = left_top.y * factorY}, {x = right_bottom.x * factorX, y = right_bottom.y * factorY})
    end
    function BBox.expand(box, amount)
        local ____box_9 = box
        local left_top = ____box_9.left_top
        local right_bottom = ____box_9.right_bottom
        return BBox({x = left_top.x - amount, y = left_top.y - amount}, {x = right_bottom.x + amount, y = right_bottom.y + amount})
    end
    function BBox.center(box)
        local ____box_10 = box
        local left_top = ____box_10.left_top
        local right_bottom = ____box_10.right_bottom
        return Pos((left_top.x + right_bottom.x) / 2, (left_top.y + right_bottom.y) / 2)
    end
    function BBox.rotateAboutOrigin(box, direction)
        if direction == nil or direction == defines.direction.north then
            return BBox.from(box)
        end
        local ____box_11 = box
        local left_top = ____box_11.left_top
        local right_bottom = ____box_11.right_bottom
        local ____left_top_12 = left_top
        local lx = ____left_top_12.x
        local ly = ____left_top_12.y
        local ____right_bottom_13 = right_bottom
        local rx = ____right_bottom_13.x
        local ry = ____right_bottom_13.y
        if direction == defines.direction.south then
            return BBox({x = -rx, y = -ry}, {x = -lx, y = -ly})
        end
        if direction == defines.direction.west then
            return BBox({x = ly, y = -rx}, {x = ry, y = -lx})
        end
        if direction == defines.direction.east then
            return BBox({x = -ry, y = lx}, {x = -ly, y = rx})
        end
        return BBox.rotateAboutOrigin(box, (direction + 7) % 8)
    end
    function BBox.intersect(box1, box2)
        local ____box1_14 = box1
        local left_top = ____box1_14.left_top
        local right_bottom = ____box1_14.right_bottom
        local ____box2_15 = box2
        local lt2 = ____box2_15.left_top
        local rb2 = ____box2_15.right_bottom
        return BBox.coords(
            max(left_top.x, lt2.x),
            max(left_top.y, lt2.y),
            min(right_bottom.x, rb2.x),
            min(right_bottom.y, rb2.y)
        )
    end
    function BBox.iterateTiles(box)
        local ____box_16 = box
        local left_top = ____box_16.left_top
        local right_bottom = ____box_16.right_bottom
        local startX = left_top.x
        local x2 = right_bottom.x
        local y2 = right_bottom.y
        local x = startX
        local y = left_top.y
        return function()
            if y >= y2 then
                return
            end
            local retX = x
            local retY = y
            x = x + 1
            if x >= x2 then
                x = startX
                y = y + 1
            end
            return retX, retY
        end
    end
    function BBox.equals(box1, box2)
        local ____box1_17 = box1
        local left_top = ____box1_17.left_top
        local right_bottom = ____box1_17.right_bottom
        local ____box2_18 = box2
        local lt2 = ____box2_18.left_top
        local rb2 = ____box2_18.right_bottom
        return left_top.x == lt2.x and left_top.y == lt2.y and right_bottom.x == rb2.x and right_bottom.y == rb2.y
    end
    function BBox.isCenteredSquare(box)
        local ____box_19 = box
        local left_top = ____box_19.left_top
        local right_bottom = ____box_19.right_bottom
        return left_top.x == left_top.y and right_bottom.x == right_bottom.y and left_top.x == -right_bottom.x
    end
    function BBox.isCenteredRectangle(box)
        local ____box_20 = box
        local left_top = ____box_20.left_top
        local right_bottom = ____box_20.right_bottom
        return left_top.x == -right_bottom.x and left_top.y == -right_bottom.y
    end
    function BBox.contains(box, point)
        local ____box_21 = box
        local left_top = ____box_21.left_top
        local right_bottom = ____box_21.right_bottom
        return point.x >= left_top.x and point.x <= right_bottom.x and point.y >= left_top.y and point.y <= right_bottom.y
    end
    function BBox.intersectsFully(box, other)
        local ____box_22 = box
        local left_top = ____box_22.left_top
        local right_bottom = ____box_22.right_bottom
        local ____other_23 = other
        local lt2 = ____other_23.left_top
        local rb2 = ____other_23.right_bottom
        return left_top.x < rb2.x and right_bottom.x > lt2.x and left_top.y < rb2.y and right_bottom.y > lt2.y
    end
    function BBox.asArray(box)
        local ____box_24 = box
        local left_top = ____box_24.left_top
        local right_bottom = ____box_24.right_bottom
        return {left_top, right_bottom}
    end
end
meta = {
    __index = BBox,
    __tostring = function(self)
        local left_top = self.left_top
        local right_bottom = self.right_bottom
        return ((((((("{(" .. tostring(left_top.x)) .. ", ") .. tostring(left_top.y)) .. "), (") .. tostring(right_bottom.x)) .. ", ") .. tostring(right_bottom.y)) .. ")}"
    end
}
____exports.BBox = BBox
return ____exports
