--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local meta
local util = require("util")
local setmetatable = _G.setmetatable
local _floor = math.floor
local _ceil = math.ceil
local Pos = setmetatable(
    {},
    {__call = function(____, x, y)
        return setmetatable({x = x, y = y}, meta)
    end}
)
do
    local sqrt = math.sqrt
    function Pos.from(position)
        return setmetatable({x = position.x, y = position.y}, meta)
    end
    function Pos.load(position)
        return setmetatable(position, meta)
    end
    function Pos.normalize(p)
        return Pos(p.x or p[1], p.y or p[2])
    end
    function Pos.plus(pos1, pos2)
        return Pos(pos1.x + pos2.x, pos1.y + pos2.y)
    end
    function Pos.add(pos, x, y)
        return Pos(pos.x + x, pos.y + y)
    end
    function Pos.minus(pos1, pos2)
        return Pos(pos1.x - pos2.x, pos1.y - pos2.y)
    end
    function Pos.times(pos1, factor)
        return Pos(pos1.x * factor, pos1.y * factor)
    end
    function Pos.div(pos1, factor)
        return Pos(pos1.x / factor, pos1.y / factor)
    end
    function Pos.emul(pos1, pos2)
        return Pos(pos1.x * pos2.x, pos1.y * pos2.y)
    end
    function Pos.ediv(pos1, pos2)
        return Pos(pos1.x / pos2.x, pos1.y / pos2.y)
    end
    function Pos.floor(pos)
        return Pos(
            _floor(pos.x),
            _floor(pos.y)
        )
    end
    function Pos.ceil(pos)
        return Pos(
            _ceil(pos.x),
            _ceil(pos.y)
        )
    end
    function Pos.length(pos)
        return sqrt(pos.x * pos.x + pos.y * pos.y)
    end
    function Pos.equals(pos1, pos2)
        return pos1.x == pos2.x and pos1.y == pos2.y
    end
    function Pos.isZero(pos)
        return pos.x == 0 and pos.y == 0
    end
    function Pos.rotateAboutOrigin(pos, direction)
        if direction == nil or direction == defines.direction.north then
            return Pos.from(pos)
        end
        if direction == defines.direction.south then
            return Pos(-pos.x, -pos.y)
        end
        if direction == defines.direction.west then
            return Pos(pos.y, -pos.x)
        end
        if direction == defines.direction.east then
            return Pos(-pos.y, pos.x)
        end
        error("invalid direction: " .. defines.direction[direction])
    end
    function Pos.asArray(pos1)
        return {pos1.x, pos1.y}
    end
    function Pos.applyTransformation(pos, flipHorizontal, flipVertical, rotation)
        local x = pos.x
        local y = pos.y
        if flipHorizontal then
            x = -x
        end
        if flipVertical then
            y = -y
        end
        return Pos.rotateAboutOrigin({x = x, y = y}, rotation)
    end
end
meta = {__index = Pos, __tostring = util.positiontostr}
____exports.Pos = Pos
return ____exports
