local ____lualib = require("lualib_bundle")
local __TS__ArrayFilter = ____lualib.__TS__ArrayFilter
local __TS__ArrayMap = ____lualib.__TS__ArrayMap
local ____exports = {}
local ____Events = require("lib.Events")
local Events = ____Events.Events
function ____exports.formatVersion(version)
    local parts = {}
    for v in string.gmatch(version, "%d+") do
        parts[#parts + 1] = string.format("%02d", v)
    end
    return table.concat(parts, ".")
end
local function lt(a, b)
    if a.prio ~= b.prio then
        return a.prio < b.prio
    end
    if a.version ~= b.version then
        return a.version < b.version
    end
    return a.order < b.order
end
____exports.Migrations = {}
local Migrations = ____exports.Migrations
do
    local order = 0
    local migrations = {}
    --- Runs when migrating from a version earlier than the specified version.
    function Migrations.to(version, func)
        local ____migrations_2 = migrations
        local ____exports_formatVersion_result_1 = ____exports.formatVersion(version)
        local ____order_0 = order
        order = ____order_0 + 1
        ____migrations_2[#____migrations_2 + 1] = {prio = 9, version = ____exports_formatVersion_result_1, order = ____order_0, func = func}
    end
    --- Runs both during on_init and from an earlier version.
    function Migrations.since(version, func)
        Events.on_init(func)
        Migrations.to(version, func)
    end
    function Migrations.early(version, func)
        local ____migrations_5 = migrations
        local ____exports_formatVersion_result_4 = ____exports.formatVersion(version)
        local ____order_3 = order
        order = ____order_3 + 1
        ____migrations_5[#____migrations_5 + 1] = {prio = 8, version = ____exports_formatVersion_result_4, order = ____order_3, func = func}
    end
    function Migrations.priority(prio, version, func)
        local ____migrations_9 = migrations
        local ____prio_7 = prio
        local ____exports_formatVersion_result_8 = ____exports.formatVersion(version)
        local ____order_6 = order
        order = ____order_6 + 1
        ____migrations_9[#____migrations_9 + 1] = {prio = ____prio_7, version = ____exports_formatVersion_result_8, order = ____order_6, func = func}
    end
    --- Runs during any migration from an earlier version.
    function Migrations.fromAny(func)
        Migrations.to(script.active_mods[script.mod_name], func)
    end
    function Migrations._prepareMock()
        assert(game and script.active_mods["factorio-test"], "should not mock until game loaded")
        migrations = {}
    end
    function Migrations.doMigrations(oldVersion)
        local formattedOldVersion = ____exports.formatVersion(oldVersion)
        local availableMigrations = __TS__ArrayFilter(
            migrations,
            function(____, m) return formattedOldVersion < m.version end
        )
        if #availableMigrations == 0 then
            return
        end
        local allVersions = __TS__ArrayMap(
            availableMigrations,
            function(____, m) return m.version end
        )
        log("Running migrations for versions: " .. table.concat(allVersions, ", "))
        table.sort(availableMigrations, lt)
        for ____, migration in ipairs(availableMigrations) do
            migration:func()
        end
    end
    function Migrations.setMigrationsHook()
        Events.on_configuration_changed(function(data)
            local thisChange = data.mod_changes[script.mod_name]
            if not thisChange then
                return
            end
            local oldVersion = thisChange.old_version
            if oldVersion then
                Migrations.doMigrations(oldVersion)
            end
        end)
    end
end
return ____exports
