local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__Class = ____lualib.__TS__Class
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local __TS__SparseArrayNew = ____lualib.__TS__SparseArrayNew
local __TS__SparseArrayPush = ____lualib.__TS__SparseArrayPush
local __TS__SparseArraySpread = ____lualib.__TS__SparseArraySpread
local ____exports = {}
local ____registry = require("lib.registry")
local Registry = ____registry.Registry
function ____exports.registerFunctionsCustomPrefix(prefix, functions)
    for name, func in pairs(functions) do
        ____exports.Functions:registerAs(prefix .. name, func)
    end
end
local registeredClasses = {}
local function registerClass(name, item)
    script.register_metatable(name, item.prototype)
    if registeredClasses[item] ~= nil then
        error(("Class " .. name) .. " is already registered")
    end
    registeredClasses[item] = true
    local prototype = item.prototype
    rawset(prototype, "__call", prototype.__call)
    for key, value in pairs(item) do
        if type(value) == "function" and type(key) == "string" then
            ____exports.Functions:registerAs((name .. ".") .. key, value)
        end
    end
end
--- Decorator for {@link registerClass}.
function ____exports.RegisterClass(name)
    return function(____, _class) return registerClass(name, _class) end
end
function ____exports.assertIsRegisteredClass(item)
    if not (registeredClasses[item] ~= nil) then
        error((("Class " .. item.name) .. " is not registered: ") .. serpent.block(item))
    end
end
____exports.Functions = __TS__New(
    Registry,
    "function",
    function(func) return serpent.block(
        type(func) == "function" and debug.getinfo(func) or func,
        {nocode = true}
    ) end
)
function ____exports.registerFunctions(prefix, functions)
    ____exports.registerFunctionsCustomPrefix(prefix .. ":", functions)
end
local _nameToItem = ____exports.Functions:_nameToItem()
local FuncRef = __TS__Class()
FuncRef.name = "FuncRef"
function FuncRef.prototype.____constructor(self, func)
    self.func = func
    self.funcName = ____exports.Functions:nameOf(func)
end
function FuncRef.prototype.invoke(self, ...)
    return _nameToItem[self.funcName](...)
end
FuncRef = __TS__DecorateLegacy(
    {____exports.RegisterClass("FuncRef")},
    FuncRef
)
--- Requires function to be registered. Resulting func takes "this" parameter.
function ____exports.funcRef(func)
    return __TS__New(FuncRef, func)
end
local Bound1 = __TS__Class()
Bound1.name = "Bound1"
function Bound1.prototype.____constructor(self, func, arg1)
    self.func = func
    self.arg1 = arg1
end
function Bound1.prototype.invoke(self, ...)
    return self.func:invoke(self.arg1, ...)
end
Bound1 = __TS__DecorateLegacy(
    {____exports.RegisterClass("FuncBound1")},
    Bound1
)
local Bound2 = __TS__Class()
Bound2.name = "Bound2"
function Bound2.prototype.____constructor(self, func, arg1, arg2)
    self.func = func
    self.arg1 = arg1
    self.arg2 = arg2
end
function Bound2.prototype.invoke(self, ...)
    return self.func:invoke(self.arg1, self.arg2, ...)
end
Bound2 = __TS__DecorateLegacy(
    {____exports.RegisterClass("FuncBound2")},
    Bound2
)
local Bound3 = __TS__Class()
Bound3.name = "Bound3"
function Bound3.prototype.____constructor(self, func, arg1, arg2, arg3)
    self.func = func
    self.arg1 = arg1
    self.arg2 = arg2
    self.arg3 = arg3
end
function Bound3.prototype.invoke(self, ...)
    return self.func:invoke(self.arg1, self.arg2, self.arg3, ...)
end
Bound3 = __TS__DecorateLegacy(
    {____exports.RegisterClass("FuncBound3")},
    Bound3
)
local Bound4 = __TS__Class()
Bound4.name = "Bound4"
function Bound4.prototype.____constructor(self, func, arg1, arg2, arg3, arg4)
    self.func = func
    self.arg1 = arg1
    self.arg2 = arg2
    self.arg3 = arg3
    self.arg4 = arg4
end
function Bound4.prototype.invoke(self, ...)
    return self.func:invoke(
        self.arg1,
        self.arg2,
        self.arg3,
        self.arg4,
        ...
    )
end
Bound4 = __TS__DecorateLegacy(
    {____exports.RegisterClass("FuncBound4")},
    Bound4
)
local BoundN = __TS__Class()
BoundN.name = "BoundN"
function BoundN.prototype.____constructor(self, func, ...)
    local args = {...}
    self.func = func
    self.args = args
end
function BoundN.prototype.invoke(self, ...)
    local ____self_1 = self.func
    local ____self_1_invoke_2 = ____self_1.invoke
    local ____array_0 = __TS__SparseArrayNew(table.unpack(self.args))
    __TS__SparseArrayPush(____array_0, ...)
    return ____self_1_invoke_2(
        ____self_1,
        __TS__SparseArraySpread(____array_0)
    )
end
BoundN = __TS__DecorateLegacy(
    {____exports.RegisterClass("FuncBoundN")},
    BoundN
)
local boundFuncClasses = {Bound1, Bound2, Bound3, Bound4}
function ____exports.bind(func, ...)
    local argCount = select("#", ...)
    local Class = boundFuncClasses[argCount] or BoundN
    if type(func) == "function" then
        func = ____exports.funcRef(func)
    end
    return __TS__New(Class, func, ...)
end
local KeyFunc = __TS__Class()
KeyFunc.name = "KeyFunc"
function KeyFunc.prototype.____constructor(self, instance, key)
    self.instance = instance
    self.key = key
end
function KeyFunc.prototype.invoke(self, ...)
    local instance = self.instance
    local fn = instance[self.key]
    if fn == nil then
        error(((((("Function with name " .. tostring(self.key)) .. " does not exist on ") .. tostring(self.instance)) .. "\n") .. ("Block: " .. serpent.block(self.instance, {maxlevel = 1})) .. "\n") .. "Metatable: " .. serpent.block(
            getmetatable(self.instance),
            {maxlevel = 1}
        ))
    end
    return fn(instance, ...)
end
KeyFunc = __TS__DecorateLegacy(
    {____exports.RegisterClass("KeyFunc")},
    KeyFunc
)
local NoSelfKeyFunc = __TS__Class()
NoSelfKeyFunc.name = "NoSelfKeyFunc"
function NoSelfKeyFunc.prototype.____constructor(self, instance, key)
    self.instance = instance
    self.key = key
end
function NoSelfKeyFunc.prototype.invoke(self, ...)
    return self.instance[self.key](...)
end
NoSelfKeyFunc = __TS__DecorateLegacy(
    {____exports.RegisterClass("NoSelfKeyFunc")},
    NoSelfKeyFunc
)
--- Instance bind. The single parameter passed must be a property/element access call, and a registered func that calls the instance/key will be returned.
-- 
-- The TSTL compiler plugin will transform `ibind(this.foo)` to `ibind(this, "foo")`.
-- 
-- Calling the returned function will call `this.foo()`, with the provided arguments, with `this` set to the instance.
-- This relies on the value of `this` having a registered class (metatable) with the given function.
____exports.ibind = setmetatable(
    {},
    {__call = function(____, obj, key) return __TS__New(KeyFunc, obj, key) end}
)
____exports.ibindNoSelf = setmetatable(
    {},
    {__call = function(____, obj, key) return __TS__New(NoSelfKeyFunc, obj, key) end}
)
return ____exports
