local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local ____exports = {}
____exports.Registry = __TS__Class()
local Registry = ____exports.Registry
Registry.name = "Registry"
function Registry.prototype.____constructor(self, itemName, getDebugDescription)
    self.itemName = itemName
    self.getDebugDescription = getDebugDescription
    self.nameToItem = {}
    self.itemToName = {}
end
function Registry.prototype.registerAs(self, name, item)
    if game ~= nil then
        error("This operation must only be done during script load.")
    end
    local existingItem = self.nameToItem[name]
    if existingItem then
        error((((self.itemName .. " with the name \"") .. name) .. "\" is already registered, existing is: ") .. self.getDebugDescription(existingItem))
    end
    local existingName = self.itemToName[item]
    if existingName then
        error((((self.itemName .. " registered with different names, existing is: ") .. existingName) .. ", tried to register again as ") .. name)
    end
    self.nameToItem[name] = item
    self.itemToName[item] = name
end
function Registry.prototype.get(self, name)
    return self.nameToItem[name] or error((("could not find " .. self.itemName) .. " with name ") .. name)
end
function Registry.prototype._nameToItem(self)
    return self.nameToItem
end
function Registry.prototype.nameOf(self, item)
    return self.itemToName[item] or error((("The given " .. self.itemName) .. " was not registered: ") .. self.getDebugDescription(item))
end
return ____exports
