--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local rendering = _G.rendering
local setterKeys = {
    time_to_live = true,
    forces = true,
    players = true,
    visible = true,
    draw_on_ground = true,
    only_in_alt_mode = true,
    use_target_orientation = true,
    color = true,
    width = true,
    dash_length = true,
    gap_length = true,
    orientation = true,
    scale = true,
    text = true,
    font = true,
    scale_with_zoom = true,
    use_rich_text = true,
    filled = true,
    radius = true,
    max_radius = true,
    min_radius = true,
    start_angle = true,
    angle = true,
    sprite = true,
    x_scale = true,
    y_scale = true,
    render_layer = true,
    oriented_offset = true,
    intensity = true,
    minimum_darkness = true,
    oriented = true,
    animation = true,
    animation_speed = true,
    animation_offset = true
}
local getterKeys = {
    type = true,
    surface = true,
    time_to_live = true,
    forces = true,
    players = true,
    visible = true,
    draw_on_ground = true,
    only_in_alt_mode = true,
    use_target_orientation = true,
    color = true,
    width = true,
    from = true,
    to = true,
    dash_length = true,
    gap_length = true,
    target = true,
    orientation = true,
    scale = true,
    text = true,
    font = true,
    alignment = true,
    vertical_alignment = true,
    scale_with_zoom = true,
    use_rich_text = true,
    filled = true,
    radius = true,
    left_top = true,
    right_bottom = true,
    max_radius = true,
    min_radius = true,
    start_angle = true,
    angle = true,
    vertices = true,
    sprite = true,
    x_scale = true,
    y_scale = true,
    render_layer = true,
    orientation_target = true,
    oriented_offset = true,
    intensity = true,
    minimum_darkness = true,
    oriented = true,
    animation = true,
    animation_speed = true,
    animation_offset = true
}
local otherSetterKeys = {
    set_from = true,
    set_to = true,
    set_dashes = true,
    set_target = true,
    set_alignment = true,
    set_vertical_alignment = true,
    set_left_top = true,
    set_right_bottom = true,
    set_corners = true,
    set_vertices = true,
    set_orientation_target = true
}
local function getKey(key)
    local success, value = pcall(function() return rendering[key] end)
    if success then
        return value
    end
end
local setters = {}
for key in pairs(setterKeys) do
    setters[key] = getKey("set_" .. key)
end
local getters = {}
for key in pairs(getterKeys) do
    getters[key] = getKey("get_" .. key)
end
getters.valid = rendering.is_valid
getters.destroy = function(id) return function()
    rendering.destroy(id)
end end
local otherProps = {}
for key in pairs(otherSetterKeys) do
    local set = rendering[key]
    otherProps[key] = function(self, ...)
        set(self.id, ...)
    end
end
otherProps.object_name = "_RenderObj"
local metatable = {
    __index = function(self, key)
        local getter = getters[key]
        if getter ~= nil then
            return getter(self.id)
        end
        return otherProps[key]
    end,
    __newindex = function(self, key, value)
        local setter = setters[key]
        if setter ~= nil then
            setter(self.id, value)
        else
            error(key .. " not in render object")
        end
    end
}
script.register_metatable("render obj", metatable)
function ____exports.default(____type, params)
    local id = rendering["draw_" .. ____type](params)
    return setmetatable({id = id}, metatable)
end
function ____exports.destroyAllRenders()
    for ____, id in ipairs(rendering.get_all_ids(script.mod_name)) do
        rendering.destroy(id)
    end
end
return ____exports
