local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local ____exports = {}
local stepTask, renderTaskGui, destroyTaskGui, updateTaskGui, CurrentTaskGui, CurrentTaskGuiName
local ____Events = require("lib.Events")
local Events = ____Events.Events
local ____factoriojsx = require("lib.factoriojsx.index")
local Component = ____factoriojsx.Component
local destroy = ____factoriojsx.destroy
local FactorioJsx = ____factoriojsx.FactorioJsx
local getComponentInstance = ____factoriojsx.getComponentInstance
local renderNamed = ____factoriojsx.renderNamed
local ____components = require("lib.factoriojsx.components.index")
local HorizontalPusher = ____components.HorizontalPusher
local ____protected_2Daction = require("lib.protected-action")
local protectedAction = ____protected_2Daction.protectedAction
local ____references = require("lib.references")
local funcRef = ____references.funcRef
local RegisterClass = ____references.RegisterClass
local registerFunctions = ____references.registerFunctions
function stepTask(task)
    task:step()
    return true
end
function ____exports.runEntireTask(task)
    while not task:isDone() do
        local success = protectedAction(stepTask, task)
        if not success then
            task:cancel()
            break
        end
    end
end
function renderTaskGui(task)
    for ____, player in pairs(game.players) do
        renderNamed(
            FactorioJsx.createElement(CurrentTaskGui, {task = task}),
            player.gui.screen,
            CurrentTaskGuiName
        )
    end
end
function destroyTaskGui()
    for ____, player in pairs(game.players) do
        destroy(player.gui.screen[CurrentTaskGuiName])
    end
end
function updateTaskGui(task)
    for ____, player in pairs(game.players) do
        do
            local guiElement = player.gui.screen[CurrentTaskGuiName]
            if not guiElement then
                goto __continue52
            end
            local component = getComponentInstance(guiElement)
            if component ~= nil then
                component:update(task)
            end
        end
        ::__continue52::
    end
end
____exports.LoopTask = __TS__Class()
local LoopTask = ____exports.LoopTask
LoopTask.name = "LoopTask"
function LoopTask.prototype.____constructor(self, steps)
    self.steps = steps
    self.nextStep = 0
end
function LoopTask.prototype.step(self)
    if self:isDone() then
        return
    end
    local ____self_doStep_3 = self.doStep
    local ____self_0, ____nextStep_1 = self, "nextStep"
    local ____self_nextStep_2 = ____self_0[____nextStep_1]
    ____self_0[____nextStep_1] = ____self_nextStep_2 + 1
    ____self_doStep_3(self, ____self_nextStep_2)
    if self:isDone() then
        local ____opt_4 = self.done
        if ____opt_4 ~= nil then
            ____opt_4(self)
        end
    end
end
function LoopTask.prototype.isDone(self)
    return self.nextStep >= self.steps
end
function LoopTask.prototype.cancel(self)
end
function LoopTask.prototype.getNextStepTitle(self)
    if self:isDone() then
        return nil
    end
    return self:getTitleForStep(self.nextStep)
end
function LoopTask.prototype.getProgress(self)
    return self.nextStep / self.steps
end
____exports.EnumeratedItemsTask = __TS__Class()
local EnumeratedItemsTask = ____exports.EnumeratedItemsTask
EnumeratedItemsTask.name = "EnumeratedItemsTask"
function EnumeratedItemsTask.prototype.____constructor(self, tasks)
    self.tasks = tasks
    self.nextIndex = 0
end
function EnumeratedItemsTask.prototype.step(self)
    if self:isDone() then
        return
    end
    local ____self_doTask_10 = self.doTask
    local ____self_tasks_9 = self.tasks
    local ____self_6, ____nextIndex_7 = self, "nextIndex"
    local ____self_nextIndex_8 = ____self_6[____nextIndex_7]
    ____self_6[____nextIndex_7] = ____self_nextIndex_8 + 1
    ____self_doTask_10(self, ____self_tasks_9[____self_nextIndex_8 + 1])
    if self:isDone() then
        local ____opt_11 = self.done
        if ____opt_11 ~= nil then
            ____opt_11(self)
        end
    end
end
function EnumeratedItemsTask.prototype.isDone(self)
    return self.nextIndex >= #self.tasks
end
function EnumeratedItemsTask.prototype.cancel(self)
end
function EnumeratedItemsTask.prototype.getNextStepTitle(self)
    if self:isDone() then
        return nil
    end
    return self:getTitleForTask(self.tasks[self.nextIndex + 1])
end
function EnumeratedItemsTask.prototype.getProgress(self)
    return self.nextIndex / #self.tasks
end
function ____exports.submitTask(task)
    if global.currentTask then
        global.currentTask:cancel()
    end
    if not game.tick_paused then
        global.currentTask = task
        renderTaskGui(task)
    else
        destroyTaskGui()
        global.currentTask = nil
        ____exports.runEntireTask(task)
    end
end
function ____exports.cancelCurrentTask()
    if global.currentTask then
        global.currentTask:cancel()
        global.currentTask = nil
        destroyTaskGui()
    end
end
function ____exports.isTaskRunning()
    return global.currentTask ~= nil
end
function ____exports.runEntireCurrentTask()
    if global.currentTask then
        ____exports.runEntireTask(global.currentTask)
        global.currentTask = nil
        destroyTaskGui()
    end
end
registerFunctions("task", {cancelCurrentTask = ____exports.cancelCurrentTask})
Events.on_tick(function()
    local task = global.currentTask
    if not task then
        return
    end
    local stepped = protectedAction(stepTask, task)
    if not stepped then
        task:cancel()
    end
    if stepped and not task:isDone() then
        updateTaskGui(task)
    else
        global.currentTask = nil
        destroyTaskGui()
    end
end)
CurrentTaskGui = __TS__Class()
CurrentTaskGui.name = "CurrentTaskGui"
__TS__ClassExtends(CurrentTaskGui, Component)
function CurrentTaskGui.prototype.render(self, ____bindingPattern0, context)
    local task
    task = ____bindingPattern0.task
    context:onMount(function() return self:update(task) end)
    return FactorioJsx.createElement(
        "frame",
        {
            caption = task:getTitle(),
            direction = "vertical",
            onCreate = function(____, e)
                local ____e_13 = e
                self.mainFrame = ____e_13
                return ____e_13
            end,
            auto_center = true,
            styleMod = {minimal_width = 500}
        },
        FactorioJsx.createElement("label", {name = "currentTaskTitle", visible = false}),
        FactorioJsx.createElement("progressbar", {name = "currentTaskProgress", value = 0, visible = false, styleMod = {horizontally_stretchable = true}}),
        FactorioJsx.createElement(
            "flow",
            {direction = "horizontal"},
            FactorioJsx.createElement(HorizontalPusher, nil),
            FactorioJsx.createElement(
                "button",
                {
                    caption = {"bp100.gui.tasks.cancel"},
                    on_gui_click = funcRef(____exports.cancelCurrentTask)
                }
            )
        )
    )
end
function CurrentTaskGui.prototype.update(self, task)
    if not self.mainFrame.valid then
        return
    end
    local ____this_15
    ____this_15 = task
    local ____opt_14 = ____this_15.getNextStepTitle
    local title = ____opt_14 and ____opt_14(____this_15)
    local titleElement = self.mainFrame.currentTaskTitle
    if title == nil then
        titleElement.visible = false
    else
        titleElement.visible = true
        titleElement.caption = title
    end
    local ____this_17
    ____this_17 = task
    local ____opt_16 = ____this_17.getProgress
    local progress = ____opt_16 and ____opt_16(____this_17)
    local progressElement = self.mainFrame.currentTaskProgress
    if progress == nil then
        progressElement.visible = false
    else
        progressElement.visible = true
        progressElement.value = progress
    end
end
CurrentTaskGui = __TS__DecorateLegacy(
    {RegisterClass("CurrentTaskGui")},
    CurrentTaskGui
)
CurrentTaskGuiName = "bp100:CurrentTaskGui"
return ____exports
