local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__New = ____lualib.__TS__New
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local __TS__ArrayIndexOf = ____lualib.__TS__ArrayIndexOf
local __TS__ObjectAssign = ____lualib.__TS__ObjectAssign
local __TS__ObjectValues = ____lualib.__TS__ObjectValues
local ____exports = {}
local ProjectActionsClass, ProjectUpdatesClass, WorldEntityUpdatesClass, StageImpl
local ____util = require("util")
local remove_from_list = ____util.remove_from_list
local ____blueprint_2Dsettings = require("blueprints.blueprint-settings")
local createNewBlueprintSettings = ____blueprint_2Dsettings.createNewBlueprintSettings
local ____ProjectContent = require("entity.ProjectContent")
local newProjectContent = ____ProjectContent.newProjectContent
local ____lib = require("lib.index")
local bind = ____lib.bind
local deepCopy = ____lib.deepCopy
local Events = ____lib.Events
local globalEvent = ____lib.globalEvent
local property = ____lib.property
local RegisterClass = ____lib.RegisterClass
local SimpleEvent = ____lib.SimpleEvent
local ____geometry = require("lib.geometry.index")
local BBox = ____geometry.BBox
local ____LazyLoad = require("lib.LazyLoad")
local LazyLoadClass = ____LazyLoad.LazyLoadClass
local ____migration = require("lib.migration")
local Migrations = ____migration.Migrations
local ____properties_2Dobj = require("utils.properties-obj")
local createdDiffedPropertyTableView = ____properties_2Dobj.createdDiffedPropertyTableView
local createEmptyPropertyOverrideTable = ____properties_2Dobj.createEmptyPropertyOverrideTable
local ____entity_2Dhighlights = require("project.entity-highlights")
local EntityHighlights = ____entity_2Dhighlights.EntityHighlights
local ____project_2Dactions = require("project.project-actions")
local ProjectActions = ____project_2Dactions.ProjectActions
local ____project_2Dupdates = require("project.project-updates")
local ProjectUpdates = ____project_2Dupdates.ProjectUpdates
local ____stage_2Dsurface = require("project.stage-surface")
local getStageAtSurface = ____stage_2Dsurface.getStageAtSurface
local ____surfaces = require("project.surfaces")
local createStageSurface = ____surfaces.createStageSurface
local destroySurface = ____surfaces.destroySurface
local ____world_2Dentity_2Dupdates = require("project.world-entity-updates")
local WorldEntityUpdates = ____world_2Dentity_2Dupdates.WorldEntityUpdates
local entity_filter_mode = defines.deconstruction_item.entity_filter_mode
local min = math.min
Events.on_init(function()
    global.nextProjectId = 1
    global.projects = {}
    global.surfaceIndexToStage = {}
end)
local GlobalProjectEvents = globalEvent()
____exports.ProjectEvents = GlobalProjectEvents
local UserProjectImpl = __TS__Class()
UserProjectImpl.name = "UserProjectImpl"
function UserProjectImpl.prototype.____constructor(self, id, name, initialNumStages)
    self.id = id
    self.content = newProjectContent()
    self.localEvents = __TS__New(SimpleEvent)
    self.defaultBlueprintSettings = createNewBlueprintSettings()
    self.landfillTile = property("landfill")
    self.valid = true
    self.stages = {}
    self.actions = ProjectActionsClass({project = self})
    self.updates = ProjectUpdatesClass({project = self})
    self.entityUpdates = WorldEntityUpdatesClass({project = self})
    self.name = property(name)
    self.stages = {}
    for i = 1, initialNumStages do
        local stage = StageImpl:create(
            self,
            i,
            "Stage " .. tostring(i)
        )
        self.stages[i] = stage
        if i <= 9 then
            stage.stageBlueprintSettings.icons:set({{
                index = 1,
                signal = {
                    type = "virtual",
                    name = "signal-" .. tostring(i)
                }
            }})
        end
    end
end
function UserProjectImpl.getDisplayName(id, name)
    return name ~= "" and name or ({"bp100.unnamed-project", id})
end
function UserProjectImpl.prototype.displayName(self)
    return self.name:map(bind(UserProjectImpl.getDisplayName, self.id))
end
function UserProjectImpl.create(self, name, initialNumStages)
    local ____UserProjectImpl_3 = UserProjectImpl
    local ____global_0, ____nextProjectId_1 = global, "nextProjectId"
    local ____global_nextProjectId_2 = ____global_0[____nextProjectId_1]
    ____global_0[____nextProjectId_1] = ____global_nextProjectId_2 + 1
    local project = __TS__New(____UserProjectImpl_3, ____global_nextProjectId_2, name, initialNumStages)
    UserProjectImpl:onProjectCreated(project)
    return project
end
function UserProjectImpl.prototype.getSurface(self, stageNum)
    local stage = self.stages[stageNum]
    return stage and stage.surface
end
function UserProjectImpl.prototype.getStage(self, stageNumber)
    return self.stages[stageNumber]
end
function UserProjectImpl.prototype.numStages(self)
    return #self.stages
end
function UserProjectImpl.prototype.lastStageFor(self, entity)
    if entity.lastStage ~= nil then
        return min(
            entity.lastStage,
            self:numStages()
        )
    end
    return self:numStages()
end
function UserProjectImpl.prototype.getAllStages(self)
    return self.stages
end
function UserProjectImpl.prototype.getStageName(self, stageNumber)
    return self.stages[stageNumber].name:get()
end
function UserProjectImpl.prototype.insertStage(self, stage)
    self:assertValid()
    assert(
        stage >= 1 and stage <= self:numStages() + 1,
        "Invalid new stage number"
    )
    local ____temp_4 = self:_getNewStageName(stage)
    local name = ____temp_4.name
    local strategy = ____temp_4.strategy
    local lastNumber = ____temp_4.lastNumber
    local previousLastNumber = ____temp_4.previousLastNumber
    local newStage = StageImpl:create(self, stage, name)
    local copyStage = self.stages[stage == 1 and 1 or stage - 1]
    local icons = deepCopy(copyStage.stageBlueprintSettings.icons:get() or ({}))
    if (strategy == "increment" or strategy == "decrement") and previousLastNumber and previousLastNumber >= 0 and previousLastNumber <= 9 and lastNumber and lastNumber >= 0 and lastNumber <= 9 then
        local lastIcon = self:findLastIcon(icons)
        if lastIcon ~= nil and lastIcon.signal.type == "virtual" and lastIcon.signal.name == "signal-" .. tostring(previousLastNumber) then
            lastIcon.signal.name = "signal-" .. tostring(lastNumber)
        end
    elseif strategy == "sublist" and #icons < 4 and lastNumber and lastNumber >= 0 and lastNumber <= 9 then
        icons[#icons + 1] = {
            index = #icons + 1,
            signal = {
                type = "virtual",
                name = "signal-" .. tostring(lastNumber)
            }
        }
    end
    newStage.stageBlueprintSettings.icons:set(icons[1] and icons)
    table.insert(self.stages, stage, newStage)
    for i = stage, #self.stages do
        self.stages[i].stageNumber = i
    end
    self.content:insertStage(stage)
    self:raiseEvent({type = "stage-added", project = self, stage = newStage})
    return newStage
end
function UserProjectImpl.prototype.findLastIcon(self, icons)
    local icon = icons[1]
    if icon == nil then
        return nil
    end
    for i = 2, #icons do
        if icons[i].index > icon.index then
            icon = icons[i]
        end
    end
    return icon
end
function UserProjectImpl.prototype.deleteStage(self, index)
    self:assertValid()
    local stage = self.stages[index]
    assert(stage ~= nil, "invalid stage number")
    if self:numStages() == 1 then
        self:delete()
        return
    end
    self:raiseEvent({type = "pre-stage-deleted", project = self, stage = stage})
    stage:_doDelete()
    table.remove(self.stages, index)
    for i = index, self:numStages() do
        self.stages[i].stageNumber = i
    end
    self.content:deleteStage(index)
    self:raiseEvent({type = "stage-deleted", project = self, stage = stage})
end
function UserProjectImpl.prototype.delete(self)
    if not self.valid then
        return
    end
    remove_from_list(global.projects, self)
    self.valid = false
    for ____, stage in pairs(self.stages) do
        stage:_doDelete()
    end
    self:raiseEvent({type = "project-deleted", project = self})
    self.localEvents:closeAll()
end
function UserProjectImpl.prototype._getNewStageName(self, stage)
    local otherStageNum = stage == 1 and 1 or stage - 1
    local otherStage = self.stages[otherStageNum]
    local previousName = otherStage.name:get()
    local name, numStr = string.match(previousName, "^(.*)(%d+)$")
    local num = tonumber(numStr)
    local foundNumber = name ~= nil and num ~= nil
    if foundNumber then
        local newNum = tonumber(numStr) + (stage == 1 and -1 or 1)
        if newNum >= 0 then
            local candidateName = name .. tostring(newNum)
            local ____opt_5 = self.stages[stage]
            local nextName = ____opt_5 and ____opt_5.name:get()
            if candidateName ~= nextName then
                return {name = candidateName, strategy = stage == 1 and "decrement" or "increment", lastNumber = newNum, previousLastNumber = num}
            end
        end
    end
    if stage == 1 then
        return {name = "New Stage", strategy = "none"}
    end
    local sep = (string.match(previousName, "^.*%d+([^%d]+)%d+$")) or (foundNumber and "." or " ")
    return {name = (previousName .. sep) .. "1", strategy = "sublist", lastNumber = 1}
end
function UserProjectImpl.prototype.raiseEvent(self, event)
    self.localEvents:raise(event)
    GlobalProjectEvents:raise(event)
end
function UserProjectImpl.prototype.assertValid(self)
    if not self.valid then
        error("Project is invalid")
    end
end
function UserProjectImpl.prototype.__tostring(self)
    return ((("<Project " .. tostring(self.id)) .. " \"") .. self.name:get()) .. "\">"
end
function UserProjectImpl.onProjectCreated(self, project)
    local ____global_projects_7 = global.projects
    ____global_projects_7[#____global_projects_7 + 1] = project
    GlobalProjectEvents:raise({type = "project-created", project = project})
end
UserProjectImpl = __TS__DecorateLegacy(
    {RegisterClass("Assembly")},
    UserProjectImpl
)
ProjectActionsClass = LazyLoadClass(
    "ProjectActions",
    function(____bindingPattern0)
        local project
        project = ____bindingPattern0.project
        return ProjectActions(project, project.updates, project.entityUpdates)
    end
)
ProjectUpdatesClass = LazyLoadClass(
    "ProjectUpdates",
    function(____bindingPattern0)
        local project
        project = ____bindingPattern0.project
        return ProjectUpdates(project, project.entityUpdates)
    end
)
WorldEntityUpdatesClass = LazyLoadClass(
    "WorldEntityUpdates",
    function(____bindingPattern0)
        local project
        project = ____bindingPattern0.project
        return WorldEntityUpdates(
            project,
            EntityHighlights(project)
        )
    end
)
function ____exports.createUserProject(name, initialNumStages)
    return UserProjectImpl:create(name, initialNumStages)
end
function ____exports._deleteAllProjects()
    for ____, project in ipairs(global.projects) do
        project:delete()
    end
    global.nextProjectId = 1
end
function ____exports.getAllProjects()
    return global.projects
end
local function swapProjects(index1, index2)
    local projects = global.projects
    local temp = projects[index1 + 1]
    projects[index1 + 1] = projects[index2 + 1]
    projects[index2 + 1] = temp
    GlobalProjectEvents:raise({type = "projects-reordered", project1 = projects[index1 + 1], project2 = projects[index2 + 1]})
end
function ____exports.moveProjectUp(project)
    local index = __TS__ArrayIndexOf(global.projects, project)
    if index <= 0 then
        return false
    end
    swapProjects(index - 1, index)
    return true
end
function ____exports.moveProjectDown(project)
    local index = __TS__ArrayIndexOf(global.projects, project)
    if index < 0 or index >= #global.projects - 1 then
        return false
    end
    swapProjects(index, index + 1)
    return true
end
local function createEmptyStageBlueprintSettings()
    return __TS__ObjectAssign(
        {},
        createEmptyPropertyOverrideTable({
            "autoLandfill",
            "useNextStageTiles",
            "stageLimit",
            "additionalWhitelist",
            "blacklist",
            "replaceInfinityEntitiesWithCombinators",
            "useModulePreloading",
            "positionOffset",
            "snapToGrid",
            "positionRelativeToGrid",
            "absoluteSnapping"
        }),
        {icons = property(nil)}
    )
end
StageImpl = __TS__Class()
StageImpl.name = "StageImpl"
function StageImpl.prototype.____constructor(self, project, surface, stageNumber, name)
    self.project = project
    self.surface = surface
    self.stageNumber = stageNumber
    self.valid = true
    self.stageBlueprintSettings = createEmptyStageBlueprintSettings()
    self.name = property(name)
    self.surfaceIndex = surface.index
    if project.id ~= 0 then
        global.surfaceIndexToStage[self.surfaceIndex] = self
    end
    self.actions = project.actions
end
function StageImpl.prototype.getBlueprintSettingsView(self)
    return __TS__ObjectAssign(
        {},
        createdDiffedPropertyTableView(self.project.defaultBlueprintSettings, self.stageBlueprintSettings),
        {icons = self.stageBlueprintSettings.icons}
    )
end
function StageImpl.prototype.getBlueprintBBox(self)
    return self.project.content:computeBoundingBox() or BBox.coords(-20, -20, 20, 20)
end
function StageImpl.create(self, project, stageNumber, name)
    local area = project.content:computeBoundingBox()
    local surface = createStageSurface(area)
    return __TS__New(
        StageImpl,
        project,
        surface,
        stageNumber,
        name
    )
end
function StageImpl.prototype.deleteInProject(self)
    if not self.valid then
        return
    end
    self.project:deleteStage(self.stageNumber)
end
function StageImpl.prototype._doDelete(self)
    if not self.valid then
        return
    end
    self.valid = false
    global.surfaceIndexToStage[self.surfaceIndex] = nil
    if self.surface.valid then
        destroySurface(self.surface)
    end
end
function StageImpl.prototype.__tostring(self)
    return ((((("<Stage " .. tostring(self.stageNumber)) .. " \"") .. self.name:get()) .. "\" of \"") .. self.project.name:get()) .. "\">"
end
StageImpl = __TS__DecorateLegacy(
    {RegisterClass("Stage")},
    StageImpl
)
Events.on_pre_surface_deleted(function(e)
    local stage = getStageAtSurface(e.surface_index)
    if stage ~= nil then
        stage:deleteInProject()
    end
end)
Migrations.priority(
    1,
    "0.23.0",
    function()
        global.projects = global.assemblies
        for ____, project in pairs(global.assemblies) do
            for ____, stage in ipairs(project:getAllStages()) do
                stage.project = project
                stage.assembly = nil
            end
        end
    end
)
Migrations.priority(
    2,
    "0.16.0",
    function()
        local oldProjects = global.projects
        global.projects = __TS__ObjectValues(oldProjects)
    end
)
Migrations.priority(
    2,
    "0.27.0",
    function()
        for ____, project in ipairs(global.projects) do
            project.actions = ProjectActionsClass({project = project})
            project.updates = ProjectUpdatesClass({project = project})
            project.entityUpdates = WorldEntityUpdatesClass({project = project})
            for ____, stage in ipairs(project:getAllStages()) do
                stage.actions = project.actions
            end
        end
    end
)
Migrations.early(
    "0.23.0",
    function()
        global.nextProjectId = global.nextAssemblyId
        global.nextAssemblyId = nil
    end
)
Migrations.early(
    "0.26.0",
    function()
        for ____, project in ipairs(global.projects) do
            project.displayName = nil
        end
    end
)
Migrations.to(
    "0.26.1",
    function()
        for ____, project in ipairs(global.projects) do
            for ____, stage in ipairs(project:getAllStages()) do
                stage.assembly = nil
            end
        end
    end
)
Migrations.to(
    "0.16.0",
    function()
        local function copyFromOldStageSettings(newSettings, oldSettings)
            newSettings.positionOffset:set(oldSettings.positionOffset)
            newSettings.snapToGrid:set(oldSettings.snapToGrid)
            newSettings.positionRelativeToGrid:set(oldSettings.positionRelativeToGrid)
            newSettings.absoluteSnapping:set(oldSettings.absoluteSnapping)
        end
        for ____, project in ipairs(global.projects) do
            local oldSettings = project.assemblyBlueprintSettings
            project.assemblyBlueprintSettings = nil
            local newSettings = createNewBlueprintSettings()
            project.defaultBlueprintSettings = newSettings
            newSettings.autoLandfill:set(oldSettings.autoLandfill:get())
            newSettings.useNextStageTiles:set(oldSettings.useNextStageTiles:get())
            newSettings.replaceInfinityEntitiesWithCombinators:set(oldSettings.replaceInfinityWithCombinators:get())
            local entityFilterMode = oldSettings.entityFilterMode:get()
            if entityFilterMode == entity_filter_mode.whitelist then
                newSettings.additionalWhitelist:set(oldSettings.entityFilters:get())
            elseif entityFilterMode == entity_filter_mode.blacklist then
                newSettings.blacklist:set(oldSettings.entityFilters:get())
            end
            local lastStageSettings = project:getStage(project:numStages()).blueprintSettings
            copyFromOldStageSettings(newSettings, lastStageSettings)
            for ____, stage in ipairs(project:getAllStages()) do
                local oldSettings = stage.blueprintSettings
                stage.blueprintSettings = nil
                stage.stageBlueprintSettings = createEmptyStageBlueprintSettings()
                local view = stage:getBlueprintSettingsView()
                copyFromOldStageSettings(view, oldSettings)
                stage.stageBlueprintSettings.icons:set(oldSettings.icons)
            end
        end
    end
)
Migrations.to(
    "0.23.1",
    function()
        for ____, project in ipairs(global.projects) do
            project.name:forceNotify()
        end
    end
)
Migrations.to(
    "0.25.0",
    function()
        for ____, project in ipairs(global.projects) do
            project.defaultBlueprintSettings.useModulePreloading = property(false)
            for ____, stage in ipairs(project:getAllStages()) do
                stage.stageBlueprintSettings.useModulePreloading = property(false)
            end
        end
    end
)
Migrations.to(
    "0.27.0",
    function()
        for ____, project in ipairs(global.projects) do
            project.landfillTile = property("landfill")
        end
    end
)
return ____exports
