--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____entity_2Dprototype_2Dinfo = require("entity.entity-prototype-info")
local OnEntityPrototypesLoaded = ____entity_2Dprototype_2Dinfo.OnEntityPrototypesLoaded
local ____lib = require("lib.index")
local assertNever = ____lib.assertNever
local ____geometry = require("lib.geometry.index")
local BBox = ____geometry.BBox
local ____create_2Dhighlight = require("project.create-highlight")
local createHighlightBox = ____create_2Dhighlight.createHighlightBox
local createSprite = ____create_2Dhighlight.createSprite
local highlightConfigs = {
    errorOutline = {type = "highlight", renderType = "not-allowed"},
    errorElsewhereIndicator = {
        type = "sprite",
        sprite = "utility/danger_icon",
        offset = {x = 0.2, y = 0.1},
        scale = 0.3,
        renderLayer = "entity-info-icon-above"
    },
    settingsRemnantHighlight = {type = "highlight", renderType = "train-visualization"},
    configChangedHighlight = {type = "highlight", renderType = "logistics"},
    configChangedLaterHighlight = {
        type = "sprite",
        sprite = "item/blueprint",
        offset = {x = 0.8, y = 0.1},
        scale = 0.5,
        renderLayer = "entity-info-icon-above"
    },
    stageDeleteHighlight = {
        type = "sprite",
        sprite = "item/deconstruction-planner",
        offset = {x = 0.8, y = 0.8},
        scale = 0.5,
        renderLayer = "entity-info-icon-above"
    }
}
local selectionBoxes
OnEntityPrototypesLoaded:addListener(function(info)
    local ____info_0 = info
    selectionBoxes = ____info_0.selectionBoxes
end)
local function createHighlight(entity, stage, surface, ____type)
    local config = highlightConfigs[____type]
    local existing = entity:getExtraEntity(____type, stage)
    local entityTarget = entity:getWorldOrPreviewEntity(stage)
    if existing and config.type == "sprite" and existing.valid and existing.object_name == "_RenderObj" and existing.target == entityTarget then
        return existing
    end
    local prototypeName = entity.firstValue.name
    local result
    if config.type == "highlight" then
        local renderType = config.renderType
        result = entityTarget and createHighlightBox(entityTarget, renderType)
    elseif config.type == "sprite" then
        local localSelectionBox = selectionBoxes[prototypeName]
        if localSelectionBox then
            local selectionBox = BBox.rotateAboutOrigin(localSelectionBox, entity.direction)
            local size = selectionBox:size()
            local relativePosition = size:emul(config.offset):plus(selectionBox.left_top)
            local target = entityTarget or relativePosition:plus(entity.position)
            local offset = entityTarget and ({relativePosition.x, relativePosition.y})
            local scale = config.scaleRelative and config.scale * (size.x + size.y) / 2 or config.scale
            result = createSprite({
                surface = surface,
                target = target,
                target_offset = offset,
                x_scale = scale,
                y_scale = scale,
                sprite = config.sprite,
                tint = config.tint,
                render_layer = config.renderLayer
            })
        end
    else
        assertNever(config)
    end
    entity:replaceExtraEntity(____type, stage, result)
    return result
end
local function removeHighlight(entity, stageNumber, ____type)
    entity:destroyExtraEntity(____type, stageNumber)
end
local function removeHighlightFromAllStages(entity, ____type)
    entity:destroyAllExtraEntities(____type)
end
---
-- @noSelf
function ____exports.EntityHighlights(project)
    local updateHighlight, updateErrorOutlines, updateStageDiffHighlights, updateStageDeleteIndicator, updateAllHighlights, deleteAllHighlights, makeSettingsRemnantHighlights, updateHighlightsOnReviveSettingsRemnant
    function updateHighlight(entity, stage, ____type, value)
        if value then
            return createHighlight(
                entity,
                stage,
                project:getSurface(stage),
                ____type
            )
        end
        removeHighlight(entity, stage, ____type)
        return nil
    end
    function updateErrorOutlines(entity)
        local hasErrorAnywhere = false
        for stage = entity.firstStage, project:lastStageFor(entity) do
            local hasError = entity:hasErrorAt(stage)
            updateHighlight(entity, stage, "errorOutline", hasError)
            if not hasErrorAnywhere then
                hasErrorAnywhere = hasError
            end
        end
        if not hasErrorAnywhere then
            entity:destroyAllExtraEntities("errorElsewhereIndicator")
        else
            for stage = 1, project:lastStageFor(entity) do
                local shouldHaveIndicator = not entity:hasErrorAt(stage)
                updateHighlight(entity, stage, "errorElsewhereIndicator", shouldHaveIndicator)
            end
        end
    end
    function updateStageDiffHighlights(entity)
        if not entity:hasStageDiff() then
            entity:destroyAllExtraEntities("configChangedHighlight")
            entity:destroyAllExtraEntities("configChangedLaterHighlight")
            return
        end
        local firstStage = entity.firstStage
        local lastStageWithHighlights = firstStage
        for stage = 1, project:lastStageFor(entity) do
            do
                local hasConfigChanged = entity:hasStageDiff(stage)
                local isUpgrade = hasConfigChanged and entity:getStageDiff(stage).name ~= nil
                local highlight = updateHighlight(entity, stage, "configChangedHighlight", hasConfigChanged)
                if highlight then
                    highlight.highlight_box_type = isUpgrade and "copy" or "logistics"
                end
                if not hasConfigChanged then
                    goto __continue21
                end
                local sprite = isUpgrade and "item/upgrade-planner" or "item/blueprint"
                do
                    while lastStageWithHighlights < stage do
                        local highlight = updateHighlight(entity, lastStageWithHighlights, "configChangedLaterHighlight", true)
                        highlight.sprite = sprite
                        lastStageWithHighlights = lastStageWithHighlights + 1
                    end
                end
            end
            ::__continue21::
        end
        if lastStageWithHighlights == firstStage then
            removeHighlightFromAllStages(entity, "configChangedLaterHighlight")
        else
            for i = lastStageWithHighlights, project:lastStageFor(entity) do
                removeHighlight(entity, i, "configChangedLaterHighlight")
            end
            for i = 1, firstStage - 1 do
                removeHighlight(entity, i, "configChangedLaterHighlight")
            end
        end
    end
    function updateStageDeleteIndicator(entity)
        entity:destroyAllExtraEntities("stageDeleteHighlight")
        if entity.lastStage ~= nil and entity.lastStage ~= entity.firstStage then
            local stage = entity.lastStage
            local surface = project:getSurface(stage)
            createHighlight(entity, stage, surface, "stageDeleteHighlight")
        end
    end
    function updateAllHighlights(entity)
        updateErrorOutlines(entity)
        updateStageDiffHighlights(entity)
        updateStageDeleteIndicator(entity)
    end
    function deleteAllHighlights(entity)
        for ____, ____type in ipairs({
            "errorOutline",
            "errorElsewhereIndicator",
            "settingsRemnantHighlight",
            "configChangedHighlight",
            "configChangedLaterHighlight",
            "stageDeleteHighlight"
        }) do
            entity:destroyAllExtraEntities(____type)
        end
    end
    function makeSettingsRemnantHighlights(entity)
        if not entity.isSettingsRemnant then
            return
        end
        for ____, ____type in ipairs({
            "errorOutline",
            "errorElsewhereIndicator",
            "settingsRemnantHighlight",
            "configChangedHighlight",
            "configChangedLaterHighlight",
            "stageDeleteHighlight"
        }) do
            entity:destroyAllExtraEntities(____type)
        end
        for stage = 1, project:lastStageFor(entity) do
            updateHighlight(entity, stage, "settingsRemnantHighlight", true)
        end
    end
    function updateHighlightsOnReviveSettingsRemnant(entity)
        if entity.isSettingsRemnant then
            return
        end
        entity:destroyAllExtraEntities("settingsRemnantHighlight")
        updateAllHighlights(entity)
    end
    return {updateAllHighlights = updateAllHighlights, deleteAllHighlights = deleteAllHighlights, makeSettingsRemnantHighlights = makeSettingsRemnantHighlights, updateHighlightsOnReviveSettingsRemnant = updateHighlightsOnReviveSettingsRemnant}
end
return ____exports
