local ____lualib = require("lualib_bundle")
local __TS__ArrayFindIndex = ____lualib.__TS__ArrayFindIndex
local __TS__ArrayFind = ____lualib.__TS__ArrayFind
local ____exports = {}
local clearToBeFastReplaced, tryFastReplace, isFastReplaceable, getInnerBlueprint, blueprintNeedsPreparation, fixOldBlueprint, prepareBlueprintForStagePaste, revertPreparedBlueprint, onPreBlueprintPasted, tryFixBlueprint, getInnerName, onEntityMarkerBuilt, manuallyConnectWires, manuallyConnectPoint, manuallyConnectCircuits, manuallyConnectNeighbours, flipSplitterPriority, editPassedValue, handleEntityMarkerBuilt, onLastEntityMarkerBuilt, transform, state, IsLastEntity, nameToType, twoDirectionTanks, rawset
local ____util = require("util")
local oppositedirection = ____util.oppositedirection
local ____create_2Dblueprint_2Dwith_2Dstage_2Dinfo = require("copy-paste.create-blueprint-with-stage-info")
local createBlueprintWithStageInfo = ____create_2Dblueprint_2Dwith_2Dstage_2Dinfo.createBlueprintWithStageInfo
local ____entity_2Dprototype_2Dinfo = require("entity.entity-prototype-info")
local areUpgradeableTypes = ____entity_2Dprototype_2Dinfo.areUpgradeableTypes
local getCompatibleNames = ____entity_2Dprototype_2Dinfo.getCompatibleNames
local getPrototypeRotationType = ____entity_2Dprototype_2Dinfo.getPrototypeRotationType
local isPreviewEntity = ____entity_2Dprototype_2Dinfo.isPreviewEntity
local OnEntityPrototypesLoaded = ____entity_2Dprototype_2Dinfo.OnEntityPrototypesLoaded
local ____ProjectEntity = require("entity.ProjectEntity")
local isWorldEntityProjectEntity = ____ProjectEntity.isWorldEntityProjectEntity
local ____lib = require("lib.index")
local assertNever = ____lib.assertNever
local mutableShallowCopy = ____lib.mutableShallowCopy
local ProtectedEvents = ____lib.ProtectedEvents
local ____geometry = require("lib.geometry.index")
local Pos = ____geometry.Pos
local ____selection_2Dtool = require("lib.selection-tool")
local addSelectionToolHandlers = ____selection_2Dtool.addSelectionToolHandlers
local ____player_2Dproject_2Ddata = require("project.player-project-data")
local getProjectPlayerData = ____player_2Dproject_2Ddata.getProjectPlayerData
local ____stage_2Dsurface = require("project.stage-surface")
local getStageAtSurface = ____stage_2Dsurface.getStageAtSurface
local ____undo = require("project.undo")
local onUndoReferenceBuilt = ____undo.onUndoReferenceBuilt
local registerGroupUndoAction = ____undo.registerGroupUndoAction
local registerUndoAction = ____undo.registerUndoAction
local registerUndoActionLater = ____undo.registerUndoActionLater
function clearToBeFastReplaced(player)
    local ____state_1 = state
    local toBeFastReplaced = ____state_1.toBeFastReplaced
    if toBeFastReplaced then
        local ____toBeFastReplaced_2 = toBeFastReplaced
        local stage = ____toBeFastReplaced_2.stage
        if stage.valid then
            local ____stage_3 = stage
            local stageNumber = ____stage_3.stageNumber
            stage.actions.onEntityDeleted(toBeFastReplaced, stageNumber, player)
            local ____toBeFastReplaced_4 = toBeFastReplaced
            local undergroundPairValue = ____toBeFastReplaced_4.undergroundPairValue
            if undergroundPairValue then
                stage.actions.onEntityDeleted(undergroundPairValue, stageNumber, player)
            end
        end
        state.toBeFastReplaced = nil
    end
end
function tryFastReplace(entity, stage, player)
    local ____state_9 = state
    local toBeFastReplaced = ____state_9.toBeFastReplaced
    if not toBeFastReplaced then
        return
    end
    local undergroundPairValue = toBeFastReplaced.undergroundPairValue
    if isFastReplaceable(toBeFastReplaced, entity) then
        stage.actions.onEntityPossiblyUpdated(entity, stage.stageNumber, toBeFastReplaced.direction, player)
        state.toBeFastReplaced = undergroundPairValue
        return true
    end
    if undergroundPairValue and isFastReplaceable(undergroundPairValue, entity) then
        stage.actions.onEntityPossiblyUpdated(entity, stage.stageNumber, toBeFastReplaced.direction, player)
        toBeFastReplaced.undergroundPairValue = nil
        return true
    end
    clearToBeFastReplaced(player)
end
function isFastReplaceable(old, next)
    return Pos.equals(old.position, next.position) and areUpgradeableTypes(old.name, next.name)
end
function getInnerBlueprint(stack)
    if not stack or not stack.valid_for_read then
        return nil
    end
    local ____type = stack.type
    if ____type == "blueprint" then
        return stack
    end
    if ____type == "blueprint-book" then
        local active = stack.active_index
        if not active then
            return nil
        end
        local innerStack = stack.get_inventory(defines.inventory.item_main)
        if not innerStack then
            return nil
        end
        local ____temp_10
        if active <= #innerStack then
            ____temp_10 = getInnerBlueprint(innerStack[active])
        else
            ____temp_10 = nil
        end
        return ____temp_10
    end
    return nil
end
function blueprintNeedsPreparation(stack)
    return stack.valid_for_read and stack.is_blueprint and stack.is_blueprint_setup() and stack.get_blueprint_entity_count() > 0
end
function fixOldBlueprint(entities)
    local firstEntityMarker = __TS__ArrayFindIndex(
        entities,
        function(____, e) return e.name == "bp100:entity-marker" end
    )
    for i = firstEntityMarker + 1, #entities do
        entities[i] = nil
    end
end
function prepareBlueprintForStagePaste(stack)
    if not blueprintNeedsPreparation(stack) then
        return
    end
    local entities = stack.get_blueprint_entities()
    if not entities then
        return
    end
    if stack.cost_to_build["bp100:entity-marker"] ~= nil then
        fixOldBlueprint(entities)
    end
    local numEntities = #entities
    local nextIndex = numEntities + 1
    for i = 1, numEntities do
        local entity = entities[i]
        local direction = entity.direction
        local name = entity.name
        local position = entity.position
        entities[nextIndex] = {
            entity_number = nextIndex,
            name = "bp100:entity-marker",
            direction = direction,
            position = position,
            tags = {referencedName = name, referencedLuaIndex = i}
        }
        nextIndex = nextIndex + 1
    end
    if nextIndex == numEntities + 1 then
        entities[nextIndex] = {entity_number = nextIndex, name = "bp100:entity-marker", position = {x = 0, y = 0}, tags = {}}
    end
    entities[#entities].tags[IsLastEntity] = true
    stack.set_blueprint_entities(entities)
    return entities, numEntities
end
function revertPreparedBlueprint(stack)
    local current = assert(state.currentBlueprintPaste)
    local entities = current.entities
    for i = #entities, current.originalNumEntities + 1, -1 do
        entities[i] = nil
    end
    stack.set_blueprint_entities(entities)
end
function onPreBlueprintPasted(player, stage, event)
    if not stage then
        tryFixBlueprint(player)
        return
    end
    local blueprint = getInnerBlueprint(player.cursor_stack)
    if not blueprint then
        player.print({"bp100.interaction.blueprint-not-handled"})
        return
    end
    local entities, numEntities = prepareBlueprintForStagePaste(blueprint)
    if entities ~= nil then
        local ____state_20 = state
        local ____stage_13 = stage
        local ____entities_14 = entities
        local ____temp_15 = {}
        local ____temp_16 = {}
        local ____numEntities_17 = numEntities
        local ____player_mod_settings_bp100_3Aupgrade_2Don_2Dpaste_value_18 = player.mod_settings["bp100:upgrade-on-paste"].value
        local ____temp_19 = event.flip_vertical ~= event.flip_horizontal
        local ____event_flip_vertical_11 = event.flip_vertical
        if ____event_flip_vertical_11 == nil then
            ____event_flip_vertical_11 = false
        end
        local ____event_flip_horizontal_12 = event.flip_horizontal
        if ____event_flip_horizontal_12 == nil then
            ____event_flip_horizontal_12 = false
        end
        ____state_20.currentBlueprintPaste = {
            stage = ____stage_13,
            entities = ____entities_14,
            knownLuaEntities = ____temp_15,
            needsManualConnections = ____temp_16,
            originalNumEntities = ____numEntities_17,
            allowPasteUpgrades = ____player_mod_settings_bp100_3Aupgrade_2Don_2Dpaste_value_18,
            isFlipped = ____temp_19,
            flipVertical = ____event_flip_vertical_11,
            flipHorizontal = ____event_flip_horizontal_12,
            direction = event.direction
        }
    end
end
function tryFixBlueprint(player)
    local blueprint = getInnerBlueprint(player.cursor_stack)
    if not blueprint then
        return
    end
    local entityCount = blueprint.get_blueprint_entity_count()
    if entityCount == 0 then
        return
    end
    local lastTags = blueprint.get_blueprint_entity_tag(entityCount, IsLastEntity)
    if lastTags ~= nil then
        local entities = blueprint.get_blueprint_entities()
        fixOldBlueprint(entities)
        blueprint.set_blueprint_entities(entities)
    end
end
function getInnerName(entity)
    if entity.type == "entity-ghost" then
        return entity.ghost_name
    end
    return entity.name
end
function onEntityMarkerBuilt(e, entity)
    local tags = e.tags or entity.tags
    if tags ~= nil then
        handleEntityMarkerBuilt(e, entity, tags)
        if tags[IsLastEntity] ~= nil then
            onLastEntityMarkerBuilt(e)
        end
    end
    entity.destroy()
end
function manuallyConnectWires(luaEntity, connections, sourceId, wireType)
    if not connections then
        return
    end
    local knownLuaEntities = state.currentBlueprintPaste.knownLuaEntities
    for ____, ____value in ipairs(connections) do
        local otherId = ____value.entity_id
        local circuit_id = ____value.circuit_id
        do
            local otherEntity = knownLuaEntities[otherId]
            if not otherEntity or not otherEntity.valid then
                goto __continue122
            end
            luaEntity.connect_neighbour({wire = wireType, target_entity = otherEntity, source_circuit_id = sourceId, target_circuit_id = circuit_id or 1})
        end
        ::__continue122::
    end
end
function manuallyConnectPoint(luaEntity, connection, sourceId)
    if not connection then
        return
    end
    manuallyConnectWires(luaEntity, connection.red, sourceId, defines.wire_type.red)
    manuallyConnectWires(luaEntity, connection.green, sourceId, defines.wire_type.green)
end
function manuallyConnectCircuits(luaEntity, connections)
    if not connections then
        return
    end
    manuallyConnectPoint(luaEntity, connections["1"], 1)
    manuallyConnectPoint(luaEntity, connections["2"], 2)
end
function manuallyConnectNeighbours(luaEntity, connections)
    if not connections or luaEntity.type ~= "electric-pole" then
        return
    end
    local knownLuaEntities = state.currentBlueprintPaste.knownLuaEntities
    for ____, otherId in ipairs(connections) do
        do
            local otherEntity = knownLuaEntities[otherId]
            if not otherEntity or otherEntity.type ~= "electric-pole" then
                goto __continue131
            end
            luaEntity.connect_neighbour(otherEntity)
        end
        ::__continue131::
    end
end
function flipSplitterPriority(entity)
    if entity.input_priority then
        entity.input_priority = entity.input_priority == "left" and "right" or "left"
    end
    if entity.output_priority then
        entity.output_priority = entity.output_priority == "left" and "right" or "left"
    end
end
function editPassedValue(entity, edit)
    local passedValue = mutableShallowCopy(entity)
    local ____opt_21 = passedValue.tags
    local stageInfoTags = ____opt_21 and ____opt_21.bp100
    if not (stageInfoTags and stageInfoTags.firstValue) then
        edit(passedValue)
    else
        edit(stageInfoTags.firstValue)
        if stageInfoTags and stageInfoTags.stageDiffs then
            for ____, value in pairs(stageInfoTags.stageDiffs) do
                edit(value)
            end
        end
    end
    return passedValue
end
function handleEntityMarkerBuilt(e, entity, tags)
    local referencedName = tags.referencedName
    if not referencedName then
        return
    end
    local bpState = state.currentBlueprintPaste
    local ____entity_27 = entity
    local position = ____entity_27.position
    local surface = ____entity_27.surface
    local luaEntities = entity.surface.find_entities_filtered({position = position, radius = 0, name = referencedName})
    local usedPasteUpgrade = false
    if not (next(luaEntities)) then
        if not bpState.allowPasteUpgrades then
            return
        end
        local compatible = getCompatibleNames(referencedName)
        if not compatible then
            return
        end
        luaEntities = surface.find_entities_filtered({position = position, radius = 0, name = compatible})
        if not (next(luaEntities)) then
            return
        end
        usedPasteUpgrade = true
    end
    local entityId = tags.referencedLuaIndex
    local value = bpState.entities[entityId]
    local passedValue = value
    local entityDir = entity.direction
    local valueName = value.name
    local ____type = nameToType[valueName]
    if ____type == "storage-tank" then
        if twoDirectionTanks[valueName] ~= nil then
            entityDir = (entityDir + (bpState.isFlipped and 2 or 0)) % 4
        end
    elseif ____type == "curved-rail" then
        local isDiagonal = (value.direction or 0) % 2 == 1 ~= bpState.isFlipped
        if isDiagonal then
            entityDir = (entityDir + 1) % 8
        end
    elseif ____type == "splitter" then
        if bpState.isFlipped then
            passedValue = editPassedValue(value, flipSplitterPriority)
        end
    elseif ____type == "inserter" then
        if passedValue.pickup_position or passedValue.drop_position then
            passedValue = editPassedValue(
                value,
                function(inserter)
                    if inserter.pickup_position then
                        inserter.pickup_position = transform(inserter.pickup_position, bpState.flipHorizontal, bpState.flipVertical, bpState.direction)
                    end
                    if inserter.drop_position then
                        inserter.drop_position = transform(inserter.drop_position, bpState.flipHorizontal, bpState.flipVertical, bpState.direction)
                    end
                end
            )
        end
    else
        local isDiagonal = (value.direction or 0) % 2 == 1
        if isDiagonal then
            entityDir = (entityDir + (bpState.isFlipped and 7 or 1)) % 8
        end
    end
    local luaEntity = __TS__ArrayFind(
        luaEntities,
        function(____, e) return not e.supports_direction or e.direction == entityDir end
    )
    if ____type == "underground-belt" then
        local valueType = value.type or "input"
        if luaEntity then
            if luaEntity.belt_to_ground_type ~= valueType then
                return
            end
        else
            entityDir = oppositedirection(entityDir)
            luaEntity = __TS__ArrayFind(
                luaEntities,
                function(____, e) return e.direction == entityDir and e.belt_to_ground_type ~= valueType end
            )
        end
        if not luaEntity then
            return
        end
    elseif not luaEntity then
        local pasteRotatableType = getPrototypeRotationType(referencedName)
        if pasteRotatableType == nil then
            return
        end
        if pasteRotatableType == 1 then
            luaEntity = luaEntities[1]
        elseif pasteRotatableType == 0 then
            local oppositeDir = oppositedirection(entityDir)
            luaEntity = __TS__ArrayFind(
                luaEntities,
                function(____, e) return e.direction == oppositeDir end
            )
        else
            assertNever(pasteRotatableType)
        end
        if not luaEntity then
            return
        end
    end
    rawset(luaEntity, "name", luaEntity.name)
    rawset(luaEntity, "type", ____type)
    if usedPasteUpgrade then
        bpState.usedPasteUpgrade = true
    end
    local stage = bpState.stage
    local projectEntity = stage.actions.onEntityPossiblyUpdated(
        luaEntity,
        stage.stageNumber,
        nil,
        e.player_index,
        passedValue
    )
    local neighbours = value.neighbours
    local connections = value.connections
    if not neighbours and not connections then
        return
    end
    if projectEntity ~= nil then
        if not luaEntity.valid then
            luaEntity = projectEntity:getWorldEntity(stage.stageNumber)
            if not luaEntity then
                return
            end
            local ____bpState_needsManualConnections_28 = bpState.needsManualConnections
            ____bpState_needsManualConnections_28[#____bpState_needsManualConnections_28 + 1] = entityId
        elseif luaEntity.type == "transport-belt" then
            local ____bpState_needsManualConnections_29 = bpState.needsManualConnections
            ____bpState_needsManualConnections_29[#____bpState_needsManualConnections_29 + 1] = entityId
        else
            stage.actions.onWiresPossiblyUpdated(luaEntity, stage.stageNumber, e.player_index)
        end
    end
    bpState.knownLuaEntities[entityId] = luaEntity
end
function onLastEntityMarkerBuilt(e)
    local ____state_currentBlueprintPaste_30 = state.currentBlueprintPaste
    local entities = ____state_currentBlueprintPaste_30.entities
    local knownLuaEntities = ____state_currentBlueprintPaste_30.knownLuaEntities
    local needsManualConnections = ____state_currentBlueprintPaste_30.needsManualConnections
    local usedPasteUpgrade = ____state_currentBlueprintPaste_30.usedPasteUpgrade
    local stage = ____state_currentBlueprintPaste_30.stage
    for ____, entityId in ipairs(needsManualConnections) do
        do
            local value = entities[entityId]
            local luaEntity = knownLuaEntities[entityId]
            if not luaEntity then
                goto __continue184
            end
            manuallyConnectNeighbours(luaEntity, value.neighbours)
            manuallyConnectCircuits(luaEntity, value.connections)
            stage.actions.onWiresPossiblyUpdated(luaEntity, stage.stageNumber, e.player_index)
        end
        ::__continue184::
    end
    local player = game.get_player(e.player_index)
    if usedPasteUpgrade then
        player.print({"bp100.interaction.paste-upgrade-applied"})
    end
    local blueprint = getInnerBlueprint(player.cursor_stack)
    revertPreparedBlueprint(assert(blueprint))
    state.currentBlueprintPaste = nil
end
transform = Pos.applyTransformation
local Events = ProtectedEvents
local function getStageAtEntity(entity)
    if entity.valid and isWorldEntityProjectEntity(entity) then
        return getStageAtSurface(entity.surface_index)
    end
end
local function getStageAtEntityOrPreview(entity)
    if entity.valid and (isWorldEntityProjectEntity(entity) or isPreviewEntity(entity)) then
        return getStageAtSurface(entity.surface_index)
    end
end
local function luaEntityCreated(entity, player)
    if not entity.valid then
        return
    end
    if getInnerName(entity) == "bp100:entity-marker" then
        entity.destroy()
        return
    end
    local stage = getStageAtSurface(entity.surface_index)
    if not stage then
        return
    end
    if isWorldEntityProjectEntity(entity) then
        stage.actions.onEntityCreated(entity, stage.stageNumber, player)
    end
end
local function luaEntityDeleted(entity, player)
    local stage = getStageAtEntity(entity)
    if stage then
        stage.actions.onEntityDeleted(entity, stage.stageNumber, player)
    end
end
local function luaEntityPossiblyUpdated(entity, player)
    local stage = getStageAtEntity(entity)
    if stage then
        stage.actions.onEntityPossiblyUpdated(entity, stage.stageNumber, nil, player)
    end
end
local function luaEntityMarkedForUpgrade(entity, player)
    local stage = getStageAtEntity(entity)
    if stage then
        stage.actions.onEntityMarkedForUpgrade(entity, stage.stageNumber, player)
    end
end
local function luaEntityDied(entity)
    local stage = getStageAtEntity(entity)
    if stage then
        stage.actions.onEntityDied(entity, stage.stageNumber)
    end
end
local function luaEntityRotated(entity, previousDirection, player)
    if not entity.valid then
        return
    end
    local stage = getStageAtSurface(entity.surface_index)
    if not stage then
        return
    end
    if isWorldEntityProjectEntity(entity) then
        stage.actions.onEntityRotated(entity, stage.stageNumber, previousDirection, player)
        return
    end
    if isPreviewEntity(entity) then
        entity.direction = previousDirection
        return
    end
end
local modName = script.mod_name
Events.script_raised_built(function(e)
    if e.mod_name ~= modName then
        luaEntityCreated(e.entity, nil)
    end
end)
Events.on_robot_built_entity(function(e) return luaEntityCreated(e.created_entity, nil) end)
Events.script_raised_revive(function(e) return luaEntityCreated(e.entity, nil) end)
Events.script_raised_destroy(function(e)
    if e.mod_name ~= modName then
        luaEntityDeleted(e.entity, nil)
    end
end)
Events.on_robot_mined_entity(function(e) return luaEntityDeleted(e.entity, nil) end)
Events.on_entity_died(function(e) return luaEntityDied(e.entity) end)
Events.on_entity_settings_pasted(function(e) return luaEntityPossiblyUpdated(e.destination, e.player_index) end)
Events.on_gui_closed(function(e)
    if e.entity then
        luaEntityPossiblyUpdated(e.entity, e.player_index)
    end
end)
Events.on_player_cursor_stack_changed(function(e)
    local player = game.get_player(e.player_index)
    local stage = getStageAtSurface(player.surface_index)
    if not stage then
        return
    end
    local selected = player.selected
    if selected and isWorldEntityProjectEntity(selected) and selected.get_module_inventory() ~= nil then
        luaEntityPossiblyUpdated(selected, e.player_index)
    end
end)
Events.on_player_rotated_entity(function(e) return luaEntityRotated(e.entity, e.previous_direction, e.player_index) end)
Events.on_marked_for_upgrade(function(e) return luaEntityMarkedForUpgrade(e.entity, e.player_index) end)
Events.on_init(function()
    local ____temp_0 = {}
    global.worldListenerState = ____temp_0
    state = ____temp_0
end)
Events.on_load(function()
    state = global.worldListenerState
end)
local function setToBeFastReplaced(entity, stage, player)
    local isUnderground = entity.type == "underground-belt"
    local oldValue = state.toBeFastReplaced
    local newValue = {
        name = entity.name,
        type = entity.type,
        position = entity.position,
        direction = entity.direction,
        surface = entity.surface,
        belt_to_ground_type = isUnderground and entity.belt_to_ground_type or nil,
        stage = stage
    }
    if isUnderground then
        if oldValue and oldValue.undergroundPair == entity then
            oldValue.undergroundPair = nil
            oldValue.undergroundPairValue = newValue
            return
        end
        newValue.undergroundPair = entity.neighbours
    end
    clearToBeFastReplaced(player)
    state.toBeFastReplaced = newValue
end
Events.on_pre_build(function(e)
    local player = game.get_player(e.player_index)
    state.currentBlueprintPaste = nil
    local surface = player.surface
    if player.is_cursor_blueprint() then
        local stage = getStageAtSurface(surface.index)
        onPreBlueprintPasted(player, stage, e)
        return
    end
    local item
    local cursorStack = player.cursor_stack
    if cursorStack and cursorStack.valid_for_read then
        item = cursorStack.prototype
    else
        item = player.cursor_ghost
    end
    if not item then
        return
    end
    state.lastPreBuild = {surface = surface, item = item.name, event = e}
    clearToBeFastReplaced(e.player_index)
    if not e.created_by_moving then
        return
    end
    local stage = getStageAtSurface(surface.index)
    if not stage then
        return
    end
    local placeResult = item.place_result
    if not placeResult or placeResult.type ~= "transport-belt" then
        return
    end
    local hoveredEntity = surface.find_entities_filtered({
        position = e.position,
        radius = 0,
        type = "underground-belt",
        direction = oppositedirection(e.direction),
        limit = 1
    })[1]
    if hoveredEntity ~= nil then
        stage.actions.onUndergroundBeltDragRotated(hoveredEntity, stage.stageNumber, e.player_index)
    end
end)
Events.on_pre_player_mined_item(function()
    state.preMinedItemCalled = true
end)
local function isFastReplaceCompatible(pos1, pos2, item1, item2, direction1, direction2)
    return pos1.x == pos2.x and pos1.y == pos2.y and (item1 == item2 and direction1 ~= direction2 or item1 ~= item2 and areUpgradeableTypes(item1, item2))
end
local function isFastReplaceMine(mineEvent)
    local lastPreBuild = state.lastPreBuild
    if not lastPreBuild then
        return
    end
    local ____mineEvent_5 = mineEvent
    local entity = ____mineEvent_5.entity
    local toBeFastReplaced = state.toBeFastReplaced
    if toBeFastReplaced and toBeFastReplaced.undergroundPair == entity then
        return true
    end
    local event = lastPreBuild.event
    local item = lastPreBuild.item
    if item == nil or event.tick ~= mineEvent.tick or event.player_index ~= mineEvent.player_index or entity.surface ~= lastPreBuild.surface then
        return
    end
    local ____event_6 = event
    local position = ____event_6.position
    if isFastReplaceCompatible(
        position,
        entity.position,
        item,
        entity.name,
        event.direction,
        entity.direction
    ) then
        return true
    end
    if entity.type == "underground-belt" then
        local pair = entity.neighbours
        if pair and isFastReplaceCompatible(
            position,
            pair.position,
            item,
            pair.name,
            event.direction,
            pair.direction
        ) then
            return true
        end
    end
end
Events.on_player_mined_entity(function(e)
    local ____e_7 = e
    local entity = ____e_7.entity
    local preMinedItemCalled = state.preMinedItemCalled
    state.preMinedItemCalled = nil
    local entitySurface = entity.surface
    local stage = getStageAtSurface(entitySurface.index)
    if not stage or not isWorldEntityProjectEntity(entity) then
        return
    end
    if preMinedItemCalled == nil or isFastReplaceMine(e) then
        setToBeFastReplaced(entity, stage, e.player_index)
    else
        stage.actions.onEntityDeleted(entity, stage.stageNumber, e.player_index)
    end
end)
Events.on_built_entity(function(e)
    local ____e_8 = e
    local entity = ____e_8.created_entity
    if not entity.valid then
        return
    end
    local innerName = getInnerName(entity)
    if innerName == "bp100:undo-reference" then
        return onUndoReferenceBuilt(e.player_index, entity)
    end
    local currentBlueprintPaste = state.currentBlueprintPaste
    if currentBlueprintPaste then
        if innerName == "bp100:entity-marker" then
            onEntityMarkerBuilt(e, entity)
        end
        return
    end
    if innerName == "bp100:entity-marker" then
        entity.destroy()
        return
    end
    local lastPreBuild = state.lastPreBuild
    state.lastPreBuild = nil
    local stage = getStageAtSurface(entity.surface_index)
    if not stage then
        return
    end
    local playerIndex = e.player_index
    if not isWorldEntityProjectEntity(entity) then
        return
    end
    if tryFastReplace(entity, stage, playerIndex) then
        return
    end
    if lastPreBuild == nil then
        stage.actions.onEntityCreated(entity, stage.stageNumber, playerIndex)
        return
    end
    local undoAction = stage.actions.onEntityCreated(entity, stage.stageNumber, playerIndex)
    if undoAction then
        registerUndoActionLater(undoAction)
    end
end)
IsLastEntity = "bp100IsLastEntity"
Events.on_player_cursor_stack_changed(function(e)
    tryFixBlueprint(game.get_player(e.player_index))
    state.lastPreBuild = nil
end)
Events.on_player_changed_surface(function(e)
    tryFixBlueprint(game.get_player(e.player_index))
    state.lastPreBuild = nil
end)
OnEntityPrototypesLoaded:addListener(function(e)
    nameToType = e.nameToType
    twoDirectionTanks = e.twoDirectionTanks
end)
rawset = _G.rawset
local function markPlayerAffectedWires(player)
    local entity = player.selected
    if not entity then
        return
    end
    local stage = getStageAtEntity(entity)
    if not stage then
        return
    end
    local data = global.players[player.index]
    local existingEntity = data.lastWireAffectedEntity
    if existingEntity and existingEntity ~= entity then
        stage.actions.onWiresPossiblyUpdated(entity, stage.stageNumber, player.index)
    end
    data.lastWireAffectedEntity = entity
end
local function clearPlayerAffectedWires(index)
    local data = global.players[index]
    local entity = data.lastWireAffectedEntity
    if entity then
        data.lastWireAffectedEntity = nil
        local stage = getStageAtEntity(entity)
        if stage then
            stage.actions.onWiresPossiblyUpdated(entity, stage.stageNumber, index)
        end
    end
end
local wirePrototypes = {["red-wire"] = true, ["green-wire"] = true, ["copper-cable"] = true}
Events.on(
    "bp100:build",
    function(e)
        local player = game.get_player(e.player_index)
        local playerStack = player.cursor_stack
        if not playerStack or not playerStack.valid_for_read or not (wirePrototypes[playerStack.name] ~= nil) then
            return
        end
        markPlayerAffectedWires(player)
    end
)
Events.on(
    "bp100:remove-pole-cables",
    function(e)
        markPlayerAffectedWires(game.get_player(e.player_index))
    end
)
Events.on_selected_entity_changed(function(e)
    clearPlayerAffectedWires(e.player_index)
    state.lastPreBuild = nil
end)
local function onCleanupToolSelected(e)
    local stage = getStageAtSurface(e.surface.index)
    if not stage then
        return
    end
    local updateLater = {}
    local stageNumber = stage.stageNumber
    local onCleanupToolUsed = stage.actions.onCleanupToolUsed
    for ____, entity in ipairs(e.entities) do
        if entity.train then
            updateLater[#updateLater + 1] = entity
        else
            onCleanupToolUsed(entity, stageNumber)
        end
    end
    for ____, entity in ipairs(updateLater) do
        onCleanupToolUsed(entity, stageNumber)
    end
end
local function onCleanupToolReverseSelected(e)
    local playerIndex = e.player_index
    local stage = getStageAtSurface(e.surface.index)
    if not stage then
        return
    end
    local onEntityForceDeleteUsed = stage.actions.onEntityForceDeleteUsed
    local stageNumber = stage.stageNumber
    local undoActions = {}
    for ____, entity in ipairs(e.entities) do
        local undoAction = onEntityForceDeleteUsed(entity, stageNumber, playerIndex)
        if undoAction then
            undoActions[#undoActions + 1] = undoAction
        end
    end
    registerGroupUndoAction(undoActions)
end
addSelectionToolHandlers("bp100:cleanup-tool", {onSelected = onCleanupToolSelected, onAltSelected = onCleanupToolSelected, onReverseSelected = onCleanupToolReverseSelected})
local function stageMoveToolUsed(e)
    local stage = getStageAtSurface(e.surface.index)
    if not stage then
        return
    end
    local playerIndex = e.player_index
    local playerData = getProjectPlayerData(playerIndex, stage.project)
    if not playerData then
        return
    end
    local targetStage = playerData.moveTargetStage
    if not targetStage then
        error("moveTargetStage was not set")
    end
    local stageNumber = stage.stageNumber
    local undoActions = {}
    local onSendToStageUsed = stage.actions.onSendToStageUsed
    local onlyIfMatchesFirstStage = e.name ~= defines.events.on_player_alt_selected_area
    for ____, entity in ipairs(e.entities) do
        local undoAction = onSendToStageUsed(
            entity,
            stageNumber,
            targetStage,
            onlyIfMatchesFirstStage,
            playerIndex
        )
        if undoAction then
            undoActions[#undoActions + 1] = undoAction
        end
    end
    registerGroupUndoAction(undoActions)
end
local function selectionToolUsed(e, action)
    local stage = getStageAtSurface(e.surface.index)
    if not stage then
        return
    end
    local stageNumber = stage.stageNumber
    local undoActions = {}
    local fn = stage.actions[action]
    local playerIndex = e.player_index
    for ____, entity in ipairs(e.entities) do
        local undoAction = fn(entity, stageNumber, playerIndex)
        if undoAction then
            undoActions[#undoActions + 1] = undoAction
        end
    end
    registerGroupUndoAction(undoActions)
end
addSelectionToolHandlers(
    "bp100:stage-move-tool",
    {
        onSelected = stageMoveToolUsed,
        onAltSelected = stageMoveToolUsed,
        onReverseSelected = function(e) return selectionToolUsed(e, "onBringToStageUsed") end,
        onAltReverseSelected = function(e) return selectionToolUsed(e, "onBringDownToStageUsed") end
    }
)
addSelectionToolHandlers(
    "bp100:stage-deconstruct-tool",
    {
        onSelected = function(e) return selectionToolUsed(e, "onStageDeleteUsed") end,
        onAltSelected = function(e) return selectionToolUsed(e, "onStageDeleteCancelUsed") end
    }
)
local function stagedCopyToolUsed(event)
    local player = game.get_player(event.player_index)
    local stage = getStageAtSurface(event.surface.index)
    if not stage then
        return player.print({"bp100.interaction.not-in-an-project"})
    end
    local stack = createBlueprintWithStageInfo(player, stage, event.area)
    if not stack then
        return
    end
    if event.name ~= defines.events.on_player_alt_selected_area then
        player.add_to_clipboard(stack)
        player.activate_paste()
    else
        player.clear_cursor()
        player.opened = stack
        global.players[event.player_index].blueprintToSetup = stack
    end
end
Events.on_gui_closed(function(e)
    local playerData = global.players[e.player_index]
    local stack = playerData.blueprintToSetup
    if not stack then
        return
    end
    playerData.blueprintToSetup = nil
    local player = game.get_player(e.player_index)
    if not (stack and stack.valid and stack.valid_for_read) then
        return
    end
    if stack.valid_for_read and stack.is_blueprint and stack.is_blueprint_setup() then
        player.add_to_clipboard(stack)
        player.activate_paste()
    end
    stack.clear()
end)
addSelectionToolHandlers("bp100:staged-copy-tool", {onSelected = stagedCopyToolUsed, onAltSelected = stagedCopyToolUsed})
local function forceDeleteToolUsed(event)
    local stage = getStageAtSurface(event.surface.index)
    if not stage then
        return
    end
    local stageNumber = stage.stageNumber
    local undoActions = {}
    local onEntityForceDeleteUsed = stage.actions.onEntityForceDeleteUsed
    for ____, entity in ipairs(event.entities) do
        local undoAction = onEntityForceDeleteUsed(entity, stageNumber, event.player_index)
        if undoAction then
            undoActions[#undoActions + 1] = undoAction
        end
    end
    registerGroupUndoAction(undoActions)
end
addSelectionToolHandlers("bp100:force-delete-tool", {onSelected = forceDeleteToolUsed, onAltSelected = forceDeleteToolUsed})
local function cutToolUsed(event)
    stagedCopyToolUsed(event)
    forceDeleteToolUsed(event)
end
addSelectionToolHandlers("bp100:staged-cut-tool", {onSelected = cutToolUsed, onAltSelected = cutToolUsed})
Events.on_marked_for_deconstruction(function(e)
    local playerIndex = e.player_index
    if not playerIndex then
        return
    end
    local player = game.get_player(playerIndex)
    local cursorStack = player.cursor_stack
    if not cursorStack or not cursorStack.valid_for_read or cursorStack.name ~= "bp100:filtered-stage-move-tool" then
        return
    end
    local entity = e.entity
    entity.cancel_deconstruction(entity.force)
    local stage = getStageAtSurface(entity.surface_index)
    if not stage then
        return
    end
    local playerData = getProjectPlayerData(playerIndex, stage.project)
    if not playerData then
        return
    end
    local targetStage = playerData.moveTargetStage
    if not targetStage then
        return
    end
    local undoAction = stage.actions.onSendToStageUsed(
        entity,
        stage.stageNumber,
        targetStage,
        true,
        playerIndex
    )
    if undoAction then
        local ____state_33, ____accumulatedUndoActions_34 = state, "accumulatedUndoActions"
        if ____state_33[____accumulatedUndoActions_34] == nil then
            ____state_33[____accumulatedUndoActions_34] = {}
        end
        local ____state_accumulatedUndoActions_36 = state.accumulatedUndoActions
        ____state_accumulatedUndoActions_36[#____state_accumulatedUndoActions_36 + 1] = undoAction
    end
end)
Events.on_player_deconstructed_area(function(e)
    if e.item ~= "bp100:filtered-stage-move-tool" then
        return
    end
    local player = game.get_player(e.player_index)
    if getStageAtSurface(player.surface_index) == nil then
        player.create_local_flying_text({text = {"bp100.interaction.not-in-an-project"}, create_at_cursor = true})
        player.play_sound({path = "utility/cannot_build"})
        return
    end
    local undoActions = state.accumulatedUndoActions
    if undoActions then
        registerGroupUndoAction(undoActions)
        state.accumulatedUndoActions = nil
    end
end)
Events.on(
    "bp100:force-delete",
    function(e)
        local playerIndex = e.player_index
        local player = game.get_player(playerIndex)
        local entity = player.selected
        if not entity then
            return
        end
        local stage = getStageAtEntityOrPreview(entity)
        if not stage then
            return
        end
        local name = entity.name
        local position = entity.position
        local undoAction = stage.actions.onEntityForceDeleteUsed(entity, stage.stageNumber, playerIndex)
        if undoAction then
            player.play_sound({path = "entity-mined/" .. name, position = position})
            registerUndoAction(undoAction)
        end
    end
)
Events.on(
    "bp100:move-to-this-stage",
    function(e)
        local player = game.get_player(e.player_index)
        local entity = player.selected
        if not entity then
            return
        end
        local stage = getStageAtEntityOrPreview(entity)
        if not stage then
            player.create_local_flying_text({text = {"bp100.interaction.not-in-an-project"}, create_at_cursor = true})
            return
        end
        local undoAction = stage.actions.onMoveEntityToStageCustomInput(entity, stage.stageNumber, e.player_index)
        if undoAction then
            registerUndoAction(undoAction)
        end
    end
)
Events.on_chunk_generated(function(e)
    local stage = getStageAtSurface(e.surface.index)
    if not stage then
        return
    end
    local entities = e.surface.find_entities_filtered({type = {"simple-entity-with-owner", "rail-remnants"}, area = e.area})
    local stageNumber = stage.stageNumber
    local project = stage.project
    local onTryFixEntity = stage.actions.onTryFixEntity
    for ____, entity in ipairs(entities) do
        if entity.valid then
            onTryFixEntity(entity, stageNumber)
        end
    end
    local status = defines.chunk_generated_status.entities
    for ____, ____value in ipairs(project:getAllStages()) do
        local surface = ____value.surface
        local position = e.position
        if not surface.is_chunk_generated(position) then
            if surface.generate_with_lab_tiles then
                surface.build_checkerboard(e.area)
            else
                surface.request_to_generate_chunks(position, 1)
                surface.force_generate_chunk_requests()
            end
            surface.set_chunk_generated_status(position, status)
        end
    end
end)
if remote.interfaces.PickerDollies and remote.interfaces.PickerDollies.dolly_moved_entity_id then
    Events.onInitOrLoad(function()
        local event = remote.call("PickerDollies", "dolly_moved_entity_id")
        Events.on(
            event,
            function(e)
                local stage = getStageAtEntityOrPreview(e.moved_entity)
                if stage then
                    stage.project.actions.onEntityDollied(e.moved_entity, stage.stageNumber, e.start_pos, e.player_index)
                end
            end
        )
    end)
end
Events.onInitOrLoad(function()
    for ____, mod in ipairs({"bobinserters", "boblogistics"}) do
        if remote.interfaces[mod] ~= nil then
            local eventId = remote.call(mod, "get_changed_position_event_id")
            Events.on(
                eventId,
                function(e) return luaEntityPossiblyUpdated(e.entity, nil) end
            )
        end
    end
end)
--- For manual calls from other parts of the code
____exports.checkForEntityUpdates = luaEntityPossiblyUpdated
function ____exports.checkForCircuitWireUpdates(entity, byPlayer)
    local stage = getStageAtEntity(entity)
    if stage then
        stage.actions.onWiresPossiblyUpdated(entity, stage.stageNumber, byPlayer)
    end
end
____exports._assertInValidState = function()
    state.lastPreBuild = nil
    for k, v in pairs(state) do
        state[k] = nil
        assert(not v, k .. " was not cleaned up")
    end
end
Events.on_init(function()
    for ____, playerData in pairs(global.players) do
        playerData.needs028MoveToolNotification = true
    end
end)
Events.on_player_cursor_stack_changed(function(e)
    local playerData = global.players[e.player_index]
    if not (playerData and playerData.needs028MoveToolNotification) then
        return
    end
    local player = game.get_player(e.player_index)
    local stack = player.cursor_stack
    if stack and stack.valid and stack.valid_for_read and stack.name == "bp100:stage-move-tool" then
        playerData.needs028MoveToolNotification = false
        player.print({"bp100.stage-move-tool-028-changed-notification"})
    end
end)
return ____exports
