--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____constants = require("constants")
local Colors = ____constants.Colors
local ____entity_2Dprototype_2Dinfo = require("entity.entity-prototype-info")
local allowOverlapDifferentDirection = ____entity_2Dprototype_2Dinfo.allowOverlapDifferentDirection
local ____underground_2Dbelt = require("entity.underground-belt")
local findUndergroundPair = ____underground_2Dbelt.findUndergroundPair
local ____lib = require("lib.index")
local assertNever = ____lib.assertNever
local deepCompare = ____lib.deepCompare
local ____notifications = require("project.notifications")
local createIndicator = ____notifications.createIndicator
local createNotification = ____notifications.createNotification
local ____undo = require("project.undo")
local registerUndoAction = ____undo.registerUndoAction
local UndoHandler = ____undo.UndoHandler
local undoDeleteEntity = UndoHandler(
    "delete entity",
    function(_, ____bindingPattern0)
        local entity
        local project
        project = ____bindingPattern0.project
        entity = ____bindingPattern0.entity
        local updates = project.updates
        updates.readdDeletedEntity(entity)
    end
)
local undoManualStageMove = UndoHandler(
    "stage move",
    function(player, ____bindingPattern0)
        local oldStage
        local entity
        local project
        project = ____bindingPattern0.project
        entity = ____bindingPattern0.entity
        oldStage = ____bindingPattern0.oldStage
        local actions = project.actions
        local actualEntity = actions.findCompatibleEntityForUndo(entity)
        if actualEntity then
            actions.userTryMoveEntityToStage(actualEntity, oldStage, player.index, true)
        end
    end
)
local undoSendToStage = UndoHandler(
    "send to stage",
    function(player, ____bindingPattern0)
        local oldStage
        local entity
        local project
        project = ____bindingPattern0.project
        entity = ____bindingPattern0.entity
        oldStage = ____bindingPattern0.oldStage
        local actions = project.actions
        local actualEntity = actions.findCompatibleEntityForUndo(entity)
        if actualEntity then
            actions.userBringEntityToStage(actualEntity, oldStage, player.index)
        end
    end
)
local undoBringToStage = UndoHandler(
    "bring to stage",
    function(player, ____bindingPattern0)
        local oldStage
        local entity
        local project
        project = ____bindingPattern0.project
        entity = ____bindingPattern0.entity
        oldStage = ____bindingPattern0.oldStage
        local actions = project.actions
        local actualEntity = actions.findCompatibleEntityForUndo(entity)
        if actualEntity then
            actions.userSendEntityToStage(actualEntity, actualEntity.firstStage, oldStage, player.index)
        end
    end
)
local lastStageChangeUndo = UndoHandler(
    "last stage change",
    function(player, ____bindingPattern0)
        local oldLastStage
        local entity
        local project
        project = ____bindingPattern0.project
        entity = ____bindingPattern0.entity
        oldLastStage = ____bindingPattern0.oldLastStage
        local actions = project.actions
        local actualEntity = actions.findCompatibleEntityForUndo(entity)
        if actualEntity then
            actions.userTrySetLastStage(actualEntity, oldLastStage, player.index)
        end
    end
)
local moveResultMessage = {
    success = nil,
    ["connected-entities-missing"] = "bp100.interaction.connected-entities-missing",
    ["entities-missing"] = "bp100.interaction.entities-missing",
    overlap = "bp100.interaction.no-room-in-another-stage",
    ["could-not-teleport"] = "bp100.interaction.cannot-be-teleported-in-another-stage",
    ["cannot-move"] = "bp100.interaction.cannot-move",
    ["wires-cannot-reach"] = "bp100.interaction.wires-maxed-in-another-stage"
}
--- Entry point for actions that can be performed on a project, from user input.
-- 
-- @noSelf
function ____exports.ProjectActions(project, projectUpdates, worldEntityUpdates)
    local onPreviewReplaced, onEntityOverbuilt, onEntityCreated, tryAddNewEntity, getCompatibleAtCurrentStageOrAdd, notifyIfUpdateError, onTryFixEntity, getCompatibleAtPositionOrAdd, onEntityDeleted, handlePasteValue, onEntityPossiblyUpdated, handleRotate, onEntityRotated, onUndergroundBeltDragRotated, onWiresPossiblyUpdated, onEntityMarkedForUpgrade, onCleanupToolUsed, onEntityForceDeleteUsed, onEntityDied, notifyIfMoveError, userRevivedSettingsRemnant, findCompatibleEntityForUndo, userTryMoveEntityToStage, onMoveEntityToStageCustomInput, userTryMoveEntityToStageWithUndo, userMoveEntityToStageWithUndo, userSendEntityToStage, onSendToStageUsed, userBringEntityToStage, onBringToStageUsed, onBringDownToStageUsed, onStageDeleteUsed, userTrySetLastStageWithUndo, userSetLastStageWithUndo, onStageDeleteCancelUsed, userTrySetLastStage, onEntityDollied, content, addNewEntity, deleteEntityOrCreateSettingsRemnant, forceDeleteEntity, tryUpdateEntityFromWorld, tryUpgradeEntityFromWorld, tryReviveSettingsRemnant, tryRotateEntityFromWorld, trySetFirstStage, trySetLastStage, setValueFromStagedInfo, updateWiresFromWorld, clearWorldEntityAtStage, rebuildWorldEntityAtStage, refreshAllWorldEntities, refreshWorldEntityAtStage, tryDollyEntities, updateAllHighlights
    function onPreviewReplaced(entity, stage, byPlayer)
        local oldStage = entity.firstStage
        if trySetFirstStage(entity, stage) ~= "updated" then
            rebuildWorldEntityAtStage(entity, stage)
            return
        end
        createNotification(
            entity,
            byPlayer,
            {
                "bp100.interaction.entity-moved-from-stage",
                project:getStageName(oldStage)
            },
            false
        )
        return byPlayer and undoManualStageMove.createAction(byPlayer, {project = project, entity = entity, oldStage = oldStage})
    end
    function onEntityOverbuilt(projectEntity, luaEntity, stage, byPlayer)
        projectEntity:replaceWorldEntity(stage, luaEntity)
        if projectEntity.isSettingsRemnant then
            userRevivedSettingsRemnant(projectEntity, stage, byPlayer)
        elseif stage >= projectEntity.firstStage then
            refreshWorldEntityAtStage(projectEntity, stage)
        else
            return onPreviewReplaced(projectEntity, stage, byPlayer)
        end
    end
    function onEntityCreated(entity, stage, byPlayer)
        local projectEntity = content:findCompatibleWithLuaEntity(entity, nil, stage)
        if projectEntity then
            return onEntityOverbuilt(projectEntity, entity, stage, byPlayer)
        end
        return tryAddNewEntity(entity, stage, byPlayer)
    end
    function tryAddNewEntity(entity, stage, byPlayer, knownBpValue)
        if not (allowOverlapDifferentDirection[entity.type] ~= nil) and entity.supports_direction then
            local existingDifferentDirection = content:findCompatibleByProps(entity.name, entity.position, nil, stage)
            if existingDifferentDirection then
                entity.destroy()
                createNotification(existingDifferentDirection, byPlayer, {"bp100.interaction.cannot-build-different-direction"}, false)
                return
            end
        end
        addNewEntity(entity, stage, knownBpValue)
    end
    function getCompatibleAtCurrentStageOrAdd(worldEntity, stage, previousDirection, byPlayer, knownBpValue)
        local compatible = content:findCompatibleWithLuaEntity(worldEntity, previousDirection, stage)
        if not compatible then
            tryAddNewEntity(worldEntity, stage, byPlayer, knownBpValue)
            return nil
        end
        if stage < compatible.firstStage then
            onEntityOverbuilt(compatible, worldEntity, stage, byPlayer)
            return nil
        end
        compatible:replaceWorldEntity(stage, worldEntity)
        return compatible
    end
    function notifyIfUpdateError(result, entity, byPlayer)
        if result == "no-change" or result == "updated" then
            return
        end
        if result == "cannot-rotate" then
            createNotification(entity, byPlayer, {"cant-be-rotated"}, true)
        elseif result == "cannot-upgrade-changed-pair" then
            createNotification(entity, byPlayer, {"bp100.interaction.cannot-upgrade-underground-changed-pair"}, true)
        else
            assertNever(result)
        end
    end
    function onTryFixEntity(previewEntity, stage, deleteSettingsRemnants)
        local existing = content:findCompatibleFromLuaEntityOrPreview(previewEntity, stage)
        if not existing then
            return
        end
        if existing.isSettingsRemnant then
            if deleteSettingsRemnants then
                forceDeleteEntity(existing)
            end
        elseif existing:hasErrorAt(stage) then
            refreshAllWorldEntities(existing)
        end
    end
    function getCompatibleAtPositionOrAdd(entity, stage, oldPosition, byPlayer)
        local existing = content:findExact(entity, oldPosition, stage)
        if existing then
            return existing
        end
        onEntityCreated(entity, stage, byPlayer)
        return nil
    end
    function onEntityDeleted(entity, stage, _byPlayer)
        local projectEntity = content:findCompatibleWithLuaEntity(entity, nil, stage)
        if not projectEntity then
            return
        end
        local firstStage = projectEntity.firstStage
        if firstStage ~= stage then
            if firstStage < stage then
                rebuildWorldEntityAtStage(projectEntity, stage)
            end
            return
        end
        deleteEntityOrCreateSettingsRemnant(projectEntity)
    end
    function handlePasteValue(entity, stage, previousDirection, byPlayer, knownBpValue, stagedInfo)
        local compatible = content:findCompatibleWithLuaEntity(entity, previousDirection, stage)
        if not compatible then
            tryAddNewEntity(entity, stage, byPlayer, knownBpValue)
            return nil
        end
        if compatible.isSettingsRemnant then
            forceDeleteEntity(compatible)
            tryAddNewEntity(entity, stage, byPlayer, knownBpValue)
            return nil
        end
        compatible:replaceWorldEntity(stage, entity)
        local result = setValueFromStagedInfo(compatible, knownBpValue, stagedInfo)
        notifyIfMoveError(result, compatible, byPlayer)
        return compatible
    end
    function onEntityPossiblyUpdated(entity, stage, previousDirection, byPlayer, knownBpValue)
        local ____opt_2 = knownBpValue and knownBpValue.tags
        local stagedInfo = ____opt_2 and ____opt_2.bp100
        if stagedInfo then
            return handlePasteValue(
                entity,
                stage,
                previousDirection,
                byPlayer,
                knownBpValue,
                stagedInfo
            )
        end
        local projectEntity = getCompatibleAtCurrentStageOrAdd(
            entity,
            stage,
            previousDirection,
            byPlayer,
            knownBpValue
        )
        if not projectEntity then
            return
        end
        local result = tryUpdateEntityFromWorld(projectEntity, stage, knownBpValue)
        notifyIfUpdateError(result, projectEntity, byPlayer)
        return projectEntity
    end
    function handleRotate(worldEntity, projectEntity, stage, byPlayer)
        local result = tryRotateEntityFromWorld(projectEntity, stage)
        notifyIfUpdateError(result, projectEntity, byPlayer)
        if projectEntity:isUndergroundBelt() then
            local worldPair = worldEntity.neighbours
            if not worldPair then
                return
            end
            local pairEntity = getCompatibleAtCurrentStageOrAdd(worldPair, stage, nil, byPlayer)
            if not pairEntity then
                return
            end
            local expectedPair = findUndergroundPair(content, projectEntity, stage)
            if pairEntity ~= expectedPair then
                updateAllHighlights(pairEntity)
            end
        end
    end
    function onEntityRotated(entity, stage, previousDirection, byPlayer)
        local projectEntity = getCompatibleAtCurrentStageOrAdd(entity, stage, previousDirection, byPlayer)
        if projectEntity then
            handleRotate(entity, projectEntity, stage, byPlayer)
        end
    end
    function onUndergroundBeltDragRotated(entity, stage, byPlayer)
        local projectEntity = content:findCompatibleWithLuaEntity(entity, nil, stage)
        if not projectEntity or not projectEntity:isUndergroundBelt() then
            return
        end
        if not ({entity.rotate()}) then
            return
        end
        handleRotate(entity, projectEntity, stage, byPlayer)
    end
    function onWiresPossiblyUpdated(entity, stage, byPlayer)
        local projectEntity = getCompatibleAtCurrentStageOrAdd(entity, stage, nil, byPlayer)
        if not projectEntity then
            return
        end
        local result = updateWiresFromWorld(projectEntity, stage)
        if result == "max-connections-exceeded" then
            createNotification(projectEntity, byPlayer, {"bp100.interaction.max-connections-reached-in-another-stage"}, true)
        elseif result ~= "updated" and result ~= "no-change" then
            assertNever(result)
        end
    end
    function onEntityMarkedForUpgrade(entity, stage, byPlayer)
        local projectEntity = getCompatibleAtCurrentStageOrAdd(entity, stage, nil, byPlayer)
        if not projectEntity then
            return
        end
        local result = tryUpgradeEntityFromWorld(projectEntity, stage)
        notifyIfUpdateError(result, projectEntity, byPlayer)
        if entity.valid then
            entity.cancel_upgrade(entity.force)
        end
    end
    function onCleanupToolUsed(entity, stage)
        onTryFixEntity(entity, stage, true)
    end
    function onEntityForceDeleteUsed(entity, stage, byPlayer)
        local projectEntity = content:findCompatibleFromLuaEntityOrPreview(entity, stage)
        if projectEntity then
            forceDeleteEntity(projectEntity)
            return undoDeleteEntity.createAction(byPlayer, {project = project, entity = projectEntity})
        end
        return nil
    end
    function onEntityDied(entity, stage)
        local projectEntity = content:findCompatibleWithLuaEntity(entity, nil, stage)
        if projectEntity then
            clearWorldEntityAtStage(projectEntity, stage)
        end
    end
    function notifyIfMoveError(result, entity, byPlayer)
        if result == "updated" or result == "no-change" then
            return
        end
        if result == "cannot-move-past-last-stage" then
            createNotification(entity, byPlayer, {"bp100.interaction.cannot-move-past-last-stage"}, true)
        elseif result == "cannot-move-before-first-stage" then
            createNotification(entity, byPlayer, {"bp100.interaction.cannot-delete-before-first-stage"}, true)
        elseif result == "intersects-another-entity" then
            createNotification(entity, byPlayer, {"bp100.interaction.move-will-intersect-another-entity"}, true)
        else
            assertNever(result)
        end
    end
    function userRevivedSettingsRemnant(entity, stage, byPlayer)
        local result = tryReviveSettingsRemnant(entity, stage)
        if result ~= "updated" and result ~= "no-change" then
            notifyIfMoveError(result, entity, byPlayer)
            refreshWorldEntityAtStage(entity, stage)
        end
    end
    function findCompatibleEntityForUndo(entity)
        if not project.valid then
            return nil
        end
        if not content:has(entity) then
            local matching = content:findCompatibleWithExistingEntity(entity, entity.firstStage)
            if not matching or entity.firstStage ~= matching.firstStage or not deepCompare(entity.firstValue, matching.firstValue) then
                return nil
            end
            return matching
        end
        return entity
    end
    function userTryMoveEntityToStage(entity, stage, byPlayer, returned)
        local oldStage = entity.firstStage
        local result = trySetFirstStage(entity, stage)
        if result == "updated" then
            if returned then
                createNotification(
                    entity,
                    byPlayer,
                    {
                        "bp100.interaction.entity-moved-back-to-stage",
                        project:getStageName(stage)
                    },
                    false
                )
            else
                createNotification(
                    entity,
                    byPlayer,
                    {
                        "bp100.interaction.entity-moved-from-stage",
                        project:getStageName(oldStage)
                    },
                    false
                )
            end
            return true
        end
        if result == "no-change" then
            createNotification(entity, byPlayer, {"bp100.interaction.already-at-first-stage"}, true)
        else
            notifyIfMoveError(result, entity, byPlayer)
        end
        return false
    end
    function onMoveEntityToStageCustomInput(entityOrPreviewEntity, stage, byPlayer)
        local entity = content:findCompatibleFromLuaEntityOrPreview(entityOrPreviewEntity, stage)
        if not entity or entity.isSettingsRemnant then
            return
        end
        return userTryMoveEntityToStageWithUndo(entity, stage, byPlayer)
    end
    function userTryMoveEntityToStageWithUndo(entity, stage, byPlayer)
        local oldStage = entity.firstStage
        if userTryMoveEntityToStage(entity, stage, byPlayer) then
            return undoManualStageMove.createAction(byPlayer, {project = project, entity = entity, oldStage = oldStage})
        end
    end
    function userMoveEntityToStageWithUndo(entity, stage, byPlayer)
        local undoAction = userTryMoveEntityToStageWithUndo(entity, stage, byPlayer)
        if undoAction then
            registerUndoAction(undoAction)
        end
    end
    function userSendEntityToStage(projectEntity, fromStage, toStage, byPlayer)
        local result = trySetFirstStage(projectEntity, toStage)
        if result ~= "updated" then
            notifyIfMoveError(result, projectEntity, byPlayer)
            return false
        end
        if toStage < fromStage then
            createIndicator(projectEntity, byPlayer, "<<", Colors.Orange)
        end
        return true
    end
    function onSendToStageUsed(entity, fromStage, toStage, onlyIfMatchesFirstStage, byPlayer)
        if fromStage == toStage then
            return
        end
        local projectEntity = content:findExact(entity, entity.position, fromStage)
        if not projectEntity or projectEntity.isSettingsRemnant or onlyIfMatchesFirstStage and projectEntity.firstStage ~= fromStage then
            return
        end
        if userSendEntityToStage(projectEntity, fromStage, toStage, byPlayer) then
            return undoSendToStage.createAction(byPlayer, {project = project, entity = projectEntity, oldStage = fromStage})
        end
    end
    function userBringEntityToStage(projectEntity, stage, byPlayer)
        local oldStage = projectEntity.firstStage
        if oldStage == stage then
            return false
        end
        local result = trySetFirstStage(projectEntity, stage)
        if result ~= "updated" then
            notifyIfMoveError(result, projectEntity, byPlayer)
            return false
        end
        if oldStage < stage then
            createIndicator(projectEntity, byPlayer, ">>", Colors.Blueish)
        end
        return true
    end
    function onBringToStageUsed(entity, stage, byPlayer)
        local projectEntity = content:findCompatibleFromLuaEntityOrPreview(entity, stage)
        if not projectEntity or projectEntity.isSettingsRemnant then
            return
        end
        local oldStage = projectEntity.firstStage
        if userBringEntityToStage(projectEntity, stage, byPlayer) then
            return undoBringToStage.createAction(byPlayer, {project = project, entity = projectEntity, oldStage = oldStage})
        end
    end
    function onBringDownToStageUsed(entity, stage, byPlayer)
        local projectEntity = content:findCompatibleFromLuaEntityOrPreview(entity, stage)
        if not projectEntity or projectEntity.isSettingsRemnant then
            return
        end
        if projectEntity.firstStage <= stage then
            return
        end
        local oldStage = projectEntity.firstStage
        if userBringEntityToStage(projectEntity, stage, byPlayer) then
            return undoBringToStage.createAction(byPlayer, {project = project, entity = projectEntity, oldStage = oldStage})
        end
    end
    function onStageDeleteUsed(entity, stage, byPlayer)
        local projectEntity = content:findCompatibleFromLuaEntityOrPreview(entity, stage)
        if not projectEntity or projectEntity.isSettingsRemnant then
            return
        end
        local newLastStage = stage - 1
        local oldLastStage = projectEntity.lastStage
        if userTrySetLastStage(projectEntity, newLastStage, byPlayer) then
            return lastStageChangeUndo.createAction(byPlayer, {project = project, entity = projectEntity, oldLastStage = oldLastStage})
        end
    end
    function userTrySetLastStageWithUndo(projectEntity, stage, byPlayer)
        local oldStage = projectEntity.lastStage
        if userTrySetLastStage(projectEntity, stage, byPlayer) then
            return lastStageChangeUndo.createAction(byPlayer, {project = project, entity = projectEntity, oldLastStage = oldStage})
        end
    end
    function userSetLastStageWithUndo(projectEntity, newLastStage, byPlayer)
        local undoAction = userTrySetLastStageWithUndo(projectEntity, newLastStage, byPlayer)
        if undoAction then
            registerUndoAction(undoAction)
        end
    end
    function onStageDeleteCancelUsed(entity, stage, byPlayer)
        local projectEntity = content:findCompatibleFromLuaEntityOrPreview(entity, stage)
        if not projectEntity or projectEntity.isSettingsRemnant or projectEntity.lastStage ~= stage then
            return
        end
        return userTrySetLastStageWithUndo(projectEntity, nil, byPlayer)
    end
    function userTrySetLastStage(projectEntity, newLastStage, byPlayer)
        local result = trySetLastStage(projectEntity, newLastStage)
        notifyIfMoveError(result, projectEntity, byPlayer)
        return result == "updated"
    end
    function onEntityDollied(entity, stage, oldPosition, byPlayer)
        local projectEntity = getCompatibleAtPositionOrAdd(entity, stage, oldPosition, byPlayer)
        if not projectEntity then
            return
        end
        assert(
            not projectEntity.isSettingsRemnant and not projectEntity:isUndergroundBelt(),
            "cannot move this entity"
        )
        local result = tryDollyEntities(projectEntity, stage)
        local message = moveResultMessage[result]
        if message ~= nil then
            createNotification(projectEntity, byPlayer, {message, {"entity-name." .. entity.name}}, true)
        end
    end
    content = project.content
    local ____projectUpdates_0 = projectUpdates
    addNewEntity = ____projectUpdates_0.addNewEntity
    deleteEntityOrCreateSettingsRemnant = ____projectUpdates_0.deleteEntityOrCreateSettingsRemnant
    forceDeleteEntity = ____projectUpdates_0.forceDeleteEntity
    tryUpdateEntityFromWorld = ____projectUpdates_0.tryUpdateEntityFromWorld
    tryUpgradeEntityFromWorld = ____projectUpdates_0.tryUpgradeEntityFromWorld
    tryReviveSettingsRemnant = ____projectUpdates_0.tryReviveSettingsRemnant
    tryRotateEntityFromWorld = ____projectUpdates_0.tryRotateEntityFromWorld
    trySetFirstStage = ____projectUpdates_0.trySetFirstStage
    trySetLastStage = ____projectUpdates_0.trySetLastStage
    setValueFromStagedInfo = ____projectUpdates_0.setValueFromStagedInfo
    updateWiresFromWorld = ____projectUpdates_0.updateWiresFromWorld
    local ____worldEntityUpdates_1 = worldEntityUpdates
    clearWorldEntityAtStage = ____worldEntityUpdates_1.clearWorldEntityAtStage
    rebuildWorldEntityAtStage = ____worldEntityUpdates_1.rebuildWorldEntityAtStage
    refreshAllWorldEntities = ____worldEntityUpdates_1.refreshAllWorldEntities
    refreshWorldEntityAtStage = ____worldEntityUpdates_1.refreshWorldEntityAtStage
    tryDollyEntities = ____worldEntityUpdates_1.tryDollyEntities
    updateAllHighlights = ____worldEntityUpdates_1.updateAllHighlights
    local result = {
        onEntityCreated = onEntityCreated,
        onEntityDeleted = onEntityDeleted,
        onEntityPossiblyUpdated = onEntityPossiblyUpdated,
        onEntityRotated = onEntityRotated,
        onUndergroundBeltDragRotated = onUndergroundBeltDragRotated,
        onWiresPossiblyUpdated = onWiresPossiblyUpdated,
        onEntityMarkedForUpgrade = onEntityMarkedForUpgrade,
        onCleanupToolUsed = onCleanupToolUsed,
        onTryFixEntity = onTryFixEntity,
        onEntityForceDeleteUsed = onEntityForceDeleteUsed,
        onEntityDied = onEntityDied,
        onEntityDollied = onEntityDollied,
        onStageDeleteUsed = onStageDeleteUsed,
        onStageDeleteCancelUsed = onStageDeleteCancelUsed,
        onBringToStageUsed = onBringToStageUsed,
        onBringDownToStageUsed = onBringDownToStageUsed,
        onSendToStageUsed = onSendToStageUsed,
        onMoveEntityToStageCustomInput = onMoveEntityToStageCustomInput,
        userRevivedSettingsRemnant = userRevivedSettingsRemnant,
        userMoveEntityToStageWithUndo = userMoveEntityToStageWithUndo,
        userSetLastStageWithUndo = userSetLastStageWithUndo,
        userBringEntityToStage = userBringEntityToStage,
        userSendEntityToStage = userSendEntityToStage,
        userTryMoveEntityToStage = userTryMoveEntityToStage,
        findCompatibleEntityForUndo = findCompatibleEntityForUndo,
        userTrySetLastStage = userTrySetLastStage
    }
    return result
end
return ____exports
