local ____lualib = require("lualib_bundle")
local __TS__ArrayMap = ____lualib.__TS__ArrayMap
local ____exports = {}
local ____geometry = require("lib.geometry.index")
local BBox = ____geometry.BBox
local function getTiles(area, tile)
    local tiles = {}
    local i = 0
    for x, y in BBox.roundTile(area):iterateTiles() do
        i = i + 1
        tiles[i] = {name = tile, position = {x = x, y = y}}
    end
    return {tiles, i}
end
function ____exports.setTiles(surface, area, tile)
    if not (game.tile_prototypes[tile] ~= nil) then
        return false
    end
    local tiles = table.unpack(getTiles(area, tile))
    surface.set_tiles(tiles, true, "abort_on_collision")
    return true
end
function ____exports.setTilesAndWater(surface, area, tile)
    if not (game.tile_prototypes.water ~= nil and game.tile_prototypes[tile] ~= nil) then
        return false
    end
    local tiles, count = table.unpack(getTiles(area, tile))
    surface.set_tiles(tiles, true, "abort_on_collision")
    for k = 1, count do
        tiles[k].name = "water"
    end
    surface.set_tiles(tiles, true, "abort_on_collision")
    return true
end
function ____exports.setTilesAndCheckerboard(surface, area, tile)
    if not ____exports.setTilesAndWater(surface, area, tile) then
        return false
    end
    local nonWaterTiles = surface.find_tiles_filtered({
        area = BBox.expand(area, 1),
        name = tile
    })
    local tiles = __TS__ArrayMap(
        nonWaterTiles,
        function(____, luaTile) return {name = tile, position = luaTile.position} end
    )
    surface.build_checkerboard(area)
    surface.set_tiles(tiles, true, "abort_on_collision")
    return true
end
function ____exports.setTilesForStage(stage)
    local tile = stage.project.landfillTile:get()
    return tile ~= nil and ____exports.setTiles(
        stage.surface,
        stage:getBlueprintBBox(),
        tile
    )
end
function ____exports.setTilesAndWaterForStage(stage)
    local tile = stage.project.landfillTile:get()
    return tile ~= nil and ____exports.setTilesAndWater(
        stage.surface,
        stage:getBlueprintBBox(),
        tile
    )
end
function ____exports.setTilesAndCheckerboardForStage(stage)
    local tile = stage.project.landfillTile:get()
    return tile ~= nil and ____exports.setTilesAndCheckerboard(
        stage.surface,
        stage:getBlueprintBBox(),
        tile
    )
end
function ____exports.setCheckerboard(surface, area)
    surface.build_checkerboard(area)
end
____exports._mockable = true
return ____exports
