local ____lualib = require("lualib_bundle")
local __TS__ArrayForEach = ____lualib.__TS__ArrayForEach
local ____exports = {}
local ____geometry = require("lib.geometry.index")
local BBox = ____geometry.BBox
function ____exports.prepareArea(surface, area)
    local ____surface_0 = surface
    local is_chunk_generated = ____surface_0.is_chunk_generated
    local set_chunk_generated_status = ____surface_0.set_chunk_generated_status
    local status = defines.chunk_generated_status.entities
    local pos = {x = 0, y = 0}
    local chunkArea = BBox.scale(area, 1 / 32):roundTile()
    for x, y in chunkArea:iterateTiles() do
        pos.x = x
        pos.y = y
        if not is_chunk_generated(pos) then
            set_chunk_generated_status(pos, status)
        end
    end
    local actualArea = chunkArea:scale(32)
    surface.build_checkerboard(actualArea)
end
local defaultPreparedArea = BBox.around({x = 0, y = 0}, script.active_mods["factorio-test"] ~= nil and 32 or 5 * 32)
local function createNewStageSurface(area)
    if area == nil then
        area = defaultPreparedArea
    end
    local surface = game.create_surface("bp100-stage-temp", {width = 10000, height = 10000})
    surface.generate_with_lab_tiles = true
    surface.always_day = true
    surface.show_clouds = false
    surface.name = "bp100-stage-" .. tostring(surface.index)
    ____exports.prepareArea(surface, area)
    return surface
end
local surfaceCreator
if not script.active_mods["factorio-test"] then
    surfaceCreator = {
        createSurface = createNewStageSurface,
        destroySurface = function(surface) return game.delete_surface(surface) end
    }
else
    surfaceCreator = {
        createSurface = function(area)
            if area == nil then
                area = defaultPreparedArea
            end
            if not global.freeSurfaces then
                global.freeSurfaces = {}
            end
            while #global.freeSurfaces > 0 do
                local surface = table.remove(global.freeSurfaces)
                if surface.valid then
                    ____exports.prepareArea(surface, area)
                    return surface
                end
            end
            return createNewStageSurface(area)
        end,
        destroySurface = function(surface)
            if not surface.valid then
                return
            end
            __TS__ArrayForEach(
                surface.find_entities(),
                function(____, entity) return entity.destroy() end
            )
            if not global.freeSurfaces then
                global.freeSurfaces = {}
            end
            local ____global_freeSurfaces_1 = global.freeSurfaces
            ____global_freeSurfaces_1[#____global_freeSurfaces_1 + 1] = surface
            for ____, id in ipairs(rendering.get_all_ids(script.mod_name)) do
                if rendering.get_surface(id) == surface then
                    rendering.destroy(id)
                end
            end
        end
    }
end
function ____exports.deleteAllFreeSurfaces()
    if global.freeSurfaces then
        for ____, surface in ipairs(global.freeSurfaces) do
            if surface.valid then
                game.delete_surface(surface)
            end
        end
        global.freeSurfaces = nil
    end
end
____exports.createStageSurface = surfaceCreator.createSurface
____exports.destroySurface = surfaceCreator.destroySurface
return ____exports
