local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local __TS__StringStartsWith = ____lualib.__TS__StringStartsWith
local __TS__New = ____lualib.__TS__New
local ____exports = {}
local ____entity_2Dprototype_2Dinfo = require("entity.entity-prototype-info")
local isPreviewEntity = ____entity_2Dprototype_2Dinfo.isPreviewEntity
local ____picker_2Ddollies = require("entity.picker-dollies")
local forceDollyEntity = ____picker_2Ddollies.forceDollyEntity
local tryDollyAllEntities = ____picker_2Ddollies.tryDollyAllEntities
local ____ProjectEntity = require("entity.ProjectEntity")
local isWorldEntityProjectEntity = ____ProjectEntity.isWorldEntityProjectEntity
local ____save_2Dload = require("entity.save-load")
local createEntity = ____save_2Dload.createEntity
local createPreviewEntity = ____save_2Dload.createPreviewEntity
local forceFlipUnderground = ____save_2Dload.forceFlipUnderground
local updateEntity = ____save_2Dload.updateEntity
local ____wires = require("entity.wires")
local updateWireConnectionsAtStage = ____wires.updateWireConnectionsAtStage
local ____lib = require("lib.index")
local RegisterClass = ____lib.RegisterClass
local ____task = require("lib.task")
local LoopTask = ____task.LoopTask
local submitTask = ____task.submitTask
local RebuildAllStagesTask = __TS__Class()
RebuildAllStagesTask.name = "RebuildAllStagesTask"
__TS__ClassExtends(RebuildAllStagesTask, LoopTask)
function RebuildAllStagesTask.prototype.____constructor(self, project)
    LoopTask.prototype.____constructor(
        self,
        project:numStages()
    )
    self.project = project
end
function RebuildAllStagesTask.prototype.getTitle(self)
    return {"bp100.gui.tasks.rebuild-all-stages"}
end
function RebuildAllStagesTask.prototype.doStep(self, i)
    self.project.entityUpdates.rebuildStage(i + 1)
end
function RebuildAllStagesTask.prototype.getTitleForStep(self, step)
    return {
        "bp100.gui.tasks.rebuilding-stage",
        self.project:getStageName(step + 1)
    }
end
RebuildAllStagesTask = __TS__DecorateLegacy(
    {RegisterClass("RebuildAllStagesTask")},
    RebuildAllStagesTask
)
---
-- @noSelf
function ____exports.WorldEntityUpdates(project, highlights)
    local makePreviewEntity, clearWorldEntityAtStage, setEntityUpdateable, updateWorldEntitiesInRange, updateWires, updateWorldEntities, updateNewWorldEntitiesWithoutWires, refreshWorldEntityAtStage, resetUnderground, rebuildWorldEntityAtStage, updateWorldEntitiesOnLastStageChanged, updateWireConnections, refreshAllWorldEntities, makeSettingsRemnant, reviveSettingsRemnant, deleteUndergroundBelt, deleteWorldEntities, checkConnectionWorldEntityExists, tryMoveOtherEntities, tryDollyEntities, disableAllEntitiesInStage, enableAllEntitiesInStage, rebuildStage, rebuildAllStages, content, updateAllHighlights, deleteAllHighlights, makeSettingsRemnantHighlights, updateHighlightsOnReviveSettingsRemnant
    function makePreviewEntity(stage, entity, direction, previewName)
        local existing = entity:getWorldOrPreviewEntity(stage)
        if existing and existing.name == previewName then
            existing.direction = direction
        else
            local previewEntity = createPreviewEntity(
                project:getSurface(stage),
                entity.position,
                direction,
                previewName
            )
            entity:replaceWorldOrPreviewEntity(stage, previewEntity)
        end
    end
    function clearWorldEntityAtStage(entity, stage)
        local previewName = "bp100:preview-entity-" .. entity.firstValue.name
        makePreviewEntity(
            stage,
            entity,
            entity:getPreviewDirection(),
            previewName
        )
        updateAllHighlights(entity)
    end
    function setEntityUpdateable(entity, updateable)
        entity.minable = updateable
        entity.rotatable = updateable
        entity.destructible = false
    end
    function updateWorldEntitiesInRange(entity, startStage, endStage)
        assert(startStage >= 1)
        local ____entity_1 = entity
        local firstStage = ____entity_1.firstStage
        local lastStage = ____entity_1.lastStage
        local direction = ____entity_1.direction
        local previewDirection = entity:getPreviewDirection()
        if startStage == firstStage then
            startStage = 1
        end
        if lastStage and lastStage > endStage then
            endStage = lastStage
        end
        local lastEntityName = nil
        local lastPreviewName
        local hasOrResolvedError = false
        local updatedNeighbors
        for stage, value, changed in entity:iterateValues(startStage, endStage) do
            do
                local surface = project:getSurface(stage)
                local existing = entity:getWorldOrPreviewEntity(stage)
                local wasPreviewEntity = existing and isPreviewEntity(existing)
                local existingNormalEntity = not wasPreviewEntity and existing
                if value ~= nil then
                    local luaEntity
                    if existingNormalEntity then
                        local updatedNeighbor
                        luaEntity, updatedNeighbor = updateEntity(existingNormalEntity, value, direction, changed)
                        if updatedNeighbor then
                            if updatedNeighbors == nil then
                                updatedNeighbors = {}
                            end
                            updatedNeighbors[updatedNeighbor] = true
                        end
                    else
                        luaEntity = createEntity(
                            surface,
                            entity.position,
                            direction,
                            value,
                            changed
                        )
                    end
                    if luaEntity then
                        setEntityUpdateable(luaEntity, stage == firstStage)
                        entity:replaceWorldOrPreviewEntity(stage, luaEntity)
                        if wasPreviewEntity then
                            hasOrResolvedError = true
                        end
                        goto __continue15
                    end
                    hasOrResolvedError = true
                end
                local entityName = (value or entity.firstValue).name
                if entityName ~= lastEntityName then
                    lastEntityName = entityName
                    lastPreviewName = "bp100:preview-entity-" .. entityName
                end
                makePreviewEntity(stage, entity, previewDirection, lastPreviewName)
            end
            ::__continue15::
        end
        if updatedNeighbors then
            for neighbor in pairs(updatedNeighbors) do
                updateAllHighlights(neighbor)
            end
        end
        return hasOrResolvedError
    end
    function updateWires(entity, startStage)
        local lastStage = project:lastStageFor(entity)
        for stage = startStage, lastStage do
            updateWireConnectionsAtStage(content, entity, stage)
        end
    end
    function updateWorldEntities(entity, startStage, updateHighlights)
        if updateHighlights == nil then
            updateHighlights = true
        end
        if entity.isSettingsRemnant then
            return makeSettingsRemnant(entity)
        end
        local lastStage = project:lastStageFor(entity)
        if lastStage < startStage then
            return
        end
        updateWorldEntitiesInRange(entity, startStage, lastStage)
        updateWires(entity, startStage)
        if updateHighlights then
            updateAllHighlights(entity)
        end
    end
    function updateNewWorldEntitiesWithoutWires(entity)
        local hasError = updateWorldEntitiesInRange(
            entity,
            1,
            project:lastStageFor(entity)
        )
        if hasError then
            updateAllHighlights(entity)
        end
    end
    function refreshWorldEntityAtStage(entity, stage)
        if entity:isPastLastStage(stage) then
            entity:destroyWorldOrPreviewEntity(stage)
            return
        end
        if not entity:isInStage(stage) then
            makePreviewEntity(
                stage,
                entity,
                entity:getPreviewDirection(),
                "bp100:preview-entity-" .. entity:getNameAtStage(stage)
            )
            return
        end
        if entity.isSettingsRemnant then
            entity:destroyWorldOrPreviewEntity(stage)
            makePreviewEntity(
                stage,
                entity,
                entity:getPreviewDirection(),
                entity:getNameAtStage(stage)
            )
            makeSettingsRemnantHighlights(entity)
            return
        end
        updateWorldEntitiesInRange(entity, stage, stage)
        updateWireConnectionsAtStage(content, entity, stage)
        updateAllHighlights(entity)
    end
    function resetUnderground(entity, stage)
        local worldEntity = entity:getWorldOrPreviewEntity(stage)
        if worldEntity and worldEntity.belt_to_ground_type ~= entity.firstValue.type then
            forceFlipUnderground(worldEntity)
        end
        updateWorldEntitiesInRange(entity, stage, stage)
        updateAllHighlights(entity)
    end
    function rebuildWorldEntityAtStage(entity, stage)
        entity:destroyWorldOrPreviewEntity(stage)
        refreshWorldEntityAtStage(entity, stage)
    end
    function updateWorldEntitiesOnLastStageChanged(entity, oldLastStage)
        local movedDown = entity.lastStage ~= nil and (oldLastStage == nil or entity.lastStage < oldLastStage)
        if movedDown then
            for stage = entity.lastStage + 1, oldLastStage or project:numStages() do
                entity:destroyWorldOrPreviewEntity(stage)
            end
        elseif oldLastStage then
            updateWorldEntities(entity, oldLastStage + 1)
        end
        updateAllHighlights(entity)
    end
    function updateWireConnections(entity)
        updateWires(entity, entity.firstStage)
    end
    function refreshAllWorldEntities(entity)
        return updateWorldEntities(entity, 1)
    end
    function makeSettingsRemnant(entity)
        assert(entity.isSettingsRemnant)
        entity:destroyAllWorldOrPreviewEntities()
        local direction = entity:getPreviewDirection()
        local previewName = "bp100:preview-entity-" .. entity.firstValue.name
        for stage = 1, project:lastStageFor(entity) do
            makePreviewEntity(stage, entity, direction, previewName)
        end
        makeSettingsRemnantHighlights(entity)
    end
    function reviveSettingsRemnant(entity)
        assert(not entity.isSettingsRemnant)
        local lastStage = project:lastStageFor(entity)
        updateWorldEntitiesInRange(entity, 1, lastStage)
        updateWires(entity, 1)
        updateHighlightsOnReviveSettingsRemnant(entity)
    end
    function deleteUndergroundBelt(entity, project)
        local pairsToUpdate = {}
        for stage = entity.firstStage, project:lastStageFor(entity) do
            do
                local worldEntity = entity:getWorldOrPreviewEntity(stage)
                if not worldEntity then
                    goto __continue51
                end
                local pair = worldEntity.neighbours
                if not pair then
                    goto __continue51
                end
                local pairProjectEntity = content:findCompatibleWithLuaEntity(pair, nil, stage)
                if pairProjectEntity then
                    pairsToUpdate[pairProjectEntity] = true
                end
            end
            ::__continue51::
        end
        entity:destroyAllWorldOrPreviewEntities()
        for pair in pairs(pairsToUpdate) do
            updateAllHighlights(pair)
        end
    end
    function deleteWorldEntities(entity)
        if entity:isUndergroundBelt() then
            deleteUndergroundBelt(entity, project)
        else
            entity:destroyAllWorldOrPreviewEntities()
        end
        deleteAllHighlights(entity)
    end
    function checkConnectionWorldEntityExists(entity, startStage, endStage)
        local cableConnected = entity.cableConnections
        if cableConnected then
            for other in pairs(cableConnected) do
                if not other:hasWorldEntityInRange(startStage, endStage) then
                    return false
                end
            end
        end
        local circuitConnections = entity.circuitConnections
        if circuitConnections then
            for other in pairs(circuitConnections) do
                if not other:hasWorldEntityInRange(startStage, endStage) then
                    return false
                end
            end
        end
        return true
    end
    function tryMoveOtherEntities(entity, stage, movedEntity)
        if entity:isUndergroundBelt() or entity.firstStage ~= stage then
            return "cannot-move"
        end
        if not checkConnectionWorldEntityExists(
            entity,
            stage,
            project:lastStageFor(entity)
        ) then
            return "connected-entities-missing"
        end
        local entities = {}
        for stageNum = 1, entity.firstStage - 1 do
            entities[#entities + 1] = entity:getWorldOrPreviewEntity(stageNum)
        end
        for stageNum = entity.firstStage, project:lastStageFor(entity) do
            local worldEntity = entity:getWorldOrPreviewEntity(stageNum)
            if not worldEntity then
                return "entities-missing"
            end
            entities[#entities + 1] = worldEntity
        end
        return tryDollyAllEntities(entities, movedEntity.position, movedEntity.direction)
    end
    function tryDollyEntities(entity, stage)
        local movedEntity = entity:getWorldOrPreviewEntity(stage)
        if not movedEntity then
            return "entities-missing"
        end
        local moveResult = tryMoveOtherEntities(entity, stage, movedEntity)
        if moveResult ~= "success" then
            forceDollyEntity(movedEntity, entity.position, entity.direction)
        else
            entity.direction = movedEntity.direction
            local posChanged = content:changePosition(entity, movedEntity.position)
            assert(posChanged, "failed to change position in content")
            deleteAllHighlights(entity)
            updateAllHighlights(entity)
        end
        return moveResult
    end
    function disableAllEntitiesInStage(stage)
        local surface = project:getSurface(stage)
        if not surface then
            return
        end
        local arr = surface.find_entities()
        for i = 1, #arr do
            arr[i].active = false
        end
    end
    function enableAllEntitiesInStage(stage)
        local surface = project:getSurface(stage)
        if not surface then
            return
        end
        local arr = surface.find_entities()
        for i = 1, #arr do
            arr[i].active = true
        end
    end
    function rebuildStage(stage)
        local surface = project:getSurface(stage)
        if not surface then
            return
        end
        for ____, entity in ipairs(surface.find_entities()) do
            if isWorldEntityProjectEntity(entity) then
                entity.destroy()
            end
        end
        for ____, entity in ipairs(surface.find_entities_filtered({type = {"simple-entity-with-owner", "rail-remnants"}})) do
            if __TS__StringStartsWith(entity.name, "bp100:preview-entity-") then
                entity.destroy()
            end
        end
        local updateLater = {}
        for entity in pairs(content:iterateAllEntities()) do
            if entity:isRollingStock() then
                updateLater[#updateLater + 1] = entity
            else
                refreshWorldEntityAtStage(entity, stage)
            end
        end
        for ____, entity in ipairs(updateLater) do
            refreshWorldEntityAtStage(entity, stage)
        end
    end
    function rebuildAllStages()
        submitTask(__TS__New(RebuildAllStagesTask, project))
    end
    content = project.content
    local ____highlights_0 = highlights
    updateAllHighlights = ____highlights_0.updateAllHighlights
    deleteAllHighlights = ____highlights_0.deleteAllHighlights
    makeSettingsRemnantHighlights = ____highlights_0.makeSettingsRemnantHighlights
    updateHighlightsOnReviveSettingsRemnant = ____highlights_0.updateHighlightsOnReviveSettingsRemnant
    return {
        updateWorldEntities = updateWorldEntities,
        updateWorldEntitiesOnLastStageChanged = updateWorldEntitiesOnLastStageChanged,
        updateWireConnections = updateWireConnections,
        updateNewWorldEntitiesWithoutWires = updateNewWorldEntitiesWithoutWires,
        makeSettingsRemnant = makeSettingsRemnant,
        reviveSettingsRemnant = reviveSettingsRemnant,
        clearWorldEntityAtStage = clearWorldEntityAtStage,
        refreshWorldEntityAtStage = refreshWorldEntityAtStage,
        refreshAllWorldEntities = refreshAllWorldEntities,
        rebuildWorldEntityAtStage = rebuildWorldEntityAtStage,
        rebuildStage = rebuildStage,
        disableAllEntitiesInStage = disableAllEntitiesInStage,
        enableAllEntitiesInStage = enableAllEntitiesInStage,
        deleteWorldEntities = deleteWorldEntities,
        tryDollyEntities = tryDollyEntities,
        resetUnderground = resetUnderground,
        rebuildAllStages = rebuildAllStages,
        updateAllHighlights = updateAllHighlights
    }
end
return ____exports
