local ____lualib = require("lualib_bundle")
local __TS__ObjectAssign = ____lualib.__TS__ObjectAssign
local ____exports = {}
local ____util = require("util")
local ____table = ____util.table
local ____constants = require("constants")
local Colors = ____constants.Colors
local function selectionToolToShortcut(prototype, icon, associatedControl, style)
    local ____prototype_name_1 = prototype.name
    local ____prototype_order_2 = prototype.order
    local ____prototype_name_3 = prototype.name
    local ____icon_4 = icon
    local ____style_5 = style
    local ____associatedControl_6 = associatedControl
    local ____prototype_localised_name_0 = prototype.localised_name
    if ____prototype_localised_name_0 == nil then
        ____prototype_localised_name_0 = {"item-name." .. prototype.name}
    end
    return {
        type = "shortcut",
        name = ____prototype_name_1,
        order = ____prototype_order_2,
        action = "spawn-item",
        item_to_spawn = ____prototype_name_3,
        icon = ____icon_4,
        style = ____style_5,
        associated_control_input = ____associatedControl_6,
        localised_name = ____prototype_localised_name_0
    }
end
local function selectionToolToInput(prototype, keySequence, useItemNameForLocalisedName)
    if keySequence == nil then
        keySequence = ""
    end
    if useItemNameForLocalisedName == nil then
        useItemNameForLocalisedName = true
    end
    return {
        type = "custom-input",
        name = prototype.name,
        localised_name = useItemNameForLocalisedName and ({"item-name." .. prototype.name}) or nil,
        order = prototype.order,
        key_sequence = keySequence,
        action = "spawn-item",
        item_to_spawn = prototype.name
    }
end
local cleanupToolColor = Colors.Green
local cleanupReverseToolColor = Colors.Red
local cleanupTool = {
    type = "selection-tool",
    name = "bp100:cleanup-tool",
    icons = {{icon = "__base__/graphics/icons/blueprint.png", icon_size = 64, tint = {1, 1, 1, 0.5}}, {icon = "__bp100__/graphics/icons/cleanup-white.png", icon_size = 64, scale = 0.4}},
    flags = {"only-in-cursor", "spawnable", "not-stackable"},
    stack_size = 1,
    subgroup = "tool",
    order = "z[bp100]-a[a-tools]-a[cleanup-tool]",
    selection_mode = {"any-entity"},
    selection_color = cleanupToolColor,
    selection_cursor_box_type = "entity",
    alt_selection_mode = {"any-entity"},
    alt_selection_color = cleanupToolColor,
    alt_selection_cursor_box_type = "entity",
    reverse_selection_mode = {"any-entity"},
    reverse_selection_color = cleanupReverseToolColor,
    reverse_selection_cursor_box_type = "not-allowed"
}
data:extend({
    cleanupTool,
    selectionToolToShortcut(cleanupTool, {filename = "__bp100__/graphics/icons/cleanup-white.png", size = 64}, "bp100:cleanup-tool", "blue"),
    selectionToolToInput(cleanupTool)
})
local stageMoveToolColor = Colors.Orange
local stageMoveToolAltColor = Colors.Orange2
local stageMoveToolReverseColor = Colors.Blueish
local stageMoveTool = {
    type = "selection-tool",
    name = "bp100:stage-move-tool",
    icon = "__bp100__/graphics/icons/stage-move-tool.png",
    icon_size = 64,
    icon_mipmaps = 4,
    flags = {"spawnable", "not-stackable", "only-in-cursor"},
    stack_size = 1,
    draw_label_for_cursor_render = true,
    subgroup = "tool",
    order = "z[bp100]-a[a-tools]-b[stage-move-tool]",
    selection_color = stageMoveToolColor,
    selection_cursor_box_type = "copy",
    selection_mode = {"deconstruct"},
    alt_selection_color = stageMoveToolAltColor,
    alt_selection_cursor_box_type = "copy",
    alt_selection_mode = {"any-entity"},
    reverse_selection_color = stageMoveToolReverseColor,
    reverse_selection_cursor_box_type = "electricity",
    reverse_selection_mode = {"any-entity"},
    alt_reverse_selection_color = stageMoveToolReverseColor,
    alt_reverse_selection_cursor_box_type = "electricity",
    alt_reverse_selection_mode = {"any-entity"}
}
data:extend({
    stageMoveTool,
    selectionToolToShortcut(stageMoveTool, {filename = "__bp100__/graphics/icons/stage-move-tool-white.png", size = 32, mipmap_count = 2}, "bp100:stage-move-tool", "blue"),
    selectionToolToInput(stageMoveTool)
})
local filteredStagedMoveTool = {
    type = "deconstruction-item",
    name = "bp100:filtered-stage-move-tool",
    icons = {{icon = "__bp100__/graphics/icons/purple-blueprint.png", icon_size = 64, icon_mipmaps = 4}, {icon = "__bp100__/graphics/icons/stage-move-tool-white.png", icon_size = 32, icon_mipmaps = 2, scale = 0.5}},
    flags = {"spawnable", "not-stackable"},
    stack_size = 1,
    entity_filter_count = 50,
    draw_label_for_cursor_render = true,
    subgroup = "tool",
    order = "z[bp100]-a[a-tools]-c[filtered-stage-move-tool]",
    selection_color = stageMoveToolColor,
    selection_cursor_box_type = "copy",
    selection_mode = {"deconstruct"},
    alt_selection_color = {0, 0, 0},
    alt_selection_cursor_box_type = "not-allowed",
    alt_selection_mode = {"nothing"}
}
data:extend({
    filteredStagedMoveTool,
    selectionToolToShortcut(filteredStagedMoveTool, {filename = "__bp100__/graphics/icons/stage-move-tool-white.png", size = 32, mipmap_count = 2}, "bp100:filtered-stage-move-tool", "red"),
    selectionToolToInput(filteredStagedMoveTool)
})
local deconstructionPlanner = ____table.deepcopy(data.raw["deconstruction-item"]["deconstruction-planner"])
local stagedDeconstructTool = {
    type = "selection-tool",
    name = "bp100:stage-deconstruct-tool",
    icon = "__bp100__/graphics/icons/staged-deconstruct-tool.png",
    icon_size = 64,
    icon_mipmaps = 2,
    flags = {"spawnable", "not-stackable", "only-in-cursor"},
    stack_size = 1,
    draw_label_for_cursor_render = true,
    subgroup = "tool",
    order = "z[bp100]-a[a-tools]-e[stage-deconstruct-tool]",
    selection_color = deconstructionPlanner.selection_color,
    selection_cursor_box_type = "not-allowed",
    selection_mode = {"blueprint"},
    alt_selection_color = deconstructionPlanner.alt_selection_color,
    alt_selection_cursor_box_type = "not-allowed",
    alt_selection_mode = {"blueprint"},
    reverse_selection_color = deconstructionPlanner.reverse_selection_color,
    reverse_selection_cursor_box_type = "not-allowed",
    reverse_selection_mode = {"nothing"}
}
data:extend({
    stagedDeconstructTool,
    selectionToolToShortcut(stagedDeconstructTool, {filename = "__bp100__/graphics/icons/staged-deconstruct-tool-new.png", size = 32}, "bp100:stage-deconstruct-tool", "red"),
    selectionToolToInput(stagedDeconstructTool, nil, false)
})
local copyTool = ____table.deepcopy(data.raw["copy-paste-tool"]["copy-paste-tool"])
local stageCopyTool = {
    type = "selection-tool",
    name = "bp100:staged-copy-tool",
    icon = "__bp100__/graphics/icons/staged-copy-tool.png",
    icon_size = 64,
    icon_mipmaps = 2,
    subgroup = "tool",
    order = "z[bp100]-b[b-tools]-a[staged-copy-tool]",
    flags = {"spawnable", "not-stackable", "only-in-cursor"},
    stack_size = 1,
    selection_mode = {"blueprint"},
    selection_color = copyTool.selection_color,
    selection_cursor_box_type = "copy",
    alt_selection_mode = {"blueprint"},
    alt_selection_color = copyTool.alt_selection_color,
    alt_selection_cursor_box_type = "copy"
}
local stageCutTool = ____table.deepcopy(stageCopyTool)
__TS__ObjectAssign(stageCutTool, {name = "bp100:staged-cut-tool", order = "z[bp100]-b[b-tools]-b[staged-cut-tool]", icon = "__bp100__/graphics/icons/staged-cut-tool.png"})
data:extend({
    stageCopyTool,
    selectionToolToShortcut(stageCopyTool, {filename = "__bp100__/graphics/icons/staged-copy-white.png", size = 32, mipmap_count = 2}, "bp100:staged-copy-tool", "blue"),
    stageCutTool,
    selectionToolToShortcut(stageCutTool, {filename = "__bp100__/graphics/icons/staged-cut-white.png", size = 32, mipmap_count = 2}, "bp100:staged-cut-tool", "blue"),
    selectionToolToInput(stageCopyTool, "CONTROL + SHIFT + C"),
    selectionToolToInput(stageCutTool, "CONTROL + SHIFT + X")
})
local forceDeleteTool = {
    type = "selection-tool",
    name = "bp100:force-delete-tool",
    icon = "__bp100__/graphics/icons/force-delete-tool.png",
    icon_size = 64,
    flags = {"spawnable", "not-stackable", "only-in-cursor"},
    stack_size = 1,
    draw_label_for_cursor_render = true,
    subgroup = "tool",
    order = "z[bp100]-b[b-tools]-c[force-delete-tool]",
    selection_mode = {"blueprint"},
    selection_color = deconstructionPlanner.selection_color,
    selection_cursor_box_type = "not-allowed",
    alt_selection_mode = {"any-entity"},
    alt_selection_color = deconstructionPlanner.selection_color,
    alt_selection_cursor_box_type = "not-allowed"
}
data:extend({
    forceDeleteTool,
    selectionToolToShortcut(forceDeleteTool, {filename = "__bp100__/graphics/icons/force-delete-tool-new.png", size = 32, mipmap_count = 2}, "bp100:force-delete-tool", "red"),
    selectionToolToInput(forceDeleteTool, nil, false)
})
local blueprintFilters = ____table.deepcopy(deconstructionPlanner)
deconstructionPlanner.tile_filter_count = nil
__TS__ObjectAssign(
    blueprintFilters,
    __TS__ObjectAssign({}, deconstructionPlanner, {name = "bp100:blueprint-filters", flags = {"hidden", "not-stackable", "spawnable"}, entity_filter_count = 80})
)
data:extend({blueprintFilters})
return ____exports
