local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__ArrayMap = ____lualib.__TS__ArrayMap
local __TS__ArrayFind = ____lualib.__TS__ArrayFind
local __TS__ArrayFindIndex = ____lualib.__TS__ArrayFindIndex
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local ____exports = {}
local createNewProject, getFrameFlow, toggleAllProjects, onModButtonClick, AllProjectsName, AllProjects
local mod_gui = require("mod-gui")
local ____lib = require("lib.index")
local bind = ____lib.bind
local funcRef = ____lib.funcRef
local ibind = ____lib.ibind
local onPlayerInitSince = ____lib.onPlayerInitSince
local RegisterClass = ____lib.RegisterClass
local registerFunctions = ____lib.registerFunctions
local ____factoriojsx = require("lib.factoriojsx.index")
local Component = ____factoriojsx.Component
local destroy = ____factoriojsx.destroy
local destroyChildren = ____factoriojsx.destroyChildren
local FactorioJsx = ____factoriojsx.FactorioJsx
local getComponentInstance = ____factoriojsx.getComponentInstance
local render = ____factoriojsx.render
local renderNamed = ____factoriojsx.renderNamed
local ____components = require("lib.factoriojsx.components.index")
local HorizontalPusher = ____components.HorizontalPusher
local SimpleTitleBar = ____components.SimpleTitleBar
local ____migration = require("lib.migration")
local Migrations = ____migration.Migrations
local ____UserProject = require("project.UserProject")
local createUserProject = ____UserProject.createUserProject
local getAllProjects = ____UserProject.getAllProjects
local moveProjectDown = ____UserProject.moveProjectDown
local moveProjectUp = ____UserProject.moveProjectUp
local ProjectEvents = ____UserProject.ProjectEvents
local ____player_2Dcurrent_2Dstage = require("ui.player-current-stage")
local exitProject = ____player_2Dcurrent_2Dstage.exitProject
local PlayerChangedStageEvent = ____player_2Dcurrent_2Dstage.PlayerChangedStageEvent
local playerCurrentStage = ____player_2Dcurrent_2Dstage.playerCurrentStage
local teleportToProject = ____player_2Dcurrent_2Dstage.teleportToProject
local ____ProjectSettings = require("ui.ProjectSettings")
local bringSettingsWindowToFront = ____ProjectSettings.bringSettingsWindowToFront
function createNewProject(player)
    local project = createUserProject("", 3)
    global.players[player.index].compactProjectSettings = nil
    teleportToProject(player, project)
end
function getFrameFlow(playerIndex)
    return mod_gui.get_frame_flow(game.get_player(playerIndex))
end
function ____exports.closeAllProjects(playerIndex)
    destroy(getFrameFlow(playerIndex)[AllProjectsName])
end
function toggleAllProjects(playerIndex)
    local flow = getFrameFlow(playerIndex)
    local allProjects = flow[AllProjectsName]
    if allProjects then
        destroy(allProjects)
    else
        renderNamed(
            FactorioJsx.createElement(AllProjects, nil),
            flow,
            AllProjectsName
        )
    end
end
function onModButtonClick(event)
    toggleAllProjects(event.player_index)
end
local mouse_button_type = defines.mouse_button_type
local function ModButton()
    return FactorioJsx.createElement(
        "sprite-button",
        {
            style = mod_gui.button_style,
            sprite = "bp100:blueprint-stages",
            tooltip = {"bp100.gui.project-selector.show-all-projects"},
            on_gui_click = funcRef(onModButtonClick)
        }
    )
end
local ModButtonName = script.mod_name .. ":all-projects"
onPlayerInitSince(
    "0.15.1",
    function(playerIndex)
        local player = game.get_player(playerIndex)
        renderNamed(
            FactorioJsx.createElement(ModButton, nil),
            mod_gui.get_button_flow(player),
            ModButtonName
        )
    end
)
AllProjectsName = script.mod_name .. ":all-projects"
local AllProjectsWidth = 260
local AllProjectsHeight = 28 * 10
AllProjects = __TS__Class()
AllProjects.name = "AllProjects"
__TS__ClassExtends(AllProjects, Component)
function AllProjects.prototype.render(self, _, context)
    self.playerIndex = context.playerIndex
    local currentStage = playerCurrentStage(self.playerIndex)
    return FactorioJsx.createElement(
        "frame",
        {direction = "vertical"},
        FactorioJsx.createElement(SimpleTitleBar, {title = {"bp100.gui.project-selector.all-projects"}}),
        FactorioJsx.createElement(
            "frame",
            {direction = "vertical", style = "inside_deep_frame", styleMod = {vertically_stretchable = true, bottom_margin = 8}},
            FactorioJsx.createElement(
                "scroll-pane",
                {
                    style = "bp100:fake-list-box",
                    styleMod = {width = AllProjectsWidth, height = AllProjectsHeight},
                    onCreate = function(____, e)
                        self.scrollPane = e
                        self:scrollToCurrentProject()
                    end
                },
                __TS__ArrayMap(
                    getAllProjects(),
                    function(____, project) return self:projectButtonFlow(project) end
                )
            )
        ),
        FactorioJsx.createElement(
            "flow",
            {direction = "horizontal", styleMod = {vertical_align = "center"}},
            FactorioJsx.createElement(
                "button",
                {
                    caption = {"bp100.gui.project-selector.new-project"},
                    on_gui_click = ibind(self, "newProject")
                }
            ),
            FactorioJsx.createElement(HorizontalPusher, nil),
            FactorioJsx.createElement(
                "button",
                {
                    caption = {"bp100.gui.project-selector.exit-project"},
                    enabled = currentStage:truthy(),
                    on_gui_click = ibind(self, "exitProject")
                }
            )
        )
    )
end
function AllProjects.prototype.projectButtonFlow(self, project)
    return FactorioJsx.createElement(
        "flow",
        {tags = {projectId = project.id}},
        self:projectButton(project)
    )
end
function AllProjects.prototype.projectButton(self, project)
    local ____opt_0 = playerCurrentStage(self.playerIndex):get()
    local currentProject = ____opt_0 and ____opt_0.project
    return FactorioJsx.createElement(
        "button",
        {
            style = project == currentProject and "bp100:fake-list-box-item-active" or "bp100:fake-list-box-item",
            caption = project:displayName(),
            tooltip = {"bp100.gui.project-selector.button-tooltip"},
            on_gui_click = bind(AllProjects.onButtonClick, project)
        }
    )
end
function AllProjects.prototype.scrollToCurrentProject(self)
    local ____opt_2 = playerCurrentStage(self.playerIndex):get()
    local currentProject = ____opt_2 and ____opt_2.project
    if not currentProject then
        return
    end
    local element = self.scrollPane
    if not element or not element.valid then
        return
    end
    local flow = __TS__ArrayFind(
        self.scrollPane.children,
        function(____, c)
            local ____opt_4 = c.tags
            return (____opt_4 and ____opt_4.projectId) == currentProject.id
        end
    )
    if flow then
        element.scroll_to_element(flow)
    end
end
function AllProjects.onButtonClick(project, event)
    if event.control then
        if event.button == mouse_button_type.left then
            moveProjectUp(project)
        elseif event.button == mouse_button_type.right then
            moveProjectDown(project)
        end
        return
    end
    local playerIndex = event.player_index
    local player = game.get_player(playerIndex)
    ____exports.closeAllProjects(playerIndex)
    teleportToProject(player, project)
    bringSettingsWindowToFront(player)
end
function AllProjects.prototype.newProject(self)
    ____exports.closeAllProjects(self.playerIndex)
    createNewProject(game.get_player(self.playerIndex))
end
function AllProjects.prototype.exitProject(self)
    ____exports.closeAllProjects(self.playerIndex)
    exitProject(game.get_player(self.playerIndex))
end
function AllProjects.prototype.projectChangedEvent(self, e)
    local element = self.scrollPane
    if not element or not element.valid then
        return
    end
    if e.type == "project-created" then
        render(
            self:projectButtonFlow(e.project),
            element
        )
        self:scrollToCurrentProject()
    elseif e.type == "project-deleted" then
        local flow = __TS__ArrayFind(
            element.children,
            function(____, c) return c.tags.projectId == e.project.id end
        )
        if flow then
            destroy(flow)
        end
    elseif e.type == "projects-reordered" then
        local children = element.children
        local index1 = __TS__ArrayFindIndex(
            children,
            function(____, c) return c.tags.projectId == e.project1.id end
        )
        local index2 = __TS__ArrayFindIndex(
            children,
            function(____, c) return c.tags.projectId == e.project2.id end
        )
        if index1 == -1 or index2 == -1 then
            return
        end
        element.swap_children(index1 + 1, index2 + 1)
        self:scrollToCurrentProject()
    end
end
function AllProjects.prototype.rerenderProject(self, project)
    local element = self.scrollPane
    if not element or not element.valid then
        return
    end
    local flow = __TS__ArrayFind(
        element.children,
        function(____, c) return c.tags.projectId == project.id end
    )
    if flow then
        destroyChildren(flow)
        render(
            self:projectButton(project),
            flow
        )
    end
end
function AllProjects.prototype.playerProjectChanged(self, oldProject, newProject)
    if oldProject then
        self:rerenderProject(oldProject)
    end
    if newProject then
        self:rerenderProject(newProject)
    end
    self:scrollToCurrentProject()
end
AllProjects = __TS__DecorateLegacy(
    {RegisterClass("gui:AllProjects")},
    AllProjects
)
registerFunctions("gui:project-selector", {onModButtonClick = onModButtonClick})
ProjectEvents:addListener(function(e)
    if e.type == "project-created" or e.type == "project-deleted" or e.type == "projects-reordered" then
        for ____, player in pairs(game.players) do
            do
                local element = getFrameFlow(player.index)[AllProjectsName]
                if not element then
                    goto __continue46
                end
                local component = getComponentInstance(element)
                if component then
                    component:projectChangedEvent(e)
                end
            end
            ::__continue46::
        end
    end
end)
PlayerChangedStageEvent:addListener(function(player, oldStage, newStage)
    local oldProject = oldStage and oldStage.project
    local newProject = newStage and newStage.project
    if oldProject ~= newProject then
        local element = getFrameFlow(player.index)[AllProjectsName]
        if not element then
            return
        end
        local component = getComponentInstance(element)
        if component then
            component:playerProjectChanged(oldProject, newProject)
        end
    end
end)
Migrations.to(
    "0.15.1",
    function()
        for playerIndex, playerData in pairs(global.players) do
            local oldPlayerData = playerData
            local ____destroy_14 = destroy
            local ____opt_10 = oldPlayerData and oldPlayerData.currentAssembliesGui
            ____destroy_14(____opt_10 and ____opt_10.mainFlow)
            local player = game.get_player(playerIndex)
            destroy(player and player.gui.left[script.mod_name .. ":current-assembly"])
        end
    end
)
Migrations.fromAny(function()
    for ____, player in pairs(game.players) do
        ____exports.closeAllProjects(player.index)
        local flow = mod_gui.get_button_flow(player)
        if flow[ModButtonName] == nil then
            renderNamed(
                FactorioJsx.createElement(ModButton, nil),
                flow,
                ModButtonName
            )
        end
    end
end)
Migrations.early(
    "0.23.0",
    function()
        local oldModButtonName = script.mod_name .. ":all-assemblies"
        local oldAllProjectsName = script.mod_name .. ":all-assemblies"
        for ____, player in pairs(game.players) do
            local flow = mod_gui.get_button_flow(player)
            destroy(flow[oldModButtonName])
            local frameFlow = mod_gui.get_frame_flow(player)
            destroy(frameFlow[oldAllProjectsName])
        end
    end
)
return ____exports
