local ____lualib = require("lualib_bundle")
local __TS__ObjectAssign = ____lualib.__TS__ObjectAssign
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local ____exports = {}
local renderAtProjectSettingsLoc, renderPlaceholder, renderCompactSettings, renderFullSettings, renderGuiForProject, updateGui, expandSettings, collapseSettings, CompactProjectSettings, ProjectSettings, ProjectSettingsHeight, ProjectSettingsWidth, ProjectSettingsName, DefaultProjectSettingsLoc
local ____blueprint_2Dcreation = require("blueprints.blueprint-creation")
local exportBlueprintBookToFile = ____blueprint_2Dcreation.exportBlueprintBookToFile
local submitProjectBlueprintBookTask = ____blueprint_2Dcreation.submitProjectBlueprintBookTask
local takeStageBlueprint = ____blueprint_2Dcreation.takeStageBlueprint
local ____edit_2Dblueprint_2Dsettings = require("blueprints.edit-blueprint-settings")
local editBlueprintFilters = ____edit_2Dblueprint_2Dsettings.editBlueprintFilters
local editInItemBlueprintSettings = ____edit_2Dblueprint_2Dsettings.editInItemBlueprintSettings
local ____constants = require("constants")
local Colors = ____constants.Colors
local ____ProjectEntity = require("entity.ProjectEntity")
local getStageToMerge = ____ProjectEntity.getStageToMerge
local ____lib = require("lib.index")
local bind = ____lib.bind
local funcRef = ____lib.funcRef
local ibind = ____lib.ibind
local multiMap = ____lib.multiMap
local onPlayerInitSince = ____lib.onPlayerInitSince
local property = ____lib.property
local RegisterClass = ____lib.RegisterClass
local registerFunctions = ____lib.registerFunctions
local ____factoriojsx = require("lib.factoriojsx.index")
local Component = ____factoriojsx.Component
local destroy = ____factoriojsx.destroy
local FactorioJsx = ____factoriojsx.FactorioJsx
local renderNamed = ____factoriojsx.renderNamed
local ____components = require("lib.factoriojsx.components.index")
local CollapseButton = ____components.CollapseButton
local DraggableSpace = ____components.DraggableSpace
local ExpandButton = ____components.ExpandButton
local Fn = ____components.Fn
local HorizontalPusher = ____components.HorizontalPusher
local showDialog = ____components.showDialog
local TitleBar = ____components.TitleBar
local TrashButton = ____components.TrashButton
local VerticalPusher = ____components.VerticalPusher
local ____migration = require("lib.migration")
local Migrations = ____migration.Migrations
local ____set_2Dtiles = require("project.set-tiles")
local setCheckerboard = ____set_2Dtiles.setCheckerboard
local setTilesAndCheckerboardForStage = ____set_2Dtiles.setTilesAndCheckerboardForStage
local setTilesAndWaterForStage = ____set_2Dtiles.setTilesAndWaterForStage
local setTilesForStage = ____set_2Dtiles.setTilesForStage
local ____DiffedProperty = require("utils.DiffedProperty")
local highlightIfNotNil = ____DiffedProperty.highlightIfNotNil
local highlightIfOverriden = ____DiffedProperty.highlightIfOverriden
local ____CheckboxTextfield = require("ui.components.CheckboxTextfield")
local CheckboxTextfield = ____CheckboxTextfield.CheckboxTextfield
local ____ItemRename = require("ui.ItemRename")
local ItemRename = ____ItemRename.ItemRename
local ____player_2Dcurrent_2Dstage = require("ui.player-current-stage")
local exitProject = ____player_2Dcurrent_2Dstage.exitProject
local PlayerChangedStageEvent = ____player_2Dcurrent_2Dstage.PlayerChangedStageEvent
local playerCurrentStage = ____player_2Dcurrent_2Dstage.playerCurrentStage
local recordPlayerLastPosition = ____player_2Dcurrent_2Dstage.recordPlayerLastPosition
local teleportToStage = ____player_2Dcurrent_2Dstage.teleportToStage
local ____StageSelector = require("ui.StageSelector")
local StageSelector = ____StageSelector.StageSelector
function renderAtProjectSettingsLoc(player, spec)
    local existing = player.gui.screen[ProjectSettingsName]
    local loc = existing and existing.location or DefaultProjectSettingsLoc
    local element = renderNamed(spec, player.gui.screen, ProjectSettingsName)
    element.location = loc
    element.bring_to_front()
end
function renderPlaceholder(player)
    renderAtProjectSettingsLoc(
        player,
        FactorioJsx.createElement("flow", {direction = "vertical", styleMod = {width = ProjectSettingsWidth, height = ProjectSettingsHeight}, visible = false})
    )
end
function renderCompactSettings(player, project)
    renderAtProjectSettingsLoc(
        player,
        FactorioJsx.createElement(CompactProjectSettings, {project = project})
    )
end
function renderFullSettings(player, project)
    renderAtProjectSettingsLoc(
        player,
        FactorioJsx.createElement(ProjectSettings, {project = project})
    )
end
function renderGuiForProject(player, currentProject)
    if not currentProject then
        return renderPlaceholder(player)
    end
    if global.players[player.index].compactProjectSettings then
        renderCompactSettings(player, currentProject)
    else
        renderFullSettings(player, currentProject)
    end
end
function updateGui(player)
    local ____opt_9 = playerCurrentStage(player.index):get()
    local currentProject = ____opt_9 and ____opt_9.project
    renderGuiForProject(player, currentProject)
end
function expandSettings(____bindingPattern0)
    local player_index
    player_index = ____bindingPattern0.player_index
    global.players[player_index].compactProjectSettings = nil
    updateGui(game.get_player(player_index))
end
function collapseSettings(____bindingPattern0)
    local player_index
    player_index = ____bindingPattern0.player_index
    global.players[player_index].compactProjectSettings = true
    updateGui(game.get_player(player_index))
end
function ____exports.bringSettingsWindowToFront(player)
    local element = player.gui.screen[ProjectSettingsName]
    if element then
        element.bring_to_front()
    end
end
onPlayerInitSince(
    "0.23.0",
    function(playerIndex)
        local data = global.players[playerIndex]
        data.projectSettingsSelectedTab = property(1)
    end
)
local StageListBoxHeight = 28 * 12
local StageListBoxWidth = 140
local NewStageBarHeight = 100
local StageSettingsButtonWidth = 180
local OtherSettingsButtonWidth = 180
local BpSettingsButtonWidth = 220
local ProjectSettingsTabWidth = 420
local function EditButton(props)
    return FactorioJsx.createElement(
        "button",
        __TS__ObjectAssign({caption = {"bp100.gui.project-settings.edit"}}, props, {styleMod = {width = 48}})
    )
end
local function StageListBox(project)
    return FactorioJsx.createElement(StageSelector, {uses = "list-box", styleMod = {height = StageListBoxHeight, width = StageListBoxWidth}, project = project})
end
CompactProjectSettings = __TS__Class()
CompactProjectSettings.name = "CompactProjectSettings"
__TS__ClassExtends(CompactProjectSettings, Component)
function CompactProjectSettings.prototype.render(self, ____bindingPattern0)
    local project
    project = ____bindingPattern0.project
    return FactorioJsx.createElement(
        "frame",
        {direction = "vertical"},
        FactorioJsx.createElement(
            TitleBar,
            nil,
            FactorioJsx.createElement(
                "label",
                {
                    caption = project:displayName(),
                    style = "caption_label",
                    styleMod = {maximal_width = StageListBoxWidth - 50},
                    ignored_by_interaction = true
                }
            ),
            FactorioJsx.createElement(DraggableSpace, nil),
            FactorioJsx.createElement(
                ExpandButton,
                {
                    on_gui_click = funcRef(expandSettings),
                    tooltip = {"bp100.gui.project-settings.show-full-settings"}
                }
            )
        ),
        StageListBox(project)
    )
end
CompactProjectSettings = __TS__DecorateLegacy(
    {RegisterClass("gui:CompactProjectSettings")},
    CompactProjectSettings
)
ProjectSettings = __TS__Class()
ProjectSettings.name = "ProjectSettings"
__TS__ClassExtends(ProjectSettings, Component)
function ProjectSettings.prototype.____constructor(self, ...)
    Component.prototype.____constructor(self, ...)
    self.sssCount = 0
end
function ProjectSettings.prototype.render(self, props, context)
    self.project = props.project
    self.playerIndex = context.playerIndex
    local selectedTabIndex = global.players[self.playerIndex].projectSettingsSelectedTab
    return FactorioJsx.createElement(
        "frame",
        {direction = "vertical"},
        FactorioJsx.createElement(
            TitleBar,
            nil,
            FactorioJsx.createElement("label", {caption = {"bp100.gui.project-settings.title-caption"}, style = "frame_title", styleMod = {right_margin = 5}, ignored_by_interaction = true}),
            FactorioJsx.createElement(
                ItemRename,
                {
                    name = self.project.name,
                    displayName = self.project:displayName(),
                    renameTooltip = {"bp100.gui.project-settings.rename-project"},
                    maximalWidth = 240
                }
            ),
            FactorioJsx.createElement(DraggableSpace, nil),
            FactorioJsx.createElement(
                CollapseButton,
                {
                    on_gui_click = funcRef(collapseSettings),
                    tooltip = {"bp100.gui.project-settings.hide-full-settings"}
                }
            )
        ),
        FactorioJsx.createElement(
            "flow",
            {direction = "horizontal", styleMod = {horizontal_spacing = 12}},
            FactorioJsx.createElement(
                "flow",
                {direction = "vertical", styleMod = {vertical_spacing = 0}},
                StageListBox(self.project),
                self:NewStageBox()
            ),
            FactorioJsx.createElement(
                "frame",
                {style = "inside_shallow_frame", direction = "vertical", styleMod = {top_padding = 5}},
                FactorioJsx.createElement(
                    "tabbed-pane",
                    {style = "tabbed_pane_with_no_side_padding", styleMod = {vertically_stretchable = true, minimal_width = ProjectSettingsTabWidth}, selected_tab_index = selectedTabIndex},
                    FactorioJsx.createElement("tab", {caption = {"bp100.gui.project-settings.stage"}}),
                    self:StagesTab(),
                    FactorioJsx.createElement("tab", {caption = {"bp100.gui.project-settings.blueprints"}}),
                    self:BlueprintSettingsTab(),
                    FactorioJsx.createElement("tab", {caption = {"bp100.gui.project-settings.other"}}),
                    self:OtherTab()
                )
            )
        )
    )
end
function ProjectSettings.prototype.StagesTab(self)
    local currentStage = playerCurrentStage(self.playerIndex)
    return FactorioJsx.createElement(
        Fn,
        {
            uses = "frame",
            from = currentStage,
            map = ibind(self, "renderStageSettings"),
            direction = "vertical",
            style = "inside_shallow_frame",
            styleMod = {vertically_stretchable = true, horizontally_stretchable = true}
        }
    )
end
function ProjectSettings.prototype.NewStageBox(self)
    return FactorioJsx.createElement(
        "frame",
        {direction = "vertical", style = "bordered_frame", styleMod = {height = NewStageBarHeight, horizontally_stretchable = true, margin = -2, padding = 5}},
        FactorioJsx.createElement("label", {style = "caption_label", caption = {"bp100.gui.project-settings.new-stage"}}),
        FactorioJsx.createElement(
            "button",
            {
                styleMod = {horizontally_stretchable = true},
                caption = {"bp100.gui.project-settings.after-current"},
                on_gui_click = ibind(self, "newStageAfter")
            }
        ),
        FactorioJsx.createElement(
            "button",
            {
                styleMod = {horizontally_stretchable = true},
                caption = {"bp100.gui.project-settings.at-front"},
                on_gui_click = ibind(self, "newStageAtFront")
            }
        )
    )
end
function ProjectSettings.prototype.renderStageSettings(self, stage)
    if stage and stage.project == self.project then
        return FactorioJsx.createElement(____exports.StageSettings, {stage = stage})
    end
    return nil
end
function ProjectSettings.prototype.BlueprintSettingsTab(self)
    return FactorioJsx.createElement(
        "flow",
        {direction = "vertical", styleMod = {vertical_spacing = 0}},
        FactorioJsx.createElement(
            "tabbed-pane",
            {style = "tabbed_pane_with_no_side_padding", selected_tab_index = 1, styleMod = {horizontally_stretchable = true, bottom_margin = -10}},
            FactorioJsx.createElement("tab", {caption = {"bp100.gui.project-settings.blueprint-settings-defaults"}}),
            self:BpSettings(nil),
            FactorioJsx.createElement("tab", {caption = {"bp100.gui.project-settings.blueprint-settings-current-stage"}, tooltip = {"bp100.gui.project-settings.blueprint-settings-current-stage-tooltip"}}),
            FactorioJsx.createElement(
                Fn,
                {
                    uses = "flow",
                    from = playerCurrentStage(self.playerIndex),
                    map = ibind(self, "BpSettings")
                }
            ),
            FactorioJsx.createElement("tab", {caption = {"bp100.gui.project-settings.bp-export"}}),
            self:BpExportTab()
        )
    )
end
function ProjectSettings.prototype.BpSettings(self, stage)
    local settings = stage == nil and self.project.defaultBlueprintSettings or stage:getBlueprintSettingsView()
    return FactorioJsx.createElement(
        "flow",
        {direction = "vertical", styleMod = {padding = 10, bottom_padding = 20}},
        FactorioJsx.createElement(
            "label",
            {
                caption = stage == nil and ({"bp100.gui.project-settings.editing-defaults"}) or stage.name:map(funcRef(ProjectSettings.editingForStage)),
                styleMod = {font = "heading-2", font_color = stage == nil and ({1, 1, 1}) or Colors.OverrideHighlight}
            }
        ),
        FactorioJsx.createElement("line", nil),
        FactorioJsx.createElement(
            "flow",
            {direction = "horizontal", styleMod = {vertical_align = "center"}},
            FactorioJsx.createElement(
                "label",
                {
                    caption = stage == nil and ({"bp100.gui.project-settings.grid-settings"}) or ({"bp100.gui.project-settings.grid-settings-and-icons"}),
                    styleMod = stage and highlightIfNotNil(self:anyGridSettingsChanged(stage))
                }
            ),
            FactorioJsx.createElement(
                EditButton,
                {on_gui_click = bind(
                    ibind(self, "editGridSettings"),
                    settings,
                    stage
                )}
            )
        ),
        FactorioJsx.createElement("label", {caption = {"bp100.gui.project-settings.entity-filters"}, style = "caption_label"}),
        FactorioJsx.createElement(
            "flow",
            {direction = "horizontal", styleMod = {vertical_align = "center"}},
            FactorioJsx.createElement(
                "label",
                {
                    caption = {"bp100.gui.project-settings.blacklist"},
                    styleMod = highlightIfOverriden(settings.blacklist)
                }
            ),
            FactorioJsx.createElement(
                EditButton,
                {on_gui_click = bind(
                    ibind(self, "editFilter"),
                    settings,
                    "blacklist"
                )}
            )
        ),
        FactorioJsx.createElement(
            "flow",
            {direction = "vertical", styleMod = {vertical_spacing = 0}},
            FactorioJsx.createElement(CheckboxTextfield, {captionBefore = {"bp100.gui.project-settings.include-entities-in-the-next-n-stages-1"}, captionAfter = {"bp100.gui.project-settings.include-entities-in-the-next-n-stages-2"}, tooltip = {"bp100.gui.project-settings.include-entities-in-the-next-n-stages-tooltip"}, value = settings.stageLimit}),
            FactorioJsx.createElement(
                "flow",
                {direction = "horizontal", styleMod = {vertical_align = "center"}},
                FactorioJsx.createElement(
                    "label",
                    {
                        caption = {"bp100.gui.project-settings.or-in-whitelist"},
                        styleMod = __TS__ObjectAssign(
                            {left_margin = 28},
                            highlightIfOverriden(settings.additionalWhitelist)
                        ),
                        enabled = settings.stageLimit:truthy()
                    }
                ),
                FactorioJsx.createElement(
                    EditButton,
                    {
                        on_gui_click = bind(
                            ibind(self, "editFilter"),
                            settings,
                            "additionalWhitelist"
                        ),
                        enabled = settings.stageLimit:truthy()
                    }
                )
            )
        ),
        FactorioJsx.createElement("label", {caption = {"bp100.gui.project-settings.entity-edits"}, style = "caption_label"}),
        FactorioJsx.createElement(
            "checkbox",
            {
                state = settings.useModulePreloading,
                caption = {"bp100.gui.project-settings.use-module-preloading"},
                tooltip = {"bp100.gui.project-settings.use-module-preloading-tooltip"},
                styleMod = highlightIfOverriden(settings.useModulePreloading)
            }
        ),
        FactorioJsx.createElement(
            "checkbox",
            {
                state = settings.replaceInfinityEntitiesWithCombinators,
                caption = {"bp100.gui.project-settings.replace-infinity-with-combinators"},
                tooltip = {"bp100.gui.project-settings.replace-infinity-with-combinators-tooltip"},
                styleMod = highlightIfOverriden(settings.replaceInfinityEntitiesWithCombinators)
            }
        ),
        FactorioJsx.createElement("label", {caption = {"bp100.gui.project-settings.tiles"}, style = "caption_label"}),
        FactorioJsx.createElement(
            "checkbox",
            {
                state = settings.autoLandfill,
                caption = {"bp100.gui.project-settings.auto-landfill"},
                tooltip = {"bp100.gui.project-settings.auto-landfill-tooltip"},
                styleMod = highlightIfOverriden(settings.autoLandfill)
            }
        ),
        FactorioJsx.createElement(
            "checkbox",
            {
                state = settings.useNextStageTiles,
                caption = {"bp100.gui.project-settings.use-next-stage-tiles"},
                tooltip = {"bp100.gui.project-settings.use-next-stage-tiles-tooltip"},
                styleMod = highlightIfOverriden(settings.useNextStageTiles)
            }
        )
    )
end
function ProjectSettings.editingForStage(name)
    return {"bp100.gui.project-settings.editing-for-stage", name}
end
function ProjectSettings.prototype.editGridSettings(self, settings, stage)
    local player = game.get_player(self.playerIndex)
    if not player then
        return
    end
    local stageToUse = stage or self.project:getStage(self.project:numStages())
    local name = stage and stage.name:get() or "Defaults (only grid settings saved)"
    local successful = editInItemBlueprintSettings(
        player,
        settings,
        stageToUse.surface,
        stageToUse:getBlueprintBBox(),
        name
    )
    if not successful then
        player.create_local_flying_text({text = {"bp100.interaction.blueprint-empty"}, create_at_cursor = true})
    end
end
function ProjectSettings.prototype.editFilter(self, settings, ____type)
    local player = game.get_player(self.playerIndex)
    if not player then
        return
    end
    editBlueprintFilters(player, settings, ____type)
end
function ProjectSettings.prototype.anyGridSettingsChanged(self, stage)
    local stageSettings = stage.stageBlueprintSettings
    return multiMap(
        funcRef(ProjectSettings.anyNotNil),
        stageSettings.snapToGrid,
        stageSettings.positionOffset,
        stageSettings.absoluteSnapping,
        stageSettings.positionRelativeToGrid
    )
end
function ProjectSettings.anyNotNil(a, b, c, d)
    return a or b or c or d
end
function ProjectSettings.prototype.BpExportTab(self)
    return FactorioJsx.createElement(
        "flow",
        {direction = "vertical", styleMod = {padding = 10}},
        FactorioJsx.createElement(
            "button",
            {
                caption = {"bp100.gui.project-settings.get-blueprint-for-current-stage"},
                styleMod = {width = BpSettingsButtonWidth},
                on_gui_click = ibind(self, "getBlueprint")
            }
        ),
        FactorioJsx.createElement("line", nil),
        FactorioJsx.createElement(
            "button",
            {
                caption = {"bp100.gui.project-settings.make-blueprint-book"},
                tooltip = {"bp100.gui.project-settings.make-blueprint-book-tooltip"},
                styleMod = {width = BpSettingsButtonWidth},
                on_gui_click = ibind(self, "makeBlueprintBook")
            }
        ),
        FactorioJsx.createElement(
            "button",
            {
                caption = {"bp100.gui.project-settings.export-blueprint-book-string-to-file"},
                tooltip = {"bp100.gui.project-settings.export-blueprint-book-string-to-file-tooltip"},
                styleMod = {width = BpSettingsButtonWidth},
                on_gui_click = ibind(self, "exportBlueprintBookStringToFile")
            }
        )
    )
end
function ProjectSettings.prototype.getBlueprint(self)
    local stage = playerCurrentStage(self.playerIndex):get()
    if not stage or stage.project ~= self.project then
        return
    end
    local player = game.get_player(self.playerIndex)
    if not player or not player.clear_cursor() then
        return
    end
    local stack = player.cursor_stack
    if not stack then
        return
    end
    local successful = takeStageBlueprint(stage, stack)
    if not successful then
        player.create_local_flying_text({text = {"bp100.interaction.blueprint-empty"}, create_at_cursor = true})
        return
    end
end
function ProjectSettings.prototype.makeBlueprintBook(self)
    local player = game.get_player(self.playerIndex)
    if not player or not player.clear_cursor() then
        return
    end
    local stack = player.cursor_stack
    if not stack then
        return
    end
    submitProjectBlueprintBookTask(self.project, stack)
end
function ProjectSettings.prototype.exportBlueprintBookStringToFile(self)
    local player = game.get_player(self.playerIndex)
    if not player then
        return
    end
    local fileName = exportBlueprintBookToFile(self.project, player)
    if fileName == nil then
        player.create_local_flying_text({text = {"bp100.interaction.blueprint-book-empty"}, create_at_cursor = true})
    else
        player.print({"bp100.interaction.blueprint-book-exported", fileName})
    end
end
function ProjectSettings.prototype.OtherTab(self)
    return FactorioJsx.createElement(
        "flow",
        {direction = "vertical", styleMod = {padding = {5, 10}}},
        FactorioJsx.createElement(
            "button",
            {
                caption = {"bp100.gui.project-settings.rebuild-all-stages"},
                styleMod = {width = OtherSettingsButtonWidth},
                on_gui_click = ibind(self, "rebuildAllStages")
            }
        ),
        FactorioJsx.createElement("line", nil),
        FactorioJsx.createElement(
            "button",
            {
                style = "red_button",
                caption = {"bp100.gui.project-settings.delete-project"},
                styleMod = {width = OtherSettingsButtonWidth},
                on_gui_click = ibind(self, "beginDelete")
            }
        ),
        FactorioJsx.createElement(VerticalPusher, nil),
        FactorioJsx.createElement(
            "button",
            {
                style = "mini_button",
                tooltip = "super secret setting",
                on_gui_click = ibind(self, "sss")
            }
        )
    )
end
function ProjectSettings.prototype.rebuildAllStages(self)
    self.project.entityUpdates.rebuildAllStages()
end
function ProjectSettings.prototype.beginDelete(self)
    local player = game.get_player(self.playerIndex)
    if not player then
        return
    end
    showDialog(
        player,
        {
            title = {"bp100.gui.project-settings.delete-project"},
            message = {
                {
                    "bp100.gui.project-settings.delete-project-confirmation1",
                    self.project:displayName():get()
                },
                {"bp100.gui.project-settings.delete-project-confirmation2"}
            },
            redConfirm = true,
            backCaption = {"gui.cancel"},
            confirmCaption = {"gui.delete"},
            onConfirm = ibind(self, "deleteProject")
        }
    )
end
function ProjectSettings.prototype.deleteProject(self)
    self.project:delete()
    exitProject(game.get_player(self.playerIndex))
end
function ProjectSettings.prototype.newStageAfter(self)
    local currentStage = playerCurrentStage(self.playerIndex):get()
    if not currentStage or currentStage.project ~= self.project then
        return
    end
    self:insertStage(currentStage.stageNumber + 1)
end
function ProjectSettings.prototype.newStageAtFront(self)
    self:insertStage(1)
end
function ProjectSettings.prototype.insertStage(self, index)
    if not self.project.valid then
        return
    end
    local stage = self.project:insertStage(index)
    teleportToStage(
        game.get_player(self.playerIndex),
        stage
    )
end
function ProjectSettings.prototype.sss(self)
    self.sssCount = self.sssCount + 1
    if self.sssCount >= 3 then
        local player = game.get_player(self.playerIndex)
        if not player then
            return
        end
        player.play_sound({path = "bp100:banana"})
        self.sssCount = 0
    end
end
ProjectSettings = __TS__DecorateLegacy(
    {RegisterClass("gui:ProjectSettings")},
    ProjectSettings
)
____exports.StageSettings = __TS__Class()
local StageSettings = ____exports.StageSettings
StageSettings.name = "StageSettings"
__TS__ClassExtends(StageSettings, Component)
function StageSettings.prototype.render(self, props, context)
    self.stage = props.stage
    self.playerIndex = context.playerIndex
    local selectedTile = self.stage.project.landfillTile
    local selectedTileValue = selectedTile:get()
    local ____selectedTileValue_2 = selectedTileValue
    if ____selectedTileValue_2 then
        local ____opt_0 = game.tile_prototypes[selectedTileValue]
        ____selectedTileValue_2 = not (____opt_0 and ____opt_0.items_to_place_this)
    end
    local tileIsNotBlueprintable = ____selectedTileValue_2
    local allowNonBlueprintable = property(not not tileIsNotBlueprintable)
    return FactorioJsx.createElement(
        FactorioJsx.Fragment,
        nil,
        FactorioJsx.createElement(
            "frame",
            {style = "subheader_frame", direction = "horizontal"},
            FactorioJsx.createElement(ItemRename, {name = props.stage.name, displayName = props.stage.name, renameTooltip = {"bp100.gui.project-settings.rename-stage"}, maximalWidth = ProjectSettingsTabWidth}),
            FactorioJsx.createElement(HorizontalPusher, nil),
            FactorioJsx.createElement(
                TrashButton,
                {
                    tooltip = {"bp100.gui.project-settings.delete-stage"},
                    enabled = self.stage.project:numStages() > 1,
                    on_gui_click = ibind(self, "beginDelete")
                }
            )
        ),
        FactorioJsx.createElement(
            "flow",
            {direction = "vertical", styleMod = {padding = {5, 10}}},
            FactorioJsx.createElement("label", {style = "caption_label", caption = {"bp100.gui.project-settings.entities"}}),
            FactorioJsx.createElement(
                "button",
                {
                    styleMod = {width = StageSettingsButtonWidth},
                    caption = {"bp100.gui.project-settings.reset-stage"},
                    tooltip = {"bp100.gui.project-settings.reset-stage-tooltip"},
                    on_gui_click = ibind(self, "resetStage")
                }
            ),
            FactorioJsx.createElement(
                "flow",
                nil,
                FactorioJsx.createElement(
                    "button",
                    {
                        styleMod = {width = StageSettingsButtonWidth},
                        caption = {"bp100.gui.project-settings.disable-all-entities"},
                        on_gui_click = ibind(self, "disableAllEntities")
                    }
                ),
                FactorioJsx.createElement(
                    "button",
                    {
                        styleMod = {width = StageSettingsButtonWidth},
                        caption = {"bp100.gui.project-settings.enable-all-entities"},
                        on_gui_click = ibind(self, "enableAllEntities")
                    }
                )
            ),
            FactorioJsx.createElement("line", nil),
            FactorioJsx.createElement("label", {style = "caption_label", caption = {"bp100.gui.project-settings.set-tiles"}}),
            FactorioJsx.createElement(
                "flow",
                {styleMod = {vertical_align = "center"}},
                FactorioJsx.createElement(
                    "flow",
                    {direction = "horizontal", styleMod = {width = StageSettingsButtonWidth, vertical_align = "center"}},
                    FactorioJsx.createElement("label", {caption = {"bp100.gui.project-settings.selected-tile"}}),
                    FactorioJsx.createElement(
                        "choose-elem-button",
                        {
                            elem_type = "tile",
                            elem_value = selectedTile,
                            elem_filters = allowNonBlueprintable:select(nil, {{filter = "item-to-place"}})
                        }
                    )
                ),
                FactorioJsx.createElement("checkbox", {state = allowNonBlueprintable, caption = {"bp100.gui.project-settings.allow-non-blueprintable-tiles"}})
            ),
            FactorioJsx.createElement(
                "flow",
                nil,
                FactorioJsx.createElement(
                    "button",
                    {
                        styleMod = {width = StageSettingsButtonWidth},
                        caption = {"bp100.gui.project-settings.set-lab-tiles"},
                        on_gui_click = ibind(self, "setLabTiles")
                    }
                ),
                FactorioJsx.createElement(
                    "button",
                    {
                        styleMod = {width = StageSettingsButtonWidth},
                        caption = {"bp100.gui.project-settings.set-selected-tile"},
                        on_gui_click = ibind(self, "setSelectedTile")
                    }
                )
            ),
            FactorioJsx.createElement(
                "flow",
                nil,
                FactorioJsx.createElement(
                    "button",
                    {
                        styleMod = {width = StageSettingsButtonWidth},
                        caption = {"bp100.gui.project-settings.set-selected-tile-and-lab"},
                        tooltip = {"bp100.gui.project-settings.set-selected-tile-and-lab-tooltip"},
                        on_gui_click = ibind(self, "setLandfillAndLabTiles")
                    }
                ),
                FactorioJsx.createElement(
                    "button",
                    {
                        styleMod = {width = StageSettingsButtonWidth},
                        caption = {"bp100.gui.project-settings.set-selected-tile-and-water"},
                        tooltip = {"bp100.gui.project-settings.set-selected-tile-and-water-tooltip"},
                        on_gui_click = ibind(self, "setLandfillAndWater")
                    }
                )
            )
        )
    )
end
function StageSettings.prototype.resetStage(self)
    local stage = self.stage
    if stage.valid then
        stage.project.entityUpdates.rebuildStage(stage.stageNumber)
    end
end
function StageSettings.prototype.setLabTiles(self)
    setCheckerboard(
        self.stage.surface,
        self.stage:getBlueprintBBox()
    )
end
function StageSettings.prototype.setSelectedTile(self)
    self:trySetLandfillTile(setTilesForStage)
end
function StageSettings.prototype.setLandfillAndWater(self)
    self:trySetLandfillTile(setTilesAndWaterForStage)
end
function StageSettings.prototype.setLandfillAndLabTiles(self)
    self:trySetLandfillTile(setTilesAndCheckerboardForStage)
end
function StageSettings.prototype.trySetLandfillTile(self, fn)
    local stage = self.stage
    if not stage.valid then
        return
    end
    local success = fn(stage)
    if not success then
        local ____opt_3 = game.get_player(self.playerIndex)
        if ____opt_3 ~= nil then
            ____opt_3.create_local_flying_text({text = {"bp100.gui.project-settings.failed-to-set-tiles"}, create_at_cursor = true})
        end
    end
end
function StageSettings.prototype.disableAllEntities(self)
    local stage = self.stage
    if not stage.valid then
        return
    end
    stage.project.entityUpdates.disableAllEntitiesInStage(stage.stageNumber)
end
function StageSettings.prototype.enableAllEntities(self)
    local stage = self.stage
    if not stage.valid then
        return
    end
    stage.project.entityUpdates.enableAllEntitiesInStage(stage.stageNumber)
end
function StageSettings.prototype.beginDelete(self)
    local player = game.get_player(self.playerIndex)
    if not player then
        return
    end
    local ____temp_5 = self:getStageToMerge()
    local isFirst = ____temp_5.isFirst
    local toMerge = ____temp_5.toMerge
    if not toMerge then
        return
    end
    showDialog(
        player,
        {
            title = {"bp100.gui.project-settings.delete-stage"},
            message = {
                {
                    "bp100.gui.project-settings.delete-stage-confirmation1",
                    self.stage.name:get()
                },
                {
                    isFirst and "bp100.gui.project-settings.delete-stage-confirmation2-first" or "bp100.gui.project-settings.delete-stage-confirmation2-middle",
                    toMerge.name:get()
                }
            },
            redConfirm = true,
            backCaption = {"gui.cancel"},
            confirmCaption = {"gui.delete"},
            onConfirm = ibind(self, "deleteStage")
        }
    )
end
function StageSettings.prototype.getStageToMerge(self)
    local stageNumber = self.stage.stageNumber
    local isFirst = stageNumber == 1
    local toMerge = self.stage.project:getStage(getStageToMerge(stageNumber))
    return {isFirst = isFirst, toMerge = toMerge}
end
function StageSettings.prototype.deleteStage(self)
    local ____temp_6 = self:getStageToMerge()
    local toMerge = ____temp_6.toMerge
    if not toMerge then
        return
    end
    local player = game.get_player(self.playerIndex)
    recordPlayerLastPosition(player)
    self.stage:deleteInProject()
    teleportToStage(player, toMerge)
end
StageSettings = __TS__DecorateLegacy(
    {RegisterClass("gui:StageSettings")},
    StageSettings
)
____exports.StageSettings = StageSettings
ProjectSettingsHeight = StageListBoxHeight + 120
ProjectSettingsWidth = StageListBoxWidth + ProjectSettingsTabWidth + 30
ProjectSettingsName = script.mod_name .. ":project-settings"
DefaultProjectSettingsLoc = {x = 0, y = 350}
registerFunctions("gui:project-settings", {expandSettings = expandSettings, collapseSettings = collapseSettings})
PlayerChangedStageEvent:addListener(function(player, newStage, oldStage)
    local newProject = newStage and newStage.project
    local oldProject = oldStage and oldStage.project
    if newProject ~= oldProject then
        renderGuiForProject(player, newProject)
    else
        ____exports.bringSettingsWindowToFront(player)
    end
end)
function ____exports.refreshCurrentProject()
    for ____, player in pairs(game.players) do
        local currentStage = playerCurrentStage(player.index):get()
        renderGuiForProject(player, currentStage and currentStage.project)
    end
end
Migrations.to(
    "0.15.1",
    function()
        for ____, player in pairs(game.players) do
            destroy(player.gui.screen["gui:AssemblySettingsFrame"])
            local playerData = global.players[player.index]
            if playerData ~= nil then
                playerData.currentShownAssembly = nil
            end
            local ____ = true
        end
    end
)
Migrations.fromAny(____exports.refreshCurrentProject)
Migrations.early(
    "0.23.0",
    function()
        local oldProjectSettingsName = script.mod_name .. ":assembly-settings"
        for ____, player in pairs(game.players) do
            destroy(player.gui.screen[oldProjectSettingsName])
        end
    end
)
return ____exports
