local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__ObjectAssign = ____lualib.__TS__ObjectAssign
local __TS__New = ____lualib.__TS__New
local __TS__ArrayMap = ____lualib.__TS__ArrayMap
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local ____exports = {}
local ____lib = require("lib.index")
local assertNever = ____lib.assertNever
local bind = ____lib.bind
local ibind = ____lib.ibind
local RegisterClass = ____lib.RegisterClass
local Subscription = ____lib.Subscription
local ____factoriojsx = require("lib.factoriojsx.index")
local Component = ____factoriojsx.Component
local FactorioJsx = ____factoriojsx.FactorioJsx
local ____player_2Dcurrent_2Dstage = require("ui.player-current-stage")
local playerCurrentStage = ____player_2Dcurrent_2Dstage.playerCurrentStage
local teleportToStage = ____player_2Dcurrent_2Dstage.teleportToStage
____exports.StageSelector = __TS__Class()
local StageSelector = ____exports.StageSelector
StageSelector.name = "StageSelector"
__TS__ClassExtends(StageSelector, Component)
function StageSelector.prototype.render(self, props, context)
    self.project = props.project
    self.trackerSubscription = context:getSubscription()
    self.playerIndex = context.playerIndex
    context:onMount(function() return self:setup() end)
    return FactorioJsx.createElement(
        props.uses,
        __TS__ObjectAssign(
            {},
            props,
            {
                onCreate = function(____, e)
                    local ____e_0 = e
                    self.element = ____e_0
                    return ____e_0
                end,
                on_gui_selection_state_changed = ibind(self, "onSelectedIndexChanged")
            }
        )
    )
end
function StageSelector.prototype.setup(self)
    local ____opt_1 = self.elementSubscription
    if ____opt_1 ~= nil then
        ____opt_1:close()
    end
    local ____TS__New_result_3 = __TS__New(Subscription)
    self.elementSubscription = ____TS__New_result_3
    local subscription = ____TS__New_result_3
    self.trackerSubscription:add(subscription)
    local stages = self.project:getAllStages()
    self.element.items = __TS__ArrayMap(
        stages,
        function(____, l) return l.name:get() end
    )
    for ____, stage in ipairs(stages) do
        stage.name:subscribe(
            subscription,
            bind(
                ibind(self, "setDropDownItem"),
                stage.stageNumber
            )
        )
    end
    playerCurrentStage(self.playerIndex):subscribeAndRaise(
        subscription,
        ibind(self, "playerStageChanged")
    )
    self.project.localEvents:subscribe(
        subscription,
        ibind(self, "onProjectEvent")
    )
end
function StageSelector.prototype.onProjectEvent(self, event)
    if event.type == "stage-added" or event.type == "stage-deleted" then
        self:setup()
    elseif event.type ~= "project-deleted" and event.type ~= "pre-stage-deleted" then
        assertNever(event)
    end
end
function StageSelector.prototype.setDropDownItem(self, stageNumber, name)
    self.element.set_item(stageNumber, name)
end
function StageSelector.prototype.onSelectedIndexChanged(self)
    if not self.project.valid then
        return
    end
    local index = self.element.selected_index
    local stage = self.project:getStage(index)
    if not stage then
        return
    end
    teleportToStage(
        game.get_player(self.playerIndex),
        stage
    )
end
function StageSelector.prototype.playerStageChanged(self, stage)
    if stage and stage.project == self.project and stage.stageNumber <= #self.element.items then
        self.element.selected_index = stage.stageNumber
        if self.element.type == "list-box" then
            self.element.scroll_to_item(stage.stageNumber)
        end
    else
        self.element.selected_index = 0
    end
end
StageSelector = __TS__DecorateLegacy(
    {RegisterClass("gui:CurrentStage")},
    StageSelector
)
____exports.StageSelector = StageSelector
return ____exports
