local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local ____exports = {}
local ____lib = require("lib.index")
local ibind = ____lib.ibind
local RegisterClass = ____lib.RegisterClass
local ____factoriojsx = require("lib.factoriojsx.index")
local Component = ____factoriojsx.Component
local FactorioJsx = ____factoriojsx.FactorioJsx
local ____DiffedProperty = require("utils.DiffedProperty")
local getDefaultValueIfIsOverridenProp = ____DiffedProperty.getDefaultValueIfIsOverridenProp
local highlightIfOverriden = ____DiffedProperty.highlightIfOverriden
____exports.CheckboxTextfield = __TS__Class()
local CheckboxTextfield = ____exports.CheckboxTextfield
CheckboxTextfield.name = "CheckboxTextfield"
__TS__ClassExtends(CheckboxTextfield, Component)
function CheckboxTextfield.prototype.render(self, props)
    local ____props_0 = props
    local captionBefore = ____props_0.captionBefore
    local captionAfter = ____props_0.captionAfter
    local value = ____props_0.value
    self.value = value
    local isTruthy = self.value:truthy()
    local highlightStyleMod = highlightIfOverriden(value)
    return FactorioJsx.createElement(
        "flow",
        {direction = "horizontal", styleMod = {vertical_align = "center"}},
        FactorioJsx.createElement(
            "checkbox",
            {
                state = isTruthy,
                caption = captionBefore,
                styleMod = highlightStyleMod,
                on_gui_checked_state_changed = ibind(self, "onCheckboxChanged"),
                onCreate = function(____, e)
                    local ____e_1 = e
                    self.checkbox = ____e_1
                    return ____e_1
                end
            }
        ),
        FactorioJsx.createElement(
            "textfield",
            {
                style = "short_number_textfield",
                numeric = true,
                clear_and_focus_on_right_click = true,
                allow_decimal = false,
                allow_negative = false,
                text = self.value:map(ibind(self, "valueToText")),
                enabled = isTruthy,
                on_gui_text_changed = ibind(self, "onTextChanged"),
                onCreate = function(____, e)
                    local ____e_2 = e
                    self.textfield = ____e_2
                    return ____e_2
                end,
                styleMod = {width = 50}
            }
        ),
        FactorioJsx.createElement("label", {caption = captionAfter, tooltip = props.tooltip, styleMod = highlightStyleMod})
    )
end
function CheckboxTextfield.prototype.valueToText(self, value)
    if value == nil then
        return ""
    end
    return tostring(value)
end
function CheckboxTextfield.prototype.onCheckboxChanged(self, e)
    local newState = e.element.state
    if newState then
        self.value:set(getDefaultValueIfIsOverridenProp(self.value) or 1)
    else
        self.value:set(nil)
    end
end
function CheckboxTextfield.prototype.onTextChanged(self, e)
    local number = tonumber(e.text)
    if number == nil then
        return
    end
    self.value:set(number)
end
CheckboxTextfield = __TS__DecorateLegacy(
    {RegisterClass("gui:CheckboxTextfield")},
    CheckboxTextfield
)
____exports.CheckboxTextfield = CheckboxTextfield
return ____exports
