local ____lualib = require("lualib_bundle")
local __TS__ObjectAssign = ____lualib.__TS__ObjectAssign
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__ObjectKeys = ____lualib.__TS__ObjectKeys
local __TS__ArrayFlatMap = ____lualib.__TS__ArrayFlatMap
local __TS__ArraySort = ____lualib.__TS__ArraySort
local __TS__ArrayMap = ____lualib.__TS__ArrayMap
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local __TS__ArrayIsArray = ____lualib.__TS__ArrayIsArray
local ____exports = {}
local renderEntityStageInfo, destroyEntityStageInfo, tryRenderExtraStageInfo, reopenEntity, relative_gui_position, EntityProjectInfo, EntityProjectInfoName, EntityProjectInfoName2, fakeRerenderTranslationId, entityTypeToGuiType
local ____lib = require("lib.index")
local bind = ____lib.bind
local ibind = ____lib.ibind
local ProtectedEvents = ____lib.ProtectedEvents
local RegisterClass = ____lib.RegisterClass
local ____factoriojsx = require("lib.factoriojsx.index")
local Component = ____factoriojsx.Component
local destroy = ____factoriojsx.destroy
local FactorioJsx = ____factoriojsx.FactorioJsx
local renderNamed = ____factoriojsx.renderNamed
local ____components = require("lib.factoriojsx.components.index")
local DraggableSpace = ____components.DraggableSpace
local HorizontalPusher = ____components.HorizontalPusher
local RefreshButton = ____components.RefreshButton
local TitleBar = ____components.TitleBar
local ____migration = require("lib.migration")
local Migrations = ____migration.Migrations
local ____event_2Dhandlers = require("project.event-handlers")
local checkForEntityUpdates = ____event_2Dhandlers.checkForEntityUpdates
local ____entity_2Dutil = require("ui.entity-util")
local getProjectEntityOfEntity = ____entity_2Dutil.getProjectEntityOfEntity
local ____player_2Dcurrent_2Dstage = require("ui.player-current-stage")
local PlayerChangedStageEvent = ____player_2Dcurrent_2Dstage.PlayerChangedStageEvent
local teleportToStage = ____player_2Dcurrent_2Dstage.teleportToStage
function renderEntityStageInfo(player, entity, projectEntity, stage)
    local guiType = entityTypeToGuiType[entity.type]
    if not guiType then
        return
    end
    local mainGuiType
    if __TS__ArrayIsArray(guiType) then
        mainGuiType = guiType[1]
    else
        mainGuiType = guiType
    end
    local position = relative_gui_position[player.mod_settings["bp100:entity-info-location"].value]
    renderNamed(
        FactorioJsx.createElement(EntityProjectInfo, {projectEntity = projectEntity, stage = stage, anchor = {gui = mainGuiType, position = position}}),
        player.gui.relative,
        EntityProjectInfoName
    )
    if __TS__ArrayIsArray(guiType) then
        renderNamed(
            FactorioJsx.createElement(EntityProjectInfo, {projectEntity = projectEntity, stage = stage, anchor = {gui = guiType[2], position = position}}),
            player.gui.relative,
            EntityProjectInfoName2
        )
    end
end
function destroyEntityStageInfo(player)
    local relative = player.gui.relative
    destroy(relative[EntityProjectInfoName])
    destroy(relative[EntityProjectInfoName2])
end
function tryRenderExtraStageInfo(player, entity)
    local stage, projectEntity = getProjectEntityOfEntity(entity)
    if not stage then
        destroyEntityStageInfo(player)
        return false
    end
    renderEntityStageInfo(player, entity, projectEntity, stage)
    return true
end
function reopenEntity(player)
    local opened = player.opened
    if opened and opened.object_name == "LuaEntity" then
        global.players[player.index].entityToReopen = opened
        player.opened = nil
        player.request_translation({fakeRerenderTranslationId})
    end
end
relative_gui_position = defines.relative_gui_position
local relative_gui_type = defines.relative_gui_type
PlayerChangedStageEvent:addListener(function(player, stage)
    local entity = player.opened
    if not entity or entity.object_name ~= "LuaEntity" then
        return
    end
    local oldStage, projectEntity = getProjectEntityOfEntity(entity)
    if not oldStage or oldStage == stage then
        return
    end
    if stage == nil or oldStage.project ~= stage.project then
        player.opened = nil
        return
    end
    player.opened = projectEntity:getWorldOrPreviewEntity(stage.stageNumber)
end)
local StageButtonWidth = 100
local StageButtonHeight = 28
local function SmallToolButton(props)
    return FactorioJsx.createElement(
        "sprite-button",
        __TS__ObjectAssign({style = "mini_button", styleMod = {size = {20, 20}}}, props)
    )
end
EntityProjectInfo = __TS__Class()
EntityProjectInfo.name = "EntityProjectInfo"
__TS__ClassExtends(EntityProjectInfo, Component)
function EntityProjectInfo.prototype.render(self, props, context)
    self.playerIndex = context.playerIndex
    local ____props_0 = props
    local stage = ____props_0.stage
    local entity = ____props_0.projectEntity
    self.stage = stage
    self.entity = entity
    local currentStageNum = stage.stageNumber
    local project = stage.project
    self.actions = project.actions
    self.updates = project.updates
    local isRollingStock = entity:isRollingStock()
    local firstStageNum = entity.firstStage
    local firstStage = project:getStage(firstStageNum)
    local stageDiffs = entity.stageDiffs
    local currentStageDiff = stageDiffs and stageDiffs[currentStageNum]
    local lastStage = entity.lastStage
    local isErrorEntity = entity:isInStage(currentStageNum) and entity:getWorldEntity(currentStageNum) == nil
    local function StageButton(buttonStage)
        return FactorioJsx.createElement(
            "button",
            {
                caption = buttonStage.name,
                styleMod = {width = StageButtonWidth, height = StageButtonHeight},
                enabled = buttonStage ~= stage,
                on_gui_click = bind(EntityProjectInfo.teleportToStageAction, buttonStage)
            }
        )
    end
    return FactorioJsx.createElement(
        "frame",
        {anchor = props.anchor, style = "inner_frame_in_outer_frame", direction = "vertical"},
        FactorioJsx.createElement(
            TitleBar,
            nil,
            FactorioJsx.createElement("label", {style = "frame_title", caption = {"bp100.gui.entity-info.title"}}),
            FactorioJsx.createElement(DraggableSpace, nil),
            FactorioJsx.createElement(
                RefreshButton,
                {on_gui_click = ibind(self, "refresh")}
            )
        ),
        FactorioJsx.createElement(
            "frame",
            {style = "inside_shallow_frame_with_padding", direction = "vertical"},
            FactorioJsx.createElement(
                "table",
                {column_count = 2, styleMod = {vertical_spacing = 0}},
                FactorioJsx.createElement("label", {caption = {"bp100.gui.entity-info.first-stage"}}),
                StageButton(firstStage),
                stageDiffs and FactorioJsx.createElement("label", {caption = {"bp100.gui.entity-info.stages-with-changes"}}),
                stageDiffs and __TS__ArrayFlatMap(
                    __TS__ObjectKeys(stageDiffs),
                    function(____, stageNum)
                        local stage = project:getStage(stageNum)
                        return {
                            StageButton(stage),
                            FactorioJsx.createElement("empty-widget", nil)
                        }
                    end
                ),
                lastStage ~= nil and FactorioJsx.createElement("label", {caption = {"bp100.gui.entity-info.last-stage"}}),
                lastStage ~= nil and StageButton(project:getStage(lastStage))
            ),
            lastStage ~= nil and FactorioJsx.createElement(
                "button",
                {
                    styleMod = {horizontally_stretchable = true},
                    caption = {"bp100.gui.entity-info.remove-last-stage"},
                    on_gui_click = ibind(self, "removeLastStage")
                }
            ),
            FactorioJsx.createElement(
                "button",
                {
                    styleMod = {horizontally_stretchable = true},
                    caption = {"bp100.gui.entity-info.move-to-this-stage"},
                    on_gui_click = ibind(self, "moveToThisStage"),
                    enabled = firstStageNum ~= currentStageNum
                }
            ),
            isRollingStock and ({
                FactorioJsx.createElement("line", {direction = "horizontal", style = "control_behavior_window_line"}),
                FactorioJsx.createElement(
                    "button",
                    {
                        styleMod = {horizontally_stretchable = true},
                        caption = {"bp100.gui.entity-info.reset-train"},
                        on_gui_click = ibind(self, "resetTrain")
                    }
                ),
                FactorioJsx.createElement(
                    "button",
                    {
                        styleMod = {horizontally_stretchable = true},
                        caption = {"bp100.gui.entity-info.set-train-location-here"},
                        on_gui_click = ibind(self, "setTrainLocationHere")
                    }
                )
            }),
            currentStageDiff and ({
                FactorioJsx.createElement("line", {direction = "horizontal", style = "control_behavior_window_line"}),
                self:renderStageDiffSettings(currentStageDiff)
            }),
            isErrorEntity and ({
                FactorioJsx.createElement("line", {direction = "horizontal", style = "control_behavior_window_line"}),
                FactorioJsx.createElement(
                    "button",
                    {
                        style = "red_button",
                        styleMod = {horizontally_stretchable = true},
                        caption = {"bp100.gui.entity-info.delete-entity"},
                        on_gui_click = ibind(self, "deleteEntity")
                    }
                )
            })
        )
    )
end
function EntityProjectInfo.teleportToStageAction(stage, event)
    local player = game.get_player(event.player_index)
    if player then
        teleportToStage(player, stage)
    end
end
function EntityProjectInfo.prototype.moveToThisStage(self)
    local wasSettingsRemnant = self.entity.isSettingsRemnant
    if wasSettingsRemnant then
        self.actions.userRevivedSettingsRemnant(self.entity, self.stage.stageNumber, self.playerIndex)
    else
        self.actions.userMoveEntityToStageWithUndo(self.entity, self.stage.stageNumber, self.playerIndex)
    end
    local ____self_rerender_2 = self.rerender
    local ____wasSettingsRemnant_1 = wasSettingsRemnant
    if ____wasSettingsRemnant_1 == nil then
        ____wasSettingsRemnant_1 = true
    end
    ____self_rerender_2(self, ____wasSettingsRemnant_1)
end
function EntityProjectInfo.prototype.removeLastStage(self)
    self.actions.userSetLastStageWithUndo(self.entity, nil, self.playerIndex)
    self:rerender(false)
end
function EntityProjectInfo.prototype.resetTrain(self)
    self.updates.resetTrain(self.entity)
end
function EntityProjectInfo.prototype.setTrainLocationHere(self)
    self.updates.setTrainLocationToCurrent(self.entity)
end
function EntityProjectInfo.prototype.deleteEntity(self)
    self.updates.forceDeleteEntity(self.entity)
end
function EntityProjectInfo.prototype.renderStageDiffSettings(self, stageDiff)
    local diffEntries = __TS__ArraySort(__TS__ObjectKeys(stageDiff))
    local nextLowerStageNum = self.entity:prevStageWithDiff(self.stage.stageNumber) or self.entity.firstStage
    local nextLowerStageName = self.stage.project:getStage(nextLowerStageNum).name:get()
    return FactorioJsx.createElement(
        FactorioJsx.Fragment,
        nil,
        FactorioJsx.createElement("label", {caption = {"bp100.gui.entity-info.stage-diff"}, style = "heading_2_label"}),
        __TS__ArrayMap(
            diffEntries,
            function(____, k) return self:renderPropertyOptions(k, nextLowerStageName) end
        ),
        #diffEntries > 1 and self:renderPropertyOptions(true, nextLowerStageName)
    )
end
function EntityProjectInfo.prototype.renderPropertyOptions(self, prop, nextLowerStageName)
    local caption = prop == true and ({"bp100.gui.entity-info.all-props"}) or prop
    return FactorioJsx.createElement(
        "flow",
        {direction = "horizontal"},
        FactorioJsx.createElement("label", {caption = caption}),
        FactorioJsx.createElement(HorizontalPusher, nil),
        FactorioJsx.createElement(
            SmallToolButton,
            {
                sprite = "utility/close_black",
                tooltip = {"bp100.gui.entity-info.reset-prop"},
                tags = {prop = prop},
                on_gui_click = ibind(self, "resetProp")
            }
        ),
        FactorioJsx.createElement(
            SmallToolButton,
            {
                sprite = "utility/speed_down",
                tooltip = {"bp100.gui.entity-info.apply-to-lower-stage", nextLowerStageName},
                tags = {prop = prop},
                on_gui_click = ibind(self, "applyToLowerStage")
            }
        )
    )
end
function EntityProjectInfo.prototype.resetProp(self, event)
    local prop = event.element.tags.prop
    if prop == true then
        self.updates.resetAllProps(self.entity, self.stage.stageNumber)
    else
        self.updates.resetProp(self.entity, self.stage.stageNumber, prop)
    end
    self:rerender(true)
end
function EntityProjectInfo.prototype.applyToLowerStage(self, event)
    local prop = event.element.tags.prop
    if prop == true then
        self.updates.moveAllPropsDown(self.entity, self.stage.stageNumber)
    else
        self.updates.movePropDown(self.entity, self.stage.stageNumber, prop)
    end
    self:rerender(false)
end
function EntityProjectInfo.prototype.rerender(self, reopen)
    local player = game.get_player(self.playerIndex)
    if not player then
        return
    end
    local worldEntity = self.entity:getWorldOrPreviewEntity(self.stage.stageNumber)
    if not worldEntity then
        player.opened = nil
        return
    end
    local currentOpened = player.opened
    if currentOpened == nil then
        player.opened = worldEntity
        return
    end
    if currentOpened ~= worldEntity then
        return
    end
    if reopen then
        reopenEntity(player)
    else
        tryRenderExtraStageInfo(player, worldEntity)
    end
end
function EntityProjectInfo.prototype.refresh(self)
    local player = game.get_player(self.playerIndex)
    if not player then
        return
    end
    local opened = player.opened
    if opened and opened.object_name == "LuaEntity" then
        checkForEntityUpdates(opened, self.playerIndex)
        tryRenderExtraStageInfo(player, opened)
    end
end
EntityProjectInfo = __TS__DecorateLegacy(
    {RegisterClass("EntityProjectInfo")},
    EntityProjectInfo
)
EntityProjectInfoName = script.mod_name .. ":EntityProjectInfo"
EntityProjectInfoName2 = script.mod_name .. ":EntityProjectInfo2"
local Events = ProtectedEvents
fakeRerenderTranslationId = script.mod_name .. ":rerender-fake-translation"
Events.on_string_translated(function(event)
    local str = event.localised_string
    if not __TS__ArrayIsArray(str) or str[1] ~= fakeRerenderTranslationId then
        return
    end
    local playerData = global.players[event.player_index]
    local entity = playerData.entityToReopen
    playerData.entityToReopen = nil
    if entity and entity.valid then
        local player = game.get_player(event.player_index)
        player.opened = entity
    end
end)
Events.on_gui_opened(function(e)
    if e.entity then
        tryRenderExtraStageInfo(
            game.get_player(e.player_index),
            e.entity
        )
    end
end)
Events.on_gui_closed(function(e)
    if e.entity then
        destroyEntityStageInfo(game.get_player(e.player_index))
    end
end)
Migrations.fromAny(function()
    for ____, player in pairs(game.players) do
        local opened = player.opened
        if opened and opened.object_name == "LuaEntity" then
            tryRenderExtraStageInfo(player, opened)
        end
    end
end)
entityTypeToGuiType = {
    accumulator = relative_gui_type.accumulator_gui,
    ["ammo-turret"] = relative_gui_type.container_gui,
    ["arithmetic-combinator"] = relative_gui_type.arithmetic_combinator_gui,
    ["artillery-wagon"] = relative_gui_type.container_gui,
    ["cargo-wagon"] = relative_gui_type.container_gui,
    ["curved-rail"] = relative_gui_type.additional_entity_info_gui,
    ["electric-energy-interface"] = relative_gui_type.electric_energy_interface_gui,
    ["electric-turret"] = relative_gui_type.additional_entity_info_gui,
    ["fluid-turret"] = relative_gui_type.additional_entity_info_gui,
    ["infinity-container"] = relative_gui_type.container_gui,
    ["infinity-pipe"] = relative_gui_type.infinity_pipe_gui,
    ["land-mine"] = relative_gui_type.additional_entity_info_gui,
    ["linked-container"] = relative_gui_type.linked_container_gui,
    ["loader-1x1"] = relative_gui_type.loader_gui,
    ["offshore-pump"] = relative_gui_type.generic_on_off_entity_gui,
    ["pipe-to-ground"] = relative_gui_type.pipe_gui,
    ["player-port"] = relative_gui_type.additional_entity_info_gui,
    ["power-switch"] = relative_gui_type.power_switch_gui,
    ["programmable-speaker"] = relative_gui_type.programmable_speaker_gui,
    ["rail-chain-signal"] = relative_gui_type.rail_chain_signal_gui,
    ["rail-signal"] = relative_gui_type.rail_signal_gui,
    ["rocket-silo"] = relative_gui_type.rocket_silo_gui,
    ["simple-entity-with-force"] = relative_gui_type.additional_entity_info_gui,
    ["rail-remnants"] = relative_gui_type.additional_entity_info_gui,
    ["simple-entity-with-owner"] = relative_gui_type.additional_entity_info_gui,
    ["solar-panel"] = relative_gui_type.additional_entity_info_gui,
    ["train-stop"] = relative_gui_type.train_stop_gui,
    ["transport-belt"] = relative_gui_type.transport_belt_gui,
    ["underground-belt"] = relative_gui_type.additional_entity_info_gui,
    boiler = relative_gui_type.entity_with_energy_source_gui,
    container = relative_gui_type.container_gui,
    furnace = relative_gui_type.furnace_gui,
    gate = relative_gui_type.additional_entity_info_gui,
    generator = relative_gui_type.additional_entity_info_gui,
    inserter = relative_gui_type.inserter_gui,
    pipe = relative_gui_type.pipe_gui,
    radar = relative_gui_type.entity_with_energy_source_gui,
    splitter = relative_gui_type.splitter_gui,
    ["artillery-turret"] = relative_gui_type.container_gui,
    ["assembling-machine"] = {relative_gui_type.assembling_machine_gui, relative_gui_type.assembling_machine_select_recipe_gui},
    ["burner-generator"] = relative_gui_type.entity_with_energy_source_gui,
    ["constant-combinator"] = relative_gui_type.constant_combinator_gui,
    ["decider-combinator"] = relative_gui_type.decider_combinator_gui,
    ["electric-pole"] = relative_gui_type.electric_network_gui,
    ["fluid-wagon"] = relative_gui_type.additional_entity_info_gui,
    ["heat-interface"] = relative_gui_type.heat_interface_gui,
    ["heat-pipe"] = relative_gui_type.additional_entity_info_gui,
    ["linked-belt"] = relative_gui_type.additional_entity_info_gui,
    ["logistic-container"] = relative_gui_type.container_gui,
    ["mining-drill"] = relative_gui_type.mining_drill_gui,
    ["storage-tank"] = relative_gui_type.storage_tank_gui,
    ["straight-rail"] = relative_gui_type.additional_entity_info_gui,
    beacon = relative_gui_type.beacon_gui,
    lab = relative_gui_type.lab_gui,
    lamp = relative_gui_type.lamp_gui,
    loader = relative_gui_type.loader_gui,
    locomotive = relative_gui_type.train_gui,
    pump = relative_gui_type.entity_with_energy_source_gui,
    reactor = relative_gui_type.reactor_gui,
    roboport = relative_gui_type.roboport_gui,
    turret = relative_gui_type.additional_entity_info_gui,
    wall = relative_gui_type.wall_gui
}
return ____exports
