--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local ____lib = require("lib.index")
local assertNever = ____lib.assertNever
local Events = ____lib.Events
local globalEvent = ____lib.globalEvent
local onPlayerInit = ____lib.onPlayerInit
local property = ____lib.property
local ____geometry = require("lib.geometry.index")
local Pos = ____geometry.Pos
local ____migration = require("lib.migration")
local Migrations = ____migration.Migrations
local ____player_2Dproject_2Ddata = require("project.player-project-data")
local getProjectPlayerData = ____player_2Dproject_2Ddata.getProjectPlayerData
local ____stage_2Dsurface = require("project.stage-surface")
local getStageAtSurface = ____stage_2Dsurface.getStageAtSurface
local ____UserProject = require("project.UserProject")
local ProjectEvents = ____UserProject.ProjectEvents
function ____exports.recordPlayerLastPosition(player)
    local currentStage = getStageAtSurface(player.surface_index)
    if currentStage then
        local playerData = getProjectPlayerData(player.index, currentStage.project)
        if not playerData then
            return
        end
        playerData.lastStage = currentStage.stageNumber
        playerData.lastPosition = player.position
    else
        local data = global.players[player.index]
        if data ~= nil then
            data.lastNonProjectLocation = {surface = player.surface, position = player.position}
        end
    end
end
function ____exports.playerCurrentStage(index)
    return global.players[index].currentStage
end
local PlayerChangedStageEvent = globalEvent()
____exports.PlayerChangedStageEvent = PlayerChangedStageEvent
local function updatePlayer(player)
    local data = global.players[player.index]
    if data == nil then
        return
    end
    local curStage = data.currentStage
    local newStage = getStageAtSurface(player.surface_index)
    local oldStage = curStage:get()
    if newStage == oldStage then
        return
    end
    curStage:set(newStage)
    PlayerChangedStageEvent:raise(player, newStage, oldStage)
end
onPlayerInit(function(index)
    global.players[index].currentStage = property(nil)
end)
Events.on_player_changed_surface(function(e) return updatePlayer(game.get_player(e.player_index)) end)
ProjectEvents:addListener(function(e)
    repeat
        local ____switch9 = e.type
        local ____cond9 = ____switch9 == "project-deleted" or ____switch9 == "stage-deleted"
        if ____cond9 then
            for ____, player in pairs(game.players) do
                updatePlayer(player)
            end
            break
        end
        ____cond9 = ____cond9 or (____switch9 == "project-created" or ____switch9 == "pre-stage-deleted" or ____switch9 == "stage-added" or ____switch9 == "projects-reordered")
        if ____cond9 then
            return
        end
        do
            assertNever(e)
        end
    until true
end)
function ____exports.teleportToStage(player, stage)
    local currentStage = getStageAtSurface(player.surface_index)
    if currentStage and currentStage.project == stage.project then
        if currentStage ~= stage then
            player.teleport(player.position, stage.surface)
        end
        return
    end
    ____exports.recordPlayerLastPosition(player)
    local ____opt_0 = getProjectPlayerData(player.index, stage.project)
    local newPosition = ____opt_0 and ____opt_0.lastPosition or ({x = 0, y = 0})
    player.teleport(newPosition, stage.surface)
end
function ____exports.teleportToProject(player, project)
    local currentStage = getStageAtSurface(player.surface_index)
    if currentStage and currentStage.project == project then
        return
    end
    ____exports.recordPlayerLastPosition(player)
    local playerData = getProjectPlayerData(player.index, project)
    if not playerData then
        return
    end
    if playerData.lastStage and playerData.lastStage <= project:numStages() then
        local stage = project:getStage(playerData.lastStage)
        player.teleport(playerData.lastPosition or ({x = 0, y = 0}), stage.surface)
    else
        local stage = project:getStage(1)
        player.teleport(
            Pos(0, 0),
            stage.surface
        )
    end
end
function ____exports.exitProject(player)
    local data = global.players[player.index]
    local ____opt_2 = data and data.lastNonProjectLocation
    if ____opt_2 and ____opt_2.surface.valid then
        player.teleport(data.lastNonProjectLocation.position, data.lastNonProjectLocation.surface)
    else
        player.teleport({0, 0}, 1)
    end
end
Migrations.early(
    "0.23.0",
    function()
        for ____, player in pairs(game.players) do
            do
                local playerData = global.players[player.index]
                if not playerData then
                    goto __continue28
                end
                playerData.lastNonProjectLocation = playerData.lastNonAssemblyLocation
                playerData.lastNonAssemblyLocation = nil
            end
            ::__continue28::
        end
    end
)
return ____exports
