local ____lualib = require("lualib_bundle")
local __TS__ArrayIndexOf = ____lualib.__TS__ArrayIndexOf
local ____exports = {}
local ____lib = require("lib.index")
local ProtectedEvents = ____lib.ProtectedEvents
local ____UserProject = require("project.UserProject")
local getAllProjects = ____UserProject.getAllProjects
local ____entity_2Dutil = require("ui.entity-util")
local getProjectEntityOfEntity = ____entity_2Dutil.getProjectEntityOfEntity
local ____player_2Dcurrent_2Dstage = require("ui.player-current-stage")
local playerCurrentStage = ____player_2Dcurrent_2Dstage.playerCurrentStage
local teleportToProject = ____player_2Dcurrent_2Dstage.teleportToProject
local teleportToStage = ____player_2Dcurrent_2Dstage.teleportToStage
local Events = ProtectedEvents
local function playErrorSound(player)
    player.play_sound({path = "utility/cannot_build"})
end
local function notifyError(player, message, playSound)
    if playSound then
        playErrorSound(player)
    end
    player.create_local_flying_text({text = message, create_at_cursor = true})
end
local function goToStageRelative(event, diff, ErrorLocale)
    local player = game.get_player(event.player_index)
    local stage = playerCurrentStage(event.player_index):get()
    if not stage then
        return
    end
    local nextStageNum = stage.stageNumber + diff
    local toStage = stage.project:getStage(nextStageNum)
    if not toStage then
        return notifyError(player, {ErrorLocale}, false)
    end
    teleportToStage(player, toStage)
end
Events.on(
    "bp100:next-stage",
    function(e)
        goToStageRelative(e, 1, "bp100.interaction.no-next-stage")
    end
)
Events.on(
    "bp100:previous-stage",
    function(e)
        goToStageRelative(e, -1, "bp100.interaction.no-previous-stage")
    end
)
Events.on(
    "bp100:go-to-first-stage",
    function(e)
        local player = game.get_player(e.player_index)
        local entity = player.selected
        if not entity then
            return
        end
        local stage, projectEntity = getProjectEntityOfEntity(entity)
        if not projectEntity then
            return
        end
        local firstStageNum = projectEntity.firstStage
        local currentStage = stage.stageNumber
        if firstStageNum == currentStage then
            return notifyError(player, {"bp100.interaction.already-at-first-stage"}, true)
        end
        local firstStage = stage.project:getStage(firstStageNum)
        assert(firstStage, "First stage not found")
        teleportToStage(player, firstStage)
    end
)
local function goToBuildRelative(event, diff, ErrorLocale)
    local projects = getAllProjects()
    if #projects == 0 then
        return
    end
    local targetIndex
    local ____opt_0 = playerCurrentStage(event.player_index):get()
    local currentProject = ____opt_0 and ____opt_0.project
    if not currentProject then
        targetIndex = 0
    else
        local curIndex = __TS__ArrayIndexOf(projects, currentProject)
        if curIndex == -1 then
            targetIndex = 0
        else
            targetIndex = curIndex + diff
        end
    end
    if targetIndex < 0 or targetIndex >= #projects then
        return notifyError(
            game.get_player(event.player_index),
            {ErrorLocale},
            false
        )
    end
    local nextProject = projects[targetIndex + 1]
    teleportToProject(
        game.get_player(event.player_index),
        nextProject
    )
end
Events.on(
    "bp100:next-project",
    function(e)
        goToBuildRelative(e, 1, "bp100.interaction.no-next-project")
    end
)
Events.on(
    "bp100:previous-project",
    function(e)
        goToBuildRelative(e, -1, "bp100.interaction.no-previous-project")
    end
)
return ____exports
