--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
local ____exports = {}
local getCursorIfHoldingStageMoveTool
local ____lib = require("lib.index")
local ProtectedEvents = ____lib.ProtectedEvents
local ____player_2Dproject_2Ddata = require("project.player-project-data")
local getProjectPlayerData = ____player_2Dproject_2Ddata.getProjectPlayerData
local ____stage_2Dsurface = require("project.stage-surface")
local getStageAtSurface = ____stage_2Dsurface.getStageAtSurface
local ____player_2Dcurrent_2Dstage = require("ui.player-current-stage")
local PlayerChangedStageEvent = ____player_2Dcurrent_2Dstage.PlayerChangedStageEvent
local playerCurrentStage = ____player_2Dcurrent_2Dstage.playerCurrentStage
function getCursorIfHoldingStageMoveTool(player)
    local cursor = player.cursor_stack
    if not cursor or not cursor.valid_for_read or cursor.name ~= "bp100:stage-move-tool" and cursor.name ~= "bp100:filtered-stage-move-tool" then
        return
    end
    return cursor
end
local Events = ProtectedEvents
local function updateItemLabel(cursor, stage)
    cursor.label = "Send to " .. stage.name:get()
end
function ____exports.updateMoveToolInCursor(player)
    local cursor = getCursorIfHoldingStageMoveTool(player)
    if not cursor then
        return
    end
    cursor.allow_manual_label_change = false
    local stage = getStageAtSurface(player.surface_index)
    if not stage then
        if cursor.name == "bp100:filtered-stage-move-tool" then
            cursor.label = "<Not in a staged BP project>"
        else
            player.create_local_flying_text({text = {"bp100.interaction.not-in-an-project"}, create_at_cursor = true})
            cursor.clear()
        end
        return
    end
    local project = stage.project
    local projectPlayerData = getProjectPlayerData(player.index, project)
    if not projectPlayerData then
        return
    end
    local selectedStage = projectPlayerData.moveTargetStage
    if not selectedStage or selectedStage < 1 or selectedStage > project:numStages() then
        selectedStage = stage.stageNumber
    end
    projectPlayerData.moveTargetStage = selectedStage
    updateItemLabel(
        cursor,
        project:getStage(selectedStage)
    )
    return player
end
Events.on_player_cursor_stack_changed(function(e)
    local player = ____exports.updateMoveToolInCursor(game.get_player(e.player_index))
    if player and player.cursor_stack.name == "bp100:filtered-stage-move-tool" then
        player.print({"bp100.interaction.filtered-stage-move-tool-warning"})
    end
end)
PlayerChangedStageEvent:addListener(function(player)
    ____exports.updateMoveToolInCursor(player)
end)
local function getStageAndData(player)
    local cursor = getCursorIfHoldingStageMoveTool(player)
    if not cursor then
        return
    end
    local stage = playerCurrentStage(player.index):get()
    if not stage then
        return
    end
    local project = stage.project
    local projectPlayerData = getProjectPlayerData(player.index, project)
    if not projectPlayerData then
        return
    end
    return cursor, stage, projectPlayerData
end
local function changeSelectedStage(player, delta)
    local cursor, stage, projectPlayerData = getStageAndData(player)
    if not cursor then
        return
    end
    local selectedStage = projectPlayerData.moveTargetStage or stage.stageNumber
    selectedStage = selectedStage + delta
    if selectedStage < 1 then
        selectedStage = 1
    end
    local maxStage = stage.project:numStages()
    if selectedStage > maxStage then
        selectedStage = maxStage
    end
    projectPlayerData.moveTargetStage = selectedStage
    updateItemLabel(
        cursor,
        stage.project:getStage(selectedStage)
    )
end
Events.on(
    "bp100:stage-select-next",
    function(e)
        changeSelectedStage(
            game.get_player(e.player_index),
            1
        )
    end
)
Events.on(
    "bp100:stage-select-previous",
    function(e)
        changeSelectedStage(
            game.get_player(e.player_index),
            -1
        )
    end
)
return ____exports
