local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__DecorateLegacy = ____lualib.__TS__DecorateLegacy
local __TS__InstanceOf = ____lualib.__TS__InstanceOf
local ____exports = {}
local ____constants = require("constants")
local Colors = ____constants.Colors
local ____lib = require("lib.index")
local bind = ____lib.bind
local funcRef = ____lib.funcRef
local Property = ____lib.Property
local RegisterClass = ____lib.RegisterClass
local registerFunctions = ____lib.registerFunctions
local ____diff_2Dvalue = require("utils.diff-value")
local getDiff = ____diff_2Dvalue.getDiff
local getResultValue = ____diff_2Dvalue.getResultValue
____exports.DiffedProperty = __TS__Class()
local DiffedProperty = ____exports.DiffedProperty
DiffedProperty.name = "DiffedProperty"
__TS__ClassExtends(DiffedProperty, Property)
function DiffedProperty.prototype.____constructor(self, overrideValue, defaultValue)
    Property.prototype.____constructor(self)
    self.overrideValue = overrideValue
    self.defaultValue = defaultValue
    self.resultValue = overrideValue:flatMap(bind(getResultValue, defaultValue))
end
function DiffedProperty.prototype._subscribeIndependently(self, observer)
    return self.resultValue:_subscribeIndependently(observer)
end
function DiffedProperty.prototype.get(self)
    return self.resultValue:get()
end
function DiffedProperty.prototype.set(self, value)
    self.overrideValue:set(getDiff(
        self.defaultValue:get(),
        value
    ))
end
function DiffedProperty.prototype.forceNotify(self)
    self.resultValue:forceNotify()
end
function DiffedProperty.prototype.closeAll(self)
    self.resultValue:closeAll()
end
DiffedProperty = __TS__DecorateLegacy(
    {RegisterClass("DiffedProperty")},
    DiffedProperty
)
____exports.DiffedProperty = DiffedProperty
local function coloredIfNotNil(value)
    return value ~= nil and Colors.OverrideHighlight or ({1, 1, 1})
end
local function boldIfNotNil(value)
    return value ~= nil and "default-bold" or "default"
end
registerFunctions("prop-possibly-overriden", {coloredIfNotNil = coloredIfNotNil, boldIfNotNil = boldIfNotNil})
function ____exports.highlightIfNotNil(prop)
    return {
        font_color = prop:map(funcRef(coloredIfNotNil)),
        font = prop:map(funcRef(boldIfNotNil))
    }
end
function ____exports.highlightIfOverriden(prop)
    if not __TS__InstanceOf(prop, ____exports.DiffedProperty) then
        return {}
    end
    return ____exports.highlightIfNotNil(prop.overrideValue)
end
function ____exports.getDefaultValueIfIsOverridenProp(prop)
    if __TS__InstanceOf(prop, ____exports.DiffedProperty) then
        return prop.defaultValue:get()
    end
end
return ____exports
